SystemOrganization addCategory: #'OB-Enhancements-PackageBrower'!
SystemOrganization addCategory: #'OB-Enhancements-SmartGroup'!
SystemOrganization addCategory: #'OB-Enhancements-MultipleSelection'!
SystemOrganization addCategory: #'OB-Enhancements-Commands'!
SystemOrganization addCategory: #'OB-Enhancements-Morphs'!
SystemOrganization addCategory: #'OB-Enhancements-ToolBar'!
SystemOrganization addCategory: #'OB-Enhancements-Panels'!
SystemOrganization addCategory: #'OB-Enhancements-Tests'!
SystemOrganization addCategory: #'OB-Enhancements-Dynamic'!
SystemOrganization addCategory: #'OB-Enhancements-Various'!

OBCmdRenameCat subclass: #OBCmdRenameSmartCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdRenameSmartCategory methodsFor: 'command' stamp: 'dr 4/16/2007 10:27'!
execute
	| category |
	category := OBTextRequest
				prompt: 'Please type new category name' 
				template: target name.
	category ifNotNil:	
		[target name: category.
		 requestor panel columns first refresh.]! !

!OBCmdRenameSmartCategory methodsFor: 'command' stamp: 'dr 4/16/2007 10:27'!
group
	^ #general! !

!OBCmdRenameSmartCategory methodsFor: 'command' stamp: 'dr 3/12/2008 15:20'!
isActive 
	^target isSmartGroupCategory and: [target isSearchGroup not]! !

!OBCmdRenameSmartCategory methodsFor: 'command' stamp: 'dr 3/1/2008 17:07'!
label
	^ 'rename smart group...'! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 3/4/2008 14:57'!
alias
   ^self! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 2/21/2008 15:35'!
currentParent
    ^nil! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:03'!
displayFullString
    ^self displayString! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 4/10/2008 15:06'!
getDefinition
    ^self definition! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 4/11/2008 11:22'!
isClassCategory
    ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 2/28/2008 14:14'!
isClassNode
   ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 10/16/2007 14:55'!
isInstrumented
    ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 11/12/2007 10:45'!
isMethodCategory
    ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 5/29/2007 10:17'!
isMethodHolderNode
    ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 11/2/2006 11:21'!
isMethodNode
	^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 13:40'!
isNodeWithReferences
    ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 3/1/2008 18:08'!
isPackage
	^ false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 3/4/2008 16:22'!
isSearch
    ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 2/29/2008 15:36'!
isSmartAlias
    ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 4/10/2007 11:22'!
isSmartGroup
    ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 4/16/2007 11:32'!
isSmartGroupCategory
    ^false! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 11:57'!
referencingClasses
    ^#()! !

!OBCodeNode methodsFor: '*ob-enhancements' stamp: 'dr 2/21/2008 15:35'!
setCurrentParent: aNode! !

OBCodeNode subclass: #OBMonticelloPackageNode
	instanceVariableNames: 'mcPackage theClass extensionClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBMonticelloPackageNode commentStamp: 'dr 7/16/2007 10:36' prior: 0!
I represent a Monticello package as a node in an OB system browser. My children are class, comment and metaclass nodes. Classes extended in the package I represent are also contained as nodes in my children.!

!OBMonticelloPackageNode class methodsFor: 'instance creation' stamp: 'dr 7/17/2007 10:18'!
on: aWorkingCopy
    ^self new mcPackage: aWorkingCopy! !

!OBMonticelloPackageNode class methodsFor: 'instance creation' stamp: 'dr 7/16/2007 11:15'!
package: aPackage class: aClass
	^self new mcPackage: aPackage; theClass: aClass! !

!OBMonticelloPackageNode methodsFor: 'comparing' stamp: 'dr 7/16/2007 10:33'!
= other 
	^ (other isKindOf: OBMonticelloPackageNode) 
		ifTrue: [self mcPackage = other mcPackage]
		ifFalse: [super = other]! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'rw 7/4/2006 23:41'!
askForRepository

	| reps index |
	reps := self repositories.
	index := (PopUpMenu labelArray: (reps collect: [:rep | rep description]))
				startUpWithCaption: 'Repository:'.
	^(index = 0) ifTrue: [nil] ifFalse: [reps at: index]! !

!OBMonticelloPackageNode methodsFor: 'actions' stamp: 'dr 2/15/2008 16:51'!
browse
	OBCodeBrowser defaultBrowserClass openOnPackage: self mcPackage! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'dr 12/14/2007 11:59'!
checkForNewerVersionsAndAskIn: repository

	| newer |
	newer := mcPackage possiblyNewerVersionsIn: repository.
	^ newer isEmpty or: [
		self confirm: 'CAUTION!! These versions in the repository may be newer:', 
			String cr, newer asString, String cr,
			'Do you really want to save this version?'].! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'dr 12/14/2007 11:59'!
checkForNewerVersionsIn: repository
	| newer |
	newer := mcPackage possiblyNewerVersionsIn: repository.
	^ newer isEmpty not! !

!OBMonticelloPackageNode methodsFor: 'public' stamp: 'dr 11/27/2007 15:05'!
classCategories
    | pkgName pkgNameSize |
    pkgName := self mcPackage packageName, '-'.
    pkgNameSize := pkgName size.
    ^self class environment organization categories select: [:cat | 
	    cat size > pkgNameSize and: [(pkgName = (cat first: pkgNameSize))]].
! !

!OBMonticelloPackageNode methodsFor: 'actions' stamp: 'dr 8/4/2006 20:33'!
classLevelProtocols

	^ theClass class organization categories
		collect: [:cat | (OBMethodCategoryNode on: cat inClass: theClass) browser: self browser]! !

!OBMonticelloPackageNode methodsFor: 'public' stamp: 'dr 3/3/2008 17:20'!
classes
	"Note: differentiate between classes and extension classes so that I can wrap them differently so that I can control how they are shown, e.g. extension classes in italic."

	| classes extensions | 
	classes := (mcPackage packageInfo classes collect: [:each | each asNode]) reject: [:ea | ea isNil].
	extensions := self extensionClasses collect: [:each | (OBClassExtensionNode on: each theNonMetaClass) package: self; yourself]. 
	^(classes asSet addAll: extensions; yourself) asArray! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'rw 7/2/2006 18:42'!
classesForPackage
	"return all classes for the selected package"

	^self classesHierarchically! !

!OBMonticelloPackageNode methodsFor: 'private-actions' stamp: 'rw 7/20/2006 15:26'!
classesHierarchically

	^OBClassAwareNode sortHierarchicallyOptimized: self classes! !

!OBMonticelloPackageNode methodsFor: 'public' stamp: 'dr 5/2/2007 15:17'!
comments
	^self classes collect: [:each | each theClass asCommentNode]! !

!OBMonticelloPackageNode methodsFor: 'public' stamp: 'rw 7/18/2006 17:58'!
commentsHierarchically
	^ OBClassAwareNode sortHierarchicallyOptimized: self comments! !

!OBMonticelloPackageNode methodsFor: 'displaying' stamp: 'dr 2/24/2008 15:48'!
definition 
	^ OBClassDefinition 
		environment: self environment 
		template: ((self environment at: #Class) template: self name)! !

!OBMonticelloPackageNode methodsFor: 'displaying' stamp: 'dr 6/7/2007 16:36'!
dropOnSmartGroup: aNode
	aNode addAlias: self.
	aNode signalChildrenChanged.! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 11/19/2007 10:39'!
environment
    ^self class environment! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 3/3/2008 17:21'!
extensionClasses
    extensionClasses ifNil: [extensionClasses := mcPackage packageInfo extensionClasses].
    ^extensionClasses! !

!OBMonticelloPackageNode methodsFor: 'private-actions' stamp: 'dr 7/16/2007 10:33'!
findClass
	| pattern foundClassOrTrait package |
	pattern := UIManager default request: 'Class name or fragment?'.
	pattern isEmpty ifTrue: [^ self].
	foundClassOrTrait := Utilities classFromPattern: pattern withCaption: ''.
	foundClassOrTrait ifNil: [^ self].
	package := self packageForClassOrTrait: foundClassOrTrait
				ifAbsent: [^ self].
	(OBMonticelloPackageNode package: package class: foundClassOrTrait asNode) 
		signalSelection! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'rw 7/4/2006 23:05'!
hasRepository

	^self repositories notEmpty! !

!OBMonticelloPackageNode methodsFor: 'displaying' stamp: 'dr 2/24/2008 16:16'!
icon
     (Smalltalk classNamed: #HODataBase) ifNil: [^nil].
     OBPackageBrowser dynamicBrowser ifFalse:  [^nil].
    ^((Smalltalk at: #HODataBase) default analyzedClasses anySatisfy: [:class | mcPackage packageInfo classes includes: class]) ifTrue: [#flag] ifFalse: [#blank]! !

!OBMonticelloPackageNode methodsFor: 'displaying' stamp: 'dr 2/24/2008 16:17'!
indentedName
	^mcPackage modified ifTrue: ['* ', self name] ifFalse: ['  ', self name]! !

!OBMonticelloPackageNode methodsFor: 'actions' stamp: 'dr 4/17/2007 15:40'!
instLevelProtocols

	^ theClass organization categories
		collect: [:cat | OBMethodCategoryNode on: cat inClass: theClass]! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 3/1/2008 18:05'!
isCategory
	^ true! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 5/2/2007 15:34'!
isDescendantOf: other
	^other class = self class and: [other mcPackage = self mcPackage]! !

!OBMonticelloPackageNode methodsFor: 'ancestry' stamp: 'dr 3/1/2008 18:29'!
isDescendantOfClass: other
    ^false! !

!OBMonticelloPackageNode methodsFor: 'ancestry' stamp: 'dr 7/16/2007 11:32'!
isDescendantOfClassCat: other
    ^self = other! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 2/24/2008 12:06'!
isDescendantOfPackage: other
	^other class = self class and: [other mcPackage = self mcPackage]! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 10/12/2007 14:38'!
isEnrichedDefinition
   ^false! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 2/7/2008 12:05'!
isInstrumented
   ^self classes allSatisfy: [:ea | ea isInstrumented]! !

!OBMonticelloPackageNode methodsFor: 'testing' stamp: 'dr 3/1/2008 18:07'!
isPackage
	^ true! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'dr 7/16/2007 11:17'!
mcPackage
	^mcPackage! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'rw 6/4/2006 21:17'!
mcPackage: aWorkingCopy

	mcPackage := aWorkingCopy! !

!OBMonticelloPackageNode methodsFor: 'public' stamp: 'dr 3/3/2008 17:21'!
metaclasses
	| metaclasses extensions | 
	metaclasses := mcPackage packageInfo classes collect: [:each | each asClassSideNode].
	extensions := self extensionClasses collect: [:each | (OBMetaclassExtensionNode on: each theNonMetaClass) package: self; yourself]. 
	^(metaclasses asSet addAll: extensions; yourself) asArray! !

!OBMonticelloPackageNode methodsFor: 'public' stamp: 'rw 7/18/2006 17:58'!
metaclassesHierarchically

	^ OBClassAwareNode sortHierarchicallyOptimized: self metaclasses! !

!OBMonticelloPackageNode methodsFor: 'public' stamp: 'dr 12/18/2007 16:41'!
name
	^mcPackage packageName! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 12/18/2007 17:13'!
organization
    ^self environment organization! !

!OBMonticelloPackageNode methodsFor: 'private-actions' stamp: 'rw 7/7/2006 14:35'!
packageForClassOrTrait: classOrTrait ifAbsent: absentblock

	MCWorkingCopy allManagers do: [:wc |
		(wc package packageInfo classes includes: classOrTrait)
			ifTrue: [^wc]
	].
	^absentblock value! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 2/7/2008 12:20'!
realClasses
    ^(self classes reject: [:ea | ea isKindOf: OBClassExtensionNode]) collect: [:ea | ea theClass].! !

!OBMonticelloPackageNode methodsFor: 'private' stamp: 'dr 7/16/2007 11:03'!
repositories
	^mcPackage repositoryGroup repositories! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 15:38'!
text self halt.
	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self name, ''''! !

!OBMonticelloPackageNode methodsFor: 'accessing' stamp: 'rw 6/10/2006 14:03'!
theClass: aClassNode

	theClass := aClassNode theClass! !

OBCodeNode subclass: #OBPackagesOrClassesNode
	instanceVariableNames: 'mcPackage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBPackagesOrClassesNode commentStamp: 'dr 7/16/2007 10:34' prior: 0!
I represent the root of the node tree in an OB system browser. My children are Monticello packages and Monticello class categories.!

!OBPackagesOrClassesNode methodsFor: 'accessing' stamp: 'dr 7/16/2007 15:35'!
environment
    ^Smalltalk! !

!OBPackagesOrClassesNode methodsFor: 'accessing' stamp: 'dr 4/17/2007 15:25'!
indentedName 
	^self name! !

!OBPackagesOrClassesNode methodsFor: 'testing' stamp: 'dr 7/16/2007 15:33'!
isEnvironment
	^ true! !

!OBPackagesOrClassesNode methodsFor: 'private' stamp: 'rw 6/9/2006 01:07'!
mcPackage: aWorkingCopy

	mcPackage := aWorkingCopy! !

!OBPackagesOrClassesNode methodsFor: 'private' stamp: 'dr 7/16/2007 11:13'!
mcRepository
	^MCCacheRepository default! !

!OBPackagesOrClassesNode methodsFor: 'public' stamp: 'dr 7/16/2007 11:13'!
name
	^self mcRepository description! !

!OBPackagesOrClassesNode methodsFor: 'accessing' stamp: 'dr 1/8/2008 11:56'!
packages
	| workingCopies packages remainingCats coveredCats |
	coveredCats := Set new.
	workingCopies := MCWorkingCopy allManagers 
				asSortedCollection: [:a :b | a package name <= b package name].
	packages := OrderedCollection new.
	workingCopies do: 
			[:wc | 
			| packageNode |
			coveredCats add: wc packageName.
			packageNode := OBMonticelloPackageNode new mcPackage: wc.
			packages add: packageNode.
			packageNode classCategories do: 
					[:classCategory | 
					coveredCats add: classCategory.
					packages add: (OBMonticelloClassCategoryNode on: classCategory package: wc)]].
	remainingCats := SystemOrganization categories asSet 
				difference: coveredCats.
	remainingCats ifNotEmpty: 
			[packages add: (OBMonticelloPackageNode new 
						mcPackage: (OBDummyPackage categories: remainingCats)).
			remainingCats asSortedCollection 
				do: [:classCategory | packages add: (OBMonticelloClassCategoryNode on: classCategory)]].
	^ packages! !

!OBPackagesOrClassesNode methodsFor: 'accessing' stamp: 'dr 3/1/2008 16:19'!
smartGroups
    ^(OBSmartRootNode default root: self; yourself) allNodes! !

!OBPackagesOrClassesNode methodsFor: 'accessing' stamp: 'dr 7/16/2007 11:13'!
text
	^'Euh - something regarding an MCCachedRepository ?!!'! !

OBCodeNode subclass: #OBSmartAliasNode
	instanceVariableNames: 'node parentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartAliasNode class methodsFor: 'as yet unclassified' stamp: 'dr 3/13/2007 18:10'!
node: aNode
    ^self new node: aNode! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/4/2008 14:57'!
alias
	^self node! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 2/29/2008 15:12'!
allNodes
    ^(self packages detect: [:ea | ea isAncestorOf: self node] ifNone: [^OrderedCollection new]) classes! !

!OBSmartAliasNode methodsFor: 'actions' stamp: 'dr 4/10/2007 10:53'!
browse
    self node browse! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 4/3/2007 11:18'!
categories
	^ Smalltalk organization categories collect: [:cat | OBClassCategoryNode 
															on: cat
															inEnvironment: Smalltalk]! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/11/2008 10:52'!
classes
    ^self navigateTo: #classes! !

!OBSmartAliasNode methodsFor: 'commands' stamp: 'dr 3/12/2008 15:32'!
cmdBrowse
	^OBCmdSmartGroupBrowse! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/11/2008 10:52'!
comments
    ^self navigateTo: #comments! !

!OBSmartAliasNode methodsFor: 'displaying' stamp: 'dr 3/3/2008 11:28'!
displayFullString
	^'Smart Node: ', self name! !

!OBSmartAliasNode methodsFor: 'displaying' stamp: 'dr 2/27/2008 16:31'!
indent
	| indent |
	indent _ Text new: 4.
	indent atAllPut: $ .
	^ indent asString! !

!OBSmartAliasNode methodsFor: 'displaying' stamp: 'dr 2/28/2008 11:51'!
indentedName
	^ self indent, self name! !

!OBSmartAliasNode methodsFor: 'ancestry' stamp: 'dr 3/3/2008 11:34'!
isAncestorOf: aNode using: aSelector
    ^aNode = self node or: [aNode = self]! !

!OBSmartAliasNode methodsFor: 'testing' stamp: 'dr 3/12/2008 15:37'!
isBrowseable
    ^self alias isSearch not! !

!OBSmartAliasNode methodsFor: 'ancestry' stamp: 'dr 3/1/2008 16:52'!
isDescendantOf: aNode
    ^aNode = self node! !

!OBSmartAliasNode methodsFor: 'ancestry' stamp: 'dr 4/10/2007 11:32'!
isDescendantOfClassCat: aClassCategoryNode
    ^false! !

!OBSmartAliasNode methodsFor: 'testing' stamp: 'dr 4/11/2008 11:22'!
isSearchOrPackageAlias
    ^self alias isSearch or: [self alias isPackage or: [self alias isClassCategory]]! !

!OBSmartAliasNode methodsFor: 'testing' stamp: 'dr 2/29/2008 15:36'!
isSmartAlias
    ^true! !

!OBSmartAliasNode methodsFor: 'testing' stamp: 'dr 4/10/2007 11:21'!
isSmartGroup
    ^true! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/11/2008 11:26'!
jumpIn: aColumnPanel
    aColumnPanel jumpTo: (self isSearchOrPackageAlias ifTrue: [self] ifFalse: [self alias]).
    (self alias isSearch and: [self alias classes notEmpty]) ifTrue: [aColumnPanel columns second selection: 1].! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/11/2008 10:52'!
metaclasses
    ^self navigateTo: #metaclasses! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:11'!
name
    ^self node name! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 4/11/2008 11:21'!
navigateTo: aSymbol
    self isSearchOrPackageAlias ifTrue: [^self alias perform: aSymbol].
    ^self packageForNode ifNotNilDo: [:pkg | pkg perform: aSymbol] ifNil: [^OrderedCollection new]! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:08'!
node
	^node! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:08'!
node: aNode
	node := aNode! !

!OBSmartAliasNode methodsFor: 'private' stamp: 'dr 3/1/2008 16:29'!
packageForNode
    ^self packages detect: [:ea | ea isAncestorOf: self node] ifNone: [nil].! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 3/1/2008 16:20'!
packages
    ^self parentNode parentNode root packages! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 15:59'!
parentNode
	^parentNode! !

!OBSmartAliasNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 15:59'!
parentNode: aNode
	parentNode := aNode! !

!OBSmartAliasNode methodsFor: 'printing' stamp: 'dr 4/5/2007 14:37'!
printOn: aStream
    super printOn: aStream.
    aStream nextPutAll: ' ('.
    self node printOn: aStream. 
    aStream nextPut: $).! !

!OBSmartAliasNode methodsFor: 'adding/removing' stamp: 'dr 4/16/2007 16:00'!
remove
    ^self parentNode nodes remove: self.! !

OBCodeNode subclass: #OBSmartGroupNode
	instanceVariableNames: 'name nodes parentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartGroupNode class methodsFor: 'as yet unclassified' stamp: 'dr 4/5/2007 17:04'!
name: aString
    ^self new name: aString! !

!OBSmartGroupNode methodsFor: 'adding/removing' stamp: 'dr 3/5/2008 14:40'!
addAlias: aNode
    | alias |
    alias := (OBSmartAliasNode node: aNode).
    (self nodes includes: alias) ifTrue: [^alias]. 
    ^self addNode: alias.! !

!OBSmartGroupNode methodsFor: 'adding/removing' stamp: 'dr 4/16/2007 15:58'!
addNode: aNode
    aNode parentNode: self.
    ^self nodes add: aNode! !

!OBSmartGroupNode methodsFor: 'drag and drop' stamp: 'dr 6/7/2007 16:19'!
dropSelector
    ^#dropOnSmartGroup:! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/10/2007 10:58'!
indentedName
    ^self name! !

!OBSmartGroupNode methodsFor: 'testing' stamp: 'dr 3/12/2008 15:32'!
isBrowseable
    ^false! !

!OBSmartGroupNode methodsFor: 'ancestry' stamp: 'dr 4/10/2007 11:33'!
isDescendantOfClassCat: aClassCategoryNode
    ^false! !

!OBSmartGroupNode methodsFor: 'testing' stamp: 'dr 3/12/2008 15:20'!
isSearchGroup
    ^self name = OBSmartRootNode searchGroupName! !

!OBSmartGroupNode methodsFor: 'testing' stamp: 'dr 4/10/2007 11:21'!
isSmartGroup
    ^true! !

!OBSmartGroupNode methodsFor: 'testing' stamp: 'dr 4/16/2007 11:32'!
isSmartGroupCategory
    ^true! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 9/10/2007 16:54'!
name
	^name! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 3/13/2008 17:01'!
name: aString
	name = OBSmartRootNode searchGroupName ifFalse: [name := aString]! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 10:48'!
nodes
    nodes ifNil: [nodes := OrderedCollection new].
    ^nodes! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 15:58'!
parentNode
	^parentNode! !

!OBSmartGroupNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 15:59'!
parentNode: aNode
	parentNode := aNode! !

!OBSmartGroupNode methodsFor: 'adding/removing' stamp: 'dr 4/16/2007 16:01'!
remove
    ^self parentNode nodes remove: self.! !

OBCodeNode subclass: #OBSmartRootNode
	instanceVariableNames: 'nodes root'
	classVariableNames: 'Instances'
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartRootNode class methodsFor: 'initialization' stamp: 'dr 4/16/2007 16:29'!
default 
    Instances ifEmpty: [Instances add: self new].
    ^Instances last! !

!OBSmartRootNode class methodsFor: 'initialization' stamp: 'dr 4/16/2007 16:30'!
initialize
    "self initialize"
    Instances ifNil: [Instances := OrderedCollection new].! !

!OBSmartRootNode class methodsFor: 'configuration' stamp: 'dr 3/5/2008 15:07'!
searchGroupName
    ^'searches'! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 4/12/2007 17:12'!
addAlias: aNode
    ^self addNode: (OBSmartAliasNode node: aNode).! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 16:23'!
addNode: aNode
    aNode parentNode: self.
    ^self nodes add: aNode! !

!OBSmartRootNode methodsFor: 'searching' stamp: 'dr 3/5/2008 15:10'!
addSearchNode: aSearchNode
    ^self searchGroup addAlias: aSearchNode.! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 4/16/2007 16:02'!
allNodes
    ^self nodes inject: OrderedCollection new into: [:coll :ea | coll add: ea. coll addAll: ea nodes. coll].
! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 3/13/2007 18:05'!
isDescendantOf: aNode
    ^false! !

!OBSmartRootNode methodsFor: 'navigating' stamp: 'dr 7/19/2007 15:37'!
name
    ^'smart root node'! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 3/5/2008 14:34'!
nodes
    | rootNode searchNode | 
    nodes ifNil: [
        rootNode := OBSmartGroupNode name: 'default'.
        rootNode addAlias: (OBClassNode on: Behavior).
        rootNode addAlias: (OBClassNode on: OBColumn).
        rootNode addAlias: (OBClassNode on: String).
        rootNode addAlias: (OBMethodNode on: #subclasses inClass: Class).  
	 
        nodes := OrderedCollection new.
        self addNode: rootNode.
        searchNode := OBSmartGroupNode name: 'searches'.
        self addNode: searchNode.
    ].
    ^nodes
! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 3/1/2008 16:20'!
root
	^root! !

!OBSmartRootNode methodsFor: 'accessing' stamp: 'dr 3/1/2008 16:20'!
root: aNode
	root := aNode! !

!OBSmartRootNode methodsFor: 'searching' stamp: 'dr 3/5/2008 15:09'!
searchGroup
    ^self nodes detect: [:node | node isSmartGroupCategory and: [node name = self class searchGroupName]] 
                  ifNone: [self addNode: (OBSmartGroupNode name: self class searchGroupName)].! !

!Trait methodsFor: '*ob-enhancements' stamp: 'dr 2/24/2008 15:50'!
asNode
   ^OBClassNode on: self! !

!OBBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 17:03'!
hasReferencePanel
    ^false! !

!OBBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/25/2008 15:20'!
isHierarchyBrowser
    ^false! !

!OBBrowser methodsFor: '*ob-enhancements' stamp: 'dr 5/24/2007 12:21'!
definitionPanel
	^ panels 
		detect: [:ea | ea isDefinition] 
		ifNone: [self error: 'No definition panel configured']! !

TestCase subclass: #OBEnhHierarchyBrowserTest
	instanceVariableNames: 'hierarchyBrowser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tests'!

!OBEnhHierarchyBrowserTest methodsFor: 'setup' stamp: 'dr 3/6/2008 16:34'!
setUp
    hierarchyBrowser := OBHierarchyBrowser onClass: self class selector: #setUp.
! !

!OBEnhHierarchyBrowserTest methodsFor: 'tests' stamp: 'dr 3/7/2008 16:20'!
testAutoSelection
    | classColumn columns |
    columns := hierarchyBrowser navigationPanel columns.
    classColumn := columns first.
    self assert: classColumn selection = 4. 
    self assert: classColumn selectedNode theClass = self class.
    self assert: columns last selectedNode selector = #setUp.
    self assert: columns last children size < 10.
    self assert: hierarchyBrowser definitionPanel text = (self class >> #setUp) getSource.
    self assert: hierarchyBrowser currentNode = columns last selectedNode.

    classColumn selection: 3.
    self assert: classColumn selection = 3. 
    self assert: classColumn selectedNode theClass = TestCase.
    self assert: columns last selectedNode theClass = TestCase.
    self assert: columns last selectedNode selector = #setUp.
    self assert: columns last children size > 20.
    self assert: hierarchyBrowser definitionPanel text asString withBlanksTrimmed = 'setUp'. 
    self assert: hierarchyBrowser currentNode = columns last selectedNode.

    classColumn selection: 4.
    self assert: classColumn selection = 4. 
    self assert: classColumn selectedNode theClass = self class.
    self assert: columns last selectedNode theClass = self class.
    self assert: columns last selectedNode selector = #setUp.
    self assert: columns last children size < 10.
    self assert: hierarchyBrowser definitionPanel text = (self class >> #setUp) getSource.
    self assert: hierarchyBrowser currentNode = columns last selectedNode.

    classColumn selection: 2.
    self assert: classColumn selection = 2. 
    self assert: classColumn selectedNode theClass = Object.
    self assert: columns last selectedNode isNil.
    self assert: (hierarchyBrowser definitionPanel getDefinition isKindOf: OBClassDefinition).
    self assert: hierarchyBrowser definitionPanel text = Object definition.
    self assert: hierarchyBrowser currentNode = classColumn selectedNode.
! !

!OBEnhHierarchyBrowserTest methodsFor: 'tests' stamp: 'dr 3/12/2008 16:09'!
testBrowserSetup
    | classNodes |
    self assert: OBHierarchyBrowser isHierarchyBrowser.
    self assert: (OBHierarchyBrowser definitionPanel isKindOf: OBEnhancementDefinitionPanel).
    self assert: (OBHierarchyBrowser navigationPanel isKindOf: OBEnhancementColumnPanel).

    self assert: (hierarchyBrowser root isKindOf: OBClassNode).
    self assert: hierarchyBrowser root theClass = self class.

    self assert: (hierarchyBrowser currentNode isKindOf: OBMethodNode).
    self assert: hierarchyBrowser currentNode theClass = self class.
    self assert: hierarchyBrowser currentNode selector = #setUp.

    classNodes := hierarchyBrowser navigationPanel columns first children.
    self assert: classNodes size = 4. 
    self assert: classNodes last theClass = self class.
    self assert: classNodes third theClass = TestCase.! !

!OBEnhHierarchyBrowserTest methodsFor: 'tests' stamp: 'dr 3/10/2008 10:30'!
testDoubleClick
    | classColumn columns |
    columns := hierarchyBrowser navigationPanel columns.
    classColumn := columns first.
    self assert: classColumn selection = 4. 
    self assert: classColumn selectedNode theClass = self class.
    self assert: (((hierarchyBrowser root displayStringForChild: classColumn selectedNode) attributesAt: 1) includes: TextEmphasis bold).
    self deny: (hierarchyBrowser root displayStringForChild: classColumn children third) isText.
    self assert: columns last selectedNode selector = #setUp.

    classColumn selection: 3.
    classColumn doubleClick.
    self assert: classColumn selection = 3. 
    self assert: classColumn selectedNode theClass = TestCase.
    self assert: classColumn children size > 10.
    self assert: (((hierarchyBrowser root displayStringForChild: classColumn selectedNode) attributesAt: 1) includes: TextEmphasis bold).
    self deny: (hierarchyBrowser root displayStringForChild: classColumn children fourth) isText.
    self assert: hierarchyBrowser definitionPanel text = TestCase definition.
    self assert: columns last children size > 20.
! !

!OBEnhHierarchyBrowserTest methodsFor: 'tests' stamp: 'dr 3/13/2008 15:46'!
testMethodSelection
    | hierarchyBrowser2 |
    self assert: (hierarchyBrowser root isKindOf: OBClassNode).
    self assert: (hierarchyBrowser currentNode isKindOf: OBMethodNode).
    self assert: hierarchyBrowser root metaNode ~= hierarchyBrowser currentNode metaNode.
    self assert: hierarchyBrowser root metaNode edges size >= 3.
    self assert: hierarchyBrowser root metaNode edges first selector = #classHierarchy.
    self assert: hierarchyBrowser currentNode metaNode ancestrySelector = #isDescendantOfMethod:.

    hierarchyBrowser2 := OBHierarchyBrowser onClass: self class.
    self assert: (hierarchyBrowser2 root isKindOf: OBClassNode).
    self assert: (hierarchyBrowser2 currentNode isKindOf: OBClassNode).
    self assert: hierarchyBrowser2 root metaNode ~= hierarchyBrowser2 currentNode metaNode.
    self assert: hierarchyBrowser2 root metaNode edges size >= 3.
    self assert: hierarchyBrowser2 root metaNode edges first selector = #classHierarchy.
    self assert: hierarchyBrowser2 currentNode metaNode edges size = 2.
    self assert: hierarchyBrowser2 currentNode metaNode edges first selector = #allCategory.
! !

!OBEnhHierarchyBrowserTest methodsFor: 'tests' stamp: 'dr 3/13/2008 15:29'!
testSelectedClassHighlighting
    | classColumn columns |
    columns := hierarchyBrowser navigationPanel columns.
    classColumn := columns first.
    self assert: (((hierarchyBrowser root displayStringForChild: classColumn selectedNode) attributesAt: 1) includes: TextEmphasis bold).
 
    classColumn switch selection: 2.
    self assert: (((hierarchyBrowser root displayStringForChild: classColumn selectedNode) attributesAt: 1) includes: TextEmphasis bold).
    self assert: columns second children isEmpty.
    self assert: hierarchyBrowser definitionPanel getDefinition text = self class comment.

    classColumn switch selection: 3.
    self assert: (((hierarchyBrowser root displayStringForChild: classColumn selectedNode) attributesAt: 1) includes: TextEmphasis bold).
    self assert: columns second children size = 2.
    self assert: hierarchyBrowser definitionPanel getDefinition text = self class class definition.
! !

TestCase subclass: #OBEnhPackageBrowserTest
	instanceVariableNames: 'packageBrowser dynamicBrowser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tests'!

!OBEnhPackageBrowserTest methodsFor: 'setup' stamp: 'dr 1/28/2008 11:05'!
setUp
    dynamicBrowser := OBPackageBrowser dynamicBrowser.
! !

!OBEnhPackageBrowserTest methodsFor: 'setup' stamp: 'dr 1/28/2008 11:05'!
tearDown
    OBPackageBrowser setDynamicBrowser: dynamicBrowser.
! !

!OBEnhPackageBrowserTest methodsFor: 'tests' stamp: 'dr 3/13/2008 13:20'!
testBackButton
    | classColumn |
    packageBrowser := OBPackageBrowser onClass: OBColumn selector: #list.
    classColumn := packageBrowser navigationPanel columns second.

    self assert: packageBrowser hasHistory.
    self deny: packageBrowser hasBackHistory.
    self deny: packageBrowser hasForwardHistory.
    self assert: packageBrowser historyCursor = 1.
    self assert: packageBrowser historyAtCursor isMethodNode.
    self assert: packageBrowser historyAtCursor theClass = OBColumn.
    self assert: packageBrowser historyAtCursor selector = #list.
    self assert: packageBrowser historyNodes size = 1.
    self assert: packageBrowser historyBackNodes size = 0.

    classColumn selection: 1.
    self assert: packageBrowser currentNode theClass = OBBrowser. 
    self assert: packageBrowser hasBackHistory.
    self deny: packageBrowser hasForwardHistory.
    self assert: packageBrowser historyCursor = 2.
    self deny: packageBrowser historyAtCursor isMethodNode.
    self assert: packageBrowser historyAtCursor theClass = OBBrowser.
    self assert: packageBrowser historyNodes size = 2.
    self assert: packageBrowser historyBackNodes size = 1.
    self assert: packageBrowser definitionPanel getDefinition text = OBBrowser definition.

    packageBrowser optionalButtonPanel back.
    self deny: packageBrowser hasBackHistory.
    self assert: packageBrowser hasForwardHistory.
    self assert: packageBrowser historyCursor = 1.
    self assert: packageBrowser historyAtCursor isMethodNode.
    self assert: packageBrowser historyAtCursor theClass = OBColumn.
    self assert: packageBrowser historyAtCursor selector = #list.
    self assert: packageBrowser historyNodes size = 2.
    self assert: packageBrowser historyBackNodes size = 0.
    self assert: packageBrowser historyForwardNodes size = 1.
    self assert: packageBrowser definitionPanel getDefinition text = (OBColumn >> #list) getSource.
    self assert: packageBrowser currentNode selector = #list.

    packageBrowser optionalButtonPanel forward.
    self assert: packageBrowser hasBackHistory.
    self deny: packageBrowser hasForwardHistory.
    self assert: packageBrowser historyCursor = 2.
    self deny: packageBrowser historyAtCursor isMethodNode.
    self assert: packageBrowser historyAtCursor theClass = OBBrowser.
    self assert: packageBrowser historyNodes size = 2.
    self assert: packageBrowser historyBackNodes size = 1.
    self assert: packageBrowser historyForwardNodes size = 0.
    self assert: packageBrowser definitionPanel getDefinition text = OBBrowser definition.
    self assert: packageBrowser currentNode theClass = OBBrowser.

    classColumn selection: 4.
    self assert: packageBrowser currentNode theClass = OBFan.    
    self assert: packageBrowser historyCursor = 3.
    self assert: packageBrowser historyAtCursor theClass = OBFan.
    self assert: packageBrowser historyNodes size = 3.

    packageBrowser optionalButtonPanel setBackPressed: true.
    packageBrowser historyGoToIndex: 1.
    self deny: packageBrowser hasBackHistory.
    self assert: packageBrowser hasForwardHistory.
    self assert: packageBrowser historyCursor = 1.
    self assert: packageBrowser historyAtCursor isMethodNode.
    self assert: packageBrowser historyAtCursor theClass = OBColumn.
    self assert: packageBrowser historyAtCursor selector = #list.
    self assert: packageBrowser historyNodes size = 3.
    self assert: packageBrowser historyBackNodes size = 0.
    self assert: packageBrowser historyForwardNodes size = 2.
    self assert: packageBrowser definitionPanel getDefinition text = (OBColumn >> #list) getSource.
    self assert: packageBrowser currentNode selector = #list.    

    classColumn selection: 2.
    self assert: packageBrowser hasBackHistory.
    self deny: packageBrowser hasForwardHistory.
    self assert: packageBrowser historyCursor = 2.
    self assert: packageBrowser historyAtCursor theClass = OBBuilder.
    self assert: packageBrowser historyNodes size = 2.
    self assert: packageBrowser historyBackNodes size = 1.
    self assert: packageBrowser historyForwardNodes size = 0.
    self assert: packageBrowser definitionPanel getDefinition text = OBBuilder definition.
    self assert: packageBrowser currentNode theClass = OBBuilder.
    self assert: (packageBrowser historyBackNodes first theClass = OBColumn).    
! !

!OBEnhPackageBrowserTest methodsFor: 'tests' stamp: 'dr 2/23/2008 16:28'!
testBrowserSetup
    | envMetaNode packageMetaNode classMetaNode methodMetaNode |
    envMetaNode _ OBPackageBrowser defaultMetaNode.
    self assert: envMetaNode name = 'Environment'.
    self assert: (OBPackageBrowser defaultRootNode isKindOf: OBPackagesOrClassesNode).

    self assert: (OBPackageBrowser dynamicBrowser eqv: (OBPackageBrowser definitionPanel isKindOf: OBEnrichedDefinitionPanel)).   
    packageMetaNode _ envMetaNode children first.
    self assert: packageMetaNode name = 'Package'.
    classMetaNode _ packageMetaNode children first.
    self assert: classMetaNode name = 'Class'.
    self assert: (OBPackageBrowser dynamicBrowser eqv: (classMetaNode filters anySatisfy: [:filter | filter isKindOf: OBClassAnnotationFilter])).
    self assert: packageMetaNode children third name = 'Metaclass'.
    self assert: (OBPackageBrowser dynamicBrowser eqv: (packageMetaNode children third filters anySatisfy: [:filter | filter isKindOf: OBClassAnnotationFilter])).	
    methodMetaNode _ classMetaNode children second children first.	
    self assert: methodMetaNode name = 'Method'.
    self assert: (OBPackageBrowser dynamicBrowser eqv: (methodMetaNode filters anySatisfy: [:filter | filter isKindOf: OBDynamicInheritanceFilter])).

    self assert: (OBPackageBrowser dynamicBrowser eqv: OBPackageBrowser hasReferencePanel).
! !

!OBEnhPackageBrowserTest methodsFor: 'tests' stamp: 'dr 3/12/2008 16:16'!
testDeselection! !

!OBEnhPackageBrowserTest methodsFor: 'tests' stamp: 'dr 4/10/2008 17:18'!
testDynamicInfo
    | packageNode clMetaNode columnNode pkgMetaNode classCatNode callBacksNode selectionNode methodMetaNode enrichedSelectionNode enrichedColumnNode source hoCollector |
    packageNode _ OBMonticelloPackageNode on: (MCPackage named: 'OmniBrowser') workingCopy.
    classCatNode _ OBMonticelloClassCategoryNode on: 'OmniBrowser-Kernel' package: packageNode mcPackage.
    pkgMetaNode _ (OBMetaNode named: 'Package') addFilter: OBClassSortFilter new.
    packageNode metaNode: pkgMetaNode.
    clMetaNode _ (OBMetaNode named: 'Class') addFilter: OBClassAnnotationFilter new.
    pkgMetaNode childAt: #classes put: clMetaNode. 
    methodMetaNode _ (OBMetaNode named: 'Method') addFilter: OBDynamicInheritanceFilter new.

    self assert: packageNode classes notEmpty.
    self assert: (packageNode classes anySatisfy: [:ea | ea theClass == OBColumn]).

    

    (Smalltalk classNamed: #HOCollector) ifNotNil: [
    hoCollector _ Smalltalk at: #HOCollector.
    hoCollector default removeClass: OBColumn.
    columnNode _ packageNode classes detect: [:ea | ea theClass == OBColumn] ifNone: [nil].
    columnNode metaNode: clMetaNode.
    self assert: columnNode icon notNil.
    OBPackageBrowser dynamicBrowser ifTrue: [self assert: packageNode icon notNil]
                                               ifFalse: [self assert: packageNode icon isNil].
    self deny: (columnNode isKindOf: OBEnrichedClassNode).
    self assert: columnNode icon = #blank.
    hoCollector default addClass: OBColumn.

    enrichedColumnNode _ packageNode classes detect: [:ea | ea theClass == OBColumn] ifNone: [nil].
    self assert: (enrichedColumnNode isKindOf: OBEnrichedClassNode).

    self assert: columnNode icon = #flag.
    OBPackageBrowser dynamicBrowser ifTrue: [self assert: packageNode icon = #flag.  self assert: classCatNode icon = #flag.]
                                               ifFalse: [self assert: packageNode icon isNil.  self assert: classCatNode icon isNil].
    hoCollector default removeClass: OBColumn.

    "test flag for method and method protocols"
    callBacksNode _ columnNode categories detect: [:ea | ea category = 'callbacks'] ifNone: [nil].
    self assert: callBacksNode notNil.
    selectionNode _ callBacksNode methods detect: [:ea | ea selector = #selection] ifNone: [nil].
    self assert: selectionNode notNil.
    self deny: (selectionNode isKindOf: OBEnrichedMethodNode).
    selectionNode metaNode: methodMetaNode.
    self assert: callBacksNode icon notNil.
    self assert: selectionNode icon notNil.
    self assert: callBacksNode icon = #blank.
    self assert: selectionNode icon = #blank.
    hoCollector default addMethod: (OBColumn >> #selection). 
    self assert: callBacksNode icon = #flag.
    self assert: selectionNode icon = #flag.

    enrichedSelectionNode _ callBacksNode methods detect: [:ea | ea selector = #selection] ifNone: [nil].
    self assert: (enrichedSelectionNode isKindOf: OBEnrichedMethodNode).
    self assert: enrichedSelectionNode source size = 35.
    self assert: (OBColumn new clearSelection) selection = 0.
    source _ enrichedSelectionNode source.
    self assert: source size = 39.
    "test for spaces after selection and ifNil:"
    #(25 26 27 34 35 36) do: [:i | self assert: (source string at: i) = Character space].
    self assert: enrichedSelectionNode referencingClasses size = 1.
    self assert: (enrichedSelectionNode referencingClasses anySatisfy: [:ea | ea theClass == SmallInteger]).

    "there should be two icons in the second line: one after selection, the other after ifNil:, and one in the first line"
    self assert: enrichedSelectionNode formatter iconPositions size = 3.
    self assert: (enrichedSelectionNode formatter iconPositions values includes: #(8 1)).
    self assert: (enrichedSelectionNode formatter iconPositions values includes: #(11 2)).
    self assert: (enrichedSelectionNode formatter iconPositions values includes: #(20 2)).

    hoCollector default removeMethod: (OBColumn >> #selection).
    self assert: callBacksNode icon = #blank.
    self assert: selectionNode icon = #blank.
    ].! !

!OBEnhPackageBrowserTest methodsFor: 'tests' stamp: 'dr 4/10/2008 17:17'!
testEnrichedDefinitionPanel
    | defPanel browser defMorph tabBarMorph textMorph tabPanelMorph referenceMorph hasCodeTabPanel |
    OBPackageBrowser setDynamicBrowser: true.
    defPanel _ OBPackageBrowser definitionPanel.
    browser _ OBPackageBrowser new.
    defPanel browser: browser.
    hasCodeTabPanel := Preferences visualizations and: [defPanel hasCodeTabPanel].


    self assert: (defPanel isKindOf: OBEnrichedDefinitionPanel). 
    defPanel buildOn: OBMorphBuilder new.
    defMorph _ defPanel morph.
    self assert: defMorph submorphs size = (hasCodeTabPanel ifTrue: [2] ifFalse: [1]). 
    tabBarMorph _ defMorph submorphs detect: [:ea | ea isKindOf: RectangleMorph] ifNone: [nil].
    textMorph _ defMorph submorphs detect: [:ea | ea isKindOf: OBEnrichedPluggableTextMorph] ifNone: [nil].
    self assert: textMorph notNil.
    
    hasCodeTabPanel ifTrue: [
	   self assert: tabBarMorph notNil.
	   self assert: tabBarMorph submorphs size = 1.
        tabPanelMorph _ tabBarMorph submorphs detect: [:ea | ea isKindOf: OBRadioButtonBar] ifNone: [nil].
        self assert: tabPanelMorph notNil.
        self assert: tabPanelMorph buttons size > 4.
        self assert: tabPanelMorph buttons first label = (Smalltalk at: #OBCmdSourceCode) new shortLabel.
        self assert: tabPanelMorph buttons last label = (Smalltalk at: #OBCmdUmlDiagram) new shortLabel.
        self assert: tabPanelMorph buttons first isEnabled.
        self assert: tabPanelMorph buttons last isEnabled not. 
    ]. 

    self assert: (defMorph owner isKindOf: RectangleMorph).
    self assert: (defMorph owner submorphs allSatisfy: [:ea | ea isKindOf: RectangleMorph]).
    self assert: (defMorph owner submorphs includes: defMorph).
    referenceMorph _ defMorph owner submorphs detect: [:ea | ea ~= defMorph].
    self assert: referenceMorph submorphs size = 2.
    self assert: (referenceMorph submorphs first isKindOf: RectangleMorph).
    self assert: (referenceMorph submorphs second isKindOf: OBPaneScroller).
    self assert: (referenceMorph submorphs first submorphs first contents = defPanel referenceList listTitle).! !

!OBEnhPackageBrowserTest methodsFor: 'tests' stamp: 'dr 1/28/2008 11:00'!
testExtensionNodes
    | packageNode objectNode textNode pkgMetaNode clMetaNode |
    packageNode := OBMonticelloPackageNode on: (MCPackage named: 'OmniBrowser') workingCopy.
    pkgMetaNode := (OBMetaNode named: 'Package') addFilter: OBClassSortFilter new.
    packageNode metaNode: pkgMetaNode.
    clMetaNode := OBMetaNode named: 'Class'.
    pkgMetaNode childAt: #classes put: clMetaNode.

    self assert: packageNode classes notEmpty.
    self assert: (packageNode classes anySatisfy: [:ea | ea theClass == OBColumn]).
    self assert: (packageNode classes anySatisfy: [:ea | ea theClass == Object]).

    objectNode := packageNode classes detect: [:ea | ea theClass == Object] ifNone: [nil].
    objectNode metaNode: clMetaNode.
    self assert: objectNode notNil.
    self assert: (objectNode isKindOf: OBClassExtensionNode).
    self assert: objectNode name isText.
    self assert: (objectNode name emphasisAt: 1) = TextEmphasis italic emphasisCode.

    "to make sure indents are set in class filter..."
    objectNode := packageNode childNodes detect: [:ea | ea theClass == Object] ifNone: [nil].

    self assert: (packageNode displayStringForChild: objectNode) isText.
    self assert: ((packageNode displayStringForChild: objectNode) emphasisAt: 1) = TextEmphasis italic emphasisCode.
    self assert: (packageNode displayStringForChild: objectNode) string = 'Object'.

    textNode := packageNode classes detect: [:ea | ea theClass == Text] ifNone: [nil].
    textNode metaNode: clMetaNode.
    self assert: textNode notNil.
    self assert: (textNode isKindOf: OBClassExtensionNode).
    self assert: textNode name isText.
    self assert: (textNode name emphasisAt: 1) = TextEmphasis italic emphasisCode.

    "to make sure indents are set in class filter..."
    textNode := packageNode childNodes detect: [:ea | ea theClass == Text] ifNone: [nil].

    self assert: (packageNode displayStringForChild: textNode) isText.
    self assert: ((packageNode displayStringForChild: textNode) emphasisAt: 1) = TextEmphasis italic emphasisCode.
    self assert: (packageNode displayStringForChild: textNode) string = '  Text'.! !

!OBEnhPackageBrowserTest methodsFor: 'tests' stamp: 'dr 3/10/2008 17:04'!
testRememberingMethod
    | classColumn methodColumn idx |
    packageBrowser := OBPackageBrowser onClass: OBBrowser selector: #buildOn:.
    classColumn := packageBrowser navigationPanel columns second.
    methodColumn := packageBrowser navigationPanel columns last.

    self assert: packageBrowser definitionPanel getDefinition text = (OBBrowser >> #buildOn:) getSource.
    self assert: packageBrowser currentNode selector = #buildOn:.

    classColumn selection: 3.
    self assert: packageBrowser currentNode isMethodNode.
    self assert: packageBrowser currentNode theClass = OBColumn.
    self assert: packageBrowser currentNode selector = #buildOn:.
    self assert: packageBrowser definitionPanel getDefinition text = (OBColumn >> #buildOn:) getSource.

    idx := methodColumn children indexOf: (OBMethodNode on: #children inClass: OBColumn).
    methodColumn selection: idx.
    self assert: packageBrowser currentNode isMethodNode.
    self assert: packageBrowser currentNode theClass = OBColumn.
    self assert: packageBrowser currentNode selector = #children.
    self assert: packageBrowser definitionPanel getDefinition text = (OBColumn >> #children) getSource.

    classColumn selection: 4.
    self assert: packageBrowser currentNode isMethodNode.
    self assert: packageBrowser currentNode theClass = OBFan.
    self assert: packageBrowser currentNode selector = #children.
    self assert: packageBrowser definitionPanel getDefinition text = (OBFan >> #children) getSource.

    classColumn selection: 1.
    self deny: packageBrowser currentNode isMethodNode.
    self assert: packageBrowser currentNode theClass = OBBrowser.
    self assert: packageBrowser definitionPanel getDefinition text = OBBrowser definition.

    classColumn selection: 3.
    self assert: packageBrowser currentNode isMethodNode.
    self assert: packageBrowser currentNode theClass = OBColumn.
    self assert: packageBrowser currentNode selector = #children.
    self assert: packageBrowser definitionPanel getDefinition text = (OBColumn >> #children) getSource.! !

!OBEnhPackageBrowserTest methodsFor: 'tests' stamp: 'dr 1/28/2008 10:13'!
testRootNode
    | rootNode packages pkgWithCategories pkgIdx dummyPackage |
    rootNode := OBPackageBrowser defaultRootNode.
    self assert: rootNode isEnvironment.
    self assert: rootNode environment == Smalltalk.

    packages := rootNode packages.
    self assert: packages notEmpty.
    self assert: (packages first isKindOf: OBMonticelloPackageNode).
    pkgWithCategories := packages detect: [:package | package classCategories notEmpty].
    pkgIdx := packages indexOf: pkgWithCategories.
    self assert: ((packages at: pkgIdx + 1) name = pkgWithCategories classCategories first).
    self assert: ((packages at: pkgIdx + 1) mcPackage = pkgWithCategories mcPackage).
    self assert: ((packages at: pkgIdx + pkgWithCategories classCategories size) name = pkgWithCategories classCategories last).

    "test dummy package"
    dummyPackage := (packages detect: [:pkg | pkg mcPackage isKindOf: OBDummyPackage] ifNone: [nil]) mcPackage.
    dummyPackage ifNotNil: [
	   self deny: dummyPackage modified.
	   self assert: dummyPackage packageName = 'Unpackaged'.
	   self assert: dummyPackage repositories isEmpty.
	   self assert: dummyPackage extensionClasses isEmpty.
	   self deny: dummyPackage categories isEmpty.
    ].
    ! !

TestCase subclass: #OBEnhSetupTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tests'!

!OBEnhSetupTest methodsFor: 'tests' stamp: 'dr 3/12/2008 16:10'!
testInstallation
    | iconicButtons |
    self assert: (World submorphs anySatisfy: [:morph | morph isKindOf: OBIconicButton]).
    iconicButtons := World submorphs select: [:morph | morph isKindOf: OBIconicButton].
    iconicButtons := iconicButtons asSortedCollection: [:a :b | a left <= b left].
    self assert: iconicButtons size = 4.
    self assert: (iconicButtons first targets includes: OBSystemBrowser).
    self assert: (iconicButtons second targets anyOne = Workspace).
    self assert: (iconicButtons third targets isEmpty).
    self assert: (iconicButtons third windowClass = PreDebugWindow).
    self assert: (iconicButtons fourth targets anyOne = Inspector).

    self assert: ((Smalltalk at: #SystemBrowser) registeredClasses includes: OBPackageBrowserAdaptor).
    self assert: OBPackageBrowserAdaptor browserClass == OBPackageBrowser.
    self assert: (TheWorldMenu registeredOpenCommands noneSatisfy: [:ea | ea first = 'Package Browser']).
    self assert: (TheWorldMenu registeredOpenCommands anySatisfy: [:ea | ea first = 'SmartGroup Browser']).! !

TestCase subclass: #OBEnhSmartGroupBrowserTest
	instanceVariableNames: 'smartGroupBrowser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Tests'!

!OBEnhSmartGroupBrowserTest methodsFor: 'setUp' stamp: 'dr 3/7/2008 16:49'!
setUp
    smartGroupBrowser := OBSmartGroupBrowser onClass: self class selector: #setUp.
! !

!OBEnhSmartGroupBrowserTest methodsFor: 'tests' stamp: 'dr 3/14/2008 17:16'!
testAddSmartCategory
    | columns smartGroupColumn |
    columns := smartGroupBrowser navigationPanel columns.
    smartGroupColumn := columns first.
    smartGroupColumn switch selection: 2.

    self assert: (OBCmdAddSmartCategory on: smartGroupBrowser root for: smartGroupColumn) isActive.! !

!OBEnhSmartGroupBrowserTest methodsFor: 'tests' stamp: 'dr 3/7/2008 17:10'!
testBrowserSetup
    | smartGroup smartGroupEdge envNode |
    self assert: OBSmartGroupBrowser paneCount = 4.
    self assert: (OBSmartGroupBrowser definitionPanel isKindOf: OBMultipleDefinitionPanel).
    self assert: (OBSmartGroupBrowser navigationPanel isKindOf: OBSmartGroupColumnPanel).


    self assert: (smartGroupBrowser root isKindOf: OBPackagesOrClassesNode).
    self assert: (smartGroupBrowser currentNode isKindOf: OBMethodNode).
    self assert: smartGroupBrowser currentNode theClass = self class.
    self assert: smartGroupBrowser currentNode selector = #setUp.

    envNode := OBSmartGroupBrowser defaultMetaNode.
    self assert: envNode name = 'Environment'.
    self assert: envNode children size = 2.
    smartGroup := envNode children detect: [:ea | ea name = 'SmartGroup'] ifNone: [nil].
    self assert: smartGroup notNil.
    self assert: envNode edges size = 2.
    smartGroupEdge := envNode edges detect: [:ea | ea metaNode = smartGroup] ifNone: [nil].
    self assert: smartGroupEdge notNil.
    self assert: smartGroupEdge metaNode == smartGroup.
    self assert: smartGroupEdge label = 'smart groups'.
    
! !

!OBEnhSmartGroupBrowserTest methodsFor: 'tests' stamp: 'dr 3/14/2008 17:06'!
testCommands
    | columns smartGroupColumn scan activeCommands |
    columns := smartGroupBrowser navigationPanel columns.
    smartGroupColumn := columns first.
    smartGroupColumn switch selection: 2.

    scan := smartGroupBrowser announce: OBNodeCommandScan. 
    activeCommands := (scan commandsOn: smartGroupColumn children first for: smartGroupColumn) select: [:ea | ea isActive].
    self deny: (activeCommands select: [:ea | ea isKindOf: OBCmdAddWorkingCopy]) size > 0.! !

!OBEnhSmartGroupBrowserTest methodsFor: 'tests' stamp: 'dr 3/13/2008 17:13'!
testNoRenameOfSearches
    | columns smartGroupColumn searchGroup cmd |
    columns := smartGroupBrowser navigationPanel columns.
    smartGroupColumn := columns first.
    smartGroupColumn switch selection: 2.

    searchGroup := smartGroupColumn children detect: [:ea | ea isSmartGroupCategory and: [ea name = OBSmartRootNode searchGroupName]]  
                                                        ifNone: [nil].
    searchGroup name: 'blabla'.
    self assert: searchGroup name = OBSmartRootNode searchGroupName.
    cmd := OBCmdRenameSmartCategory on: searchGroup for: 'dontcare'.
    self deny: cmd isActive.! !

!OBEnhSmartGroupBrowserTest methodsFor: 'tests' stamp: 'dr 3/13/2008 15:08'!
testRememberingSearchNodeOnSwitch
    | columns smartGroupColumn searchNode query aliasNode |
    columns := smartGroupBrowser navigationPanel columns.
    smartGroupColumn := columns first.
    query := (OrderedCollection with: 'OBEnhSmart').
    searchNode := OBClassSearchNode on: query.

    aliasNode := smartGroupBrowser root smartGroups detect: [:node | node isSmartAlias and: [node alias = searchNode]] ifNone: [nil]. 
    aliasNode ifNotNil: [aliasNode remove].

    smartGroupBrowser navigationPanel addSearchToSmartGroup: searchNode.
    aliasNode := smartGroupBrowser root smartGroups detect: [:node | node isSmartAlias and: [node alias = searchNode]] ifNone: [nil].
    self assert: smartGroupColumn selectedNode = aliasNode.
    self assert: columns second selection = 1. 
    self assert: columns second selectedNode theClass = self class.

    smartGroupColumn switch selection: 1.
    self assert: smartGroupBrowser currentNode theClass = self class.
    self assert: columns second selectedNode theClass = self class.   
    self assert: smartGroupColumn selectedNode name = 'OB-Enhancements-Tests'.  
    self assert: smartGroupBrowser definitionPanel getDefinition text = self class definition.

    smartGroupColumn switch selection: 2.
    self assert: smartGroupBrowser currentNode isNil.
    self assert: columns second selectedNode isNil.   
    self assert: smartGroupColumn selectedNode isNil.  
    self assert: smartGroupBrowser definitionPanel getDefinition isNil.

    aliasNode remove.  
    self assert: (smartGroupBrowser root smartGroups noneSatisfy: [:node | node isSmartAlias and: [node alias = searchNode]]).
! !

!OBEnhSmartGroupBrowserTest methodsFor: 'tests' stamp: 'dr 3/12/2008 16:15'!
testSearchSmartGroup
    | columns smartGroupColumn searchNode query aliasNode size |
    columns := smartGroupBrowser navigationPanel columns.
    smartGroupColumn := columns first.
    query := (OrderedCollection with: 'OBEnhSmart').
    searchNode := OBClassSearchNode on: query.

    aliasNode := smartGroupBrowser root smartGroups detect: [:node | node isSmartAlias and: [node alias = searchNode]] ifNone: [nil]. 
    aliasNode ifNotNil: [aliasNode remove].

    self assert: (smartGroupBrowser root smartGroups noneSatisfy: [:node | node isSmartAlias and: [node alias = searchNode]]).

    smartGroupBrowser navigationPanel addSearchToSmartGroup: searchNode.
    aliasNode := smartGroupBrowser root smartGroups detect: [:node | node isSmartAlias and: [node alias = searchNode]] ifNone: [nil].
    self assert: aliasNode notNil.
    self assert: searchNode = aliasNode alias.

    self assert: (smartGroupColumn children anySatisfy: [:node | node isSmartAlias and: [node alias = searchNode]]).
    self assert: smartGroupColumn selectedNode = aliasNode.
    self assert: columns second children size = 1.
    self assert: (columns second children first isKindOf: OBClassNode).
    self assert: columns second children first theClass = self class.
    self assert: columns second selectedNode theClass = self class.
    self assert: smartGroupBrowser definitionPanel getDefinition text = self class definition.

    columns second selection: 1. "this is a hidden test for de-selection"
    self assert: columns second selectedNode isNil.
    self assert: smartGroupBrowser definitionPanel getDefinition text isEmpty.

    "no double adding possible"
    size := smartGroupColumn children size.
    smartGroupBrowser navigationPanel addSearchToSmartGroup: searchNode copy.
    self assert: size = smartGroupColumn children size.
    self assert: (smartGroupBrowser root smartGroups select: [:node | node isSmartAlias and: [node alias = searchNode]]) size = 1.

    aliasNode remove.  
    self assert: (smartGroupBrowser root smartGroups noneSatisfy: [:node | node isSmartAlias and: [node alias = searchNode]]).
! !

!OBEnhSmartGroupBrowserTest methodsFor: 'tests' stamp: 'dr 3/14/2008 16:24'!
testSmartGroupNodes
    | columns smartGroupColumn searchGroup defaultGroup |
    columns := smartGroupBrowser navigationPanel columns.
    smartGroupColumn := columns first.
    smartGroupColumn switch selection: 2.

    defaultGroup := smartGroupColumn children detect: [:ea | ea isSmartGroupCategory and: [ea name = 'default']]  
                                                        ifNone: [nil].
    searchGroup := smartGroupColumn children detect: [:ea | ea isSmartGroupCategory and: [ea name = OBSmartRootNode searchGroupName]]  
                                                        ifNone: [nil].
    self assert: searchGroup notNil.
    self assert: defaultGroup notNil.
    self deny: (OBCmdRemoveFromSmartGroup on: defaultGroup for: nil) isActive.
    self deny: (OBCmdRemoveFromSmartGroup on: searchGroup for: nil) isActive.
 
 ! !

!OBEnhSmartGroupBrowserTest methodsFor: 'tests' stamp: 'dr 3/7/2008 17:45'!
testSmartGroupSwitch
    | columns smartGroupColumn smartCategories smartAlias idx |
    columns := smartGroupBrowser navigationPanel columns.
    smartGroupColumn := columns first.
    self assert: smartGroupColumn switch selection = 1.
    self assert: smartGroupColumn switch list size = 2.
    self assert: smartGroupColumn children size = smartGroupBrowser root packages size.

    smartGroupColumn switch selection: 2.
    self assert: smartGroupColumn switch selection = 2.
    self assert: smartGroupColumn children size = smartGroupBrowser root smartGroups size.

    smartCategories := smartGroupBrowser root smartGroups select: [:ea | ea isSmartGroupCategory]. 
    self assert: (smartCategories anySatisfy: [:ea | ea name = 'default']).
    self assert: (smartCategories anySatisfy: [:ea | ea name = 'searches']).

    smartAlias := smartGroupBrowser root smartGroups detect: [:ea | ea isSmartAlias] ifNone: [nil]. 
    smartAlias ifNotNil: [
	   idx := smartGroupBrowser root smartGroups indexOf: smartAlias.
	   self assert: smartGroupColumn selectedNode isNil.
	   smartGroupColumn selection: idx.
	   self assert: smartGroupColumn selectedNode = smartAlias.
	   self assert: smartGroupBrowser currentNode = smartAlias alias.
	   self assert: smartGroupBrowser definitionPanel getDefinition text = smartAlias alias definition text.
    ].
    
! !

!OBTextMorph methodsFor: '*ob-enhancements' stamp: 'dr 4/11/2008 11:46'!
keyStroke: anEvent	
	(anEvent anyModifierKeyPressed or: [editView model isEditable])
		ifTrue: [super keyStroke: anEvent. editView removeIcons].! !

!OBDefinition methodsFor: '*ob-enhancements' stamp: 'dr 9/28/2007 13:43'!
isEnrichedDefinition
    ^false! !

!OBCommandScan methodsFor: '*ob-enhancements' stamp: 'dr 2/7/2008 10:10'!
populateMenu: aMenu withNode: aNode forRequestor: aRequestor filter: aBlock
	| commands cluster |
	commands _ IdentitySet new.
	self addCommandsOn: aNode for: aRequestor to: commands.
	commands _ commands select: [:cmd | aBlock value: cmd].
	cluster _ self clusterCommands: commands.
	cluster populateMenu: aMenu! !

OBMethodDefinition subclass: #OBEnrichedMethodDefinition
	instanceVariableNames: 'formatter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBEnrichedMethodDefinition commentStamp: 'dr 10/9/2007 17:11' prior: 0!
I am an enriched definition. I know how to display and format dynamic information about the method's source code I represent.!

!OBEnrichedMethodDefinition methodsFor: 'accessing' stamp: 'dr 9/28/2007 11:39'!
formatter
    ^formatter! !

!OBEnrichedMethodDefinition methodsFor: 'testing' stamp: 'dr 9/28/2007 13:43'!
isEnrichedDefinition
    ^true! !

!OBEnrichedMethodDefinition methodsFor: 'accessing' stamp: 'dr 9/28/2007 11:39'!
setFormatter: aHOFormatter
    formatter := aHOFormatter! !

!OBEnrichedMethodDefinition methodsFor: 'accessing' stamp: 'dr 11/21/2007 11:19'!
text
	^ source 
		ifNotNil: [source asText]
		ifNil: [self theClass sourceCodeTemplate]! !

OBClassNode subclass: #OBClassExtensionNode
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBClassExtensionNode methodsFor: 'navigating' stamp: 'dr 3/3/2008 15:09'!
allCategory
	^ Array with: ((OBAllMethodExtensionCategoryNode on: self theClass) classExtensionNode: self; yourself)! !

!OBClassExtensionNode methodsFor: 'navigating' stamp: 'dr 3/3/2008 16:06'!
categories
	^self theClass organization categories
		collect: [:cat | (OBMethodCategoryExtensionNode on: cat inClass: self theClass) classExtensionNode: self]! !

!OBClassExtensionNode methodsFor: 'accessing' stamp: 'dr 3/3/2008 15:11'!
extensionName
    ^package mcPackage packageName ! !

!OBClassExtensionNode methodsFor: 'testing' stamp: 'dr 2/24/2008 14:44'!
isDescendantOfClass: other
     ^other = self! !

!OBClassExtensionNode methodsFor: 'testing' stamp: 'dr 3/3/2008 17:22'!
isDescendantOfClassCat: aClassCategoryNode
	(aClassCategoryNode isKindOf: OBMonticelloPackageNode) ifFalse: [^false].
	aClassCategoryNode = self package ifFalse: [^false].
	^(aClassCategoryNode extensionClasses collect: [:ea | ea theNonMetaClass]) includes: self theNonMetaClass.! !

!OBClassExtensionNode methodsFor: 'displaying' stamp: 'dr 1/8/2008 17:17'!
name 
	^Text string: super name asString emphasis: {TextEmphasis italic} ! !

!OBClassExtensionNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 13:17'!
package
	^ package! !

!OBClassExtensionNode methodsFor: 'accessing' stamp: 'dr 3/3/2008 15:12'!
package: aPackageNode
	package := aPackageNode ! !

OBClassExtensionNode subclass: #OBMetaclassExtensionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBMetaclassExtensionNode methodsFor: 'actions' stamp: 'dr 2/15/2008 16:22'!
browse
	^ OBCodeBrowser defaultBrowserClass openOnClass: self theNonMetaClass ! !

!OBMetaclassExtensionNode methodsFor: 'displaying' stamp: 'dr 3/3/2008 16:59'!
displayFullString
    ^self theClass name! !

!OBMetaclassExtensionNode methodsFor: 'displaying' stamp: 'dr 1/8/2008 17:17'!
name 
	^Text string: self nonMetaName emphasis: {TextEmphasis italic} ! !

!OBMetaclassExtensionNode methodsFor: 'as yet unclassified' stamp: 'ms 12/19/2007 00:28'!
nonMetaName
	^ self theNonMetaClass name! !

!OBMetaclassExtensionNode methodsFor: 'initializing' stamp: 'ms 12/19/2007 00:28'!
setClass: aClass
	self theClass: aClass theMetaClass! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 6/7/2007 16:34'!
dropOnSmartGroup: aNode
	aNode addAlias: self.
	aNode signalChildrenChanged.! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 2/28/2008 14:14'!
isClassNode
   ^true! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:08'!
isInstrumented 
    ^(Smalltalk classNamed: #HODataBase) notNil and: [(Smalltalk at: #HODataBase) default includesClass: self theNonMetaClass]! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 13:40'!
isNodeWithReferences
    ^true! !

!OBClassNode methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 14:23'!
prefixedName
    ^self name! !

OBClassNode subclass: #OBClassReferenceNode
	instanceVariableNames: 'modelClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBClassReferenceNode commentStamp: 'dr 10/9/2007 17:00' prior: 0!
I relate referencing classes, i.e. classes that reference each other dynamically. I know in which methods of my associated class the referenced class is used.
I am used in the dependency browser.  !

!OBClassReferenceNode class methodsFor: 'as yet unclassified' stamp: 'dr 10/5/2007 10:42'!
on: aClass modelClass: modelClass
    ^self new setClass: aClass setModelClass: modelClass! !

!OBClassReferenceNode methodsFor: 'accessing' stamp: 'dr 10/11/2007 17:23'!
asClassNode
    ^OBClassNode on: self theClass! !

!OBClassReferenceNode methodsFor: 'displaying' stamp: 'dr 10/11/2007 17:19'!
displayString
    ^self name! !

!OBClassReferenceNode methodsFor: 'accessing' stamp: 'dr 2/23/2008 16:11'!
icon
    (Smalltalk classNamed: #HODataBase) ifNil: [^nil].
    ^((Smalltalk at: #HODataBase) default includesClass: self theClass) ifTrue: [#flag] ifFalse: [#blank]! !

!OBClassReferenceNode methodsFor: 'testing' stamp: 'dr 2/21/2008 14:50'!
isDescendantOfClassRef: aNode
    ^aNode = self! !

!OBClassReferenceNode methodsFor: 'navigating' stamp: 'dr 10/15/2007 16:14'!
referencingMethods
    ^((modelClass methodsReferencingClass: self theClass) asSortedCollection: [:a :b | a selector <= b selector]) 
              collect: [:ea | OBEnrichedMethodNode on: ea referencedClass: self theClass]! !

!OBClassReferenceNode methodsFor: 'accessing' stamp: 'dr 10/4/2007 11:31'!
setClass: aClass setModelClass: secondClass
    theClass := aClass.
    modelClass := secondClass.
! !

OBClassNode subclass: #OBEnrichedClassNode
	instanceVariableNames: 'metaClass formatter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBEnrichedClassNode class methodsFor: 'instance creation' stamp: 'dr 11/19/2007 11:20'!
on: aHOClass
    ^(super on: aHOClass actualClass) setMetaClass: aHOClass; yourself! !

!OBEnrichedClassNode methodsFor: 'accessing' stamp: 'dr 11/19/2007 11:25'!
definition
	^(OBEnrichedClassDefinition 
		environment: self theClass environment 
		template: self theClass definition) setFormatter: self formatter! !

!OBEnrichedClassNode methodsFor: 'accessing' stamp: 'dr 11/19/2007 15:33'!
formatter
    formatter ifNil: [formatter := HOClassFormatter metaClass: self metaClass].
    ^formatter! !

!OBEnrichedClassNode methodsFor: 'accessing' stamp: 'dr 11/17/2007 16:45'!
metaClass
    ^metaClass! !

!OBEnrichedClassNode methodsFor: 'accessing' stamp: 'dr 11/19/2007 16:14'!
reference
    ^nil! !

!OBEnrichedClassNode methodsFor: 'accessing' stamp: 'dr 11/17/2007 16:45'!
setMetaClass: aHOClass
    metaClass := aHOClass! !

OBInheritanceFilter subclass: #OBDynamicInheritanceFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBDynamicInheritanceFilter methodsFor: 'filtering' stamp: 'dr 2/15/2008 17:41'!
icon: aSymbol forNode: aNode
	| method |
	method _ aNode theClass lookupSelector: aNode selector.
	method ifNil: [^ #blank].
	(Smalltalk at: #HODataBase ifAbsent: [^#blank]).
	((Smalltalk at: #HODataBase) default isInstrumentedMethod: aNode reference) ifTrue: [
		(aNode isKindOf: OBEnrichedMethodNode) ifFalse: [
			aNode become: (OBEnrichedMethodNode fromMethodNode: aNode)].
		^#flag].			
	^ aNode isOverride
		ifTrue: [aNode isOverridden 
			ifTrue: [#arrowUpAndDown] 
			ifFalse: [#arrowUp]]
		ifFalse: [aNode isOverridden 
			ifTrue: [#arrowDown] 
			ifFalse: [#blank]]! !

OBSystemBrowser subclass: #OBPackageBrowser
	instanceVariableNames: 'browseHistory historyCursor historyIndexOnSwitch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

OBPackageBrowser class
	instanceVariableNames: 'dynamicBrowser'!

OBPackageBrowser class
	instanceVariableNames: 'dynamicBrowser'!

OBPackageBrowser subclass: #OBMultipleSelectionBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-MultipleSelection'!

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 10/9/2007 17:09'!
definitionPanel
	^ OBMultipleDefinitionPanel new! !

!OBMultipleSelectionBrowser class methodsFor: 'initializing' stamp: 'dr 7/19/2007 16:10'!
initialize
	self registerInOpenMenu! !

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 7/18/2007 16:17'!
methodColumnIndex
    ^4! !

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 7/19/2007 17:52'!
navigationPanel
	^OBMultipleSelectionColumnPanel minPanes: self minPanes maxPanes: self maxPanes! !

!OBMultipleSelectionBrowser class methodsFor: 'initializing' stamp: 'dr 2/23/2008 15:22'!
registerInOpenMenu
	TheWorldMenu registerOpenCommand: {'Multiple Selection Browser'. {self. #open}}.! !

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 4/11/2008 10:56'!
title
    ^'Multiple Selection System Browser'! !

!OBMultipleSelectionBrowser class methodsFor: 'configuration' stamp: 'dr 7/18/2007 16:15'!
useMultipleSelection
    ^true! !

OBMultipleSelectionBrowser subclass: #OBSmartGroupBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartGroupBrowser class methodsFor: 'configuration' stamp: 'dr 2/29/2008 16:31'!
defaultMetaNode
     | env smartGroup package |
	env _ OBMetaNode named: 'Environment'.
	package _ OBMetaNode named: 'Package'.
	package
	      displaySelector: #indentedName;
	      ancestrySelector: #isDescendantOfClassCat:.
	self buildMetagraphOn: package.
     smartGroup _ OBMetaNode named: 'SmartGroup'.
     smartGroup
		displaySelector: #indentedName.
	self buildMetagraphOn: smartGroup.	
	
     env
		childAt: #packages
			labeled: 'packages'
			put: package;
		childAt: #smartGroups
			labeled: 'smart groups'
			put: smartGroup;
		addFilter: OBModalFilter new.
     ^env       ! !

!OBSmartGroupBrowser class methodsFor: 'configuration' stamp: 'dr 7/19/2007 10:47'!
navigationPanel
	^OBSmartGroupColumnPanel minPanes: self minPanes maxPanes: self maxPanes! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:40'!
cmdAddSmartCategory
	^OBCmdAddSmartCategory! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:40'!
cmdAddToSmartGroup
	^OBCmdAddToSmartGroup! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 3/12/2008 15:34'!
cmdBrowse
	^OBCmdSmartGroupBrowse! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:41'!
cmdRemoveFromSmartGroup
	^OBCmdRemoveFromSmartGroup! !

!OBSmartGroupBrowser methodsFor: 'commands' stamp: 'dr 7/19/2007 11:41'!
cmdRenameSmartCategory
	^OBCmdRenameSmartCategory! !

!OBSmartGroupBrowser methodsFor: 'testing' stamp: 'dr 3/11/2008 10:15'!
isSearchBrowser
	^ true ! !

!OBPackageBrowser class methodsFor: 'initializing' stamp: 'dr 4/11/2008 10:52'!
addPreferences
	Preferences 
		addPreference: #visualizations
		categories: #('browsing')
		default: true
		balloonHelp: 'Display visualizations in the code browser such as UML, system complexity, etc..'.
		
	Preferences 
		addPreference: #classCommentOnClassSelect
		categories: #('browsing')
		default: self isDeveloperImage
		balloonHelp: 'Automatically display class comment when selecting a class.'.	! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 2/16/2008 15:20'!
beDynamic
   self setDynamicBrowser: true! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 2/14/2008 16:01'!
buildMetagraphOn: root class: classSel comment: commentSel metaclass: metaclassSel 
	^((self dynamicBrowser ifTrue: [OBDynamicMetagraphBuilder] ifFalse: [OBEnhancementMetagraphBuilder])
		on: root
		class: classSel
		comment: commentSel
		metaclass: metaclassSel) execute! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 2/16/2008 15:46'!
defaultExtent
    ^650@400! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 4/10/2008 16:35'!
defaultMetaNode
     | env smartGroup package |
	env _ OBMetaNode named: 'Environment'.
	package _ OBMetaNode named: 'Package'.
	package
	      displaySelector: #indentedName;
	      ancestrySelector: #isDescendantOfClassCat:.
	self buildMetagraphOn: package.
     smartGroup _ OBMetaNode named: 'SmartGroup'.
     smartGroup
		displaySelector: #indentedName.
	self buildMetagraphOn: smartGroup.	
	
     env
		childAt: #packages
			labeled: 'packages'
			put: package;
		childAt: #smartGroups
			labeled: 'smart groups'
			put: smartGroup;
		addFilter: OBModalFilter new.
     ^env! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 7/20/2007 15:03'!
defaultRootNode
	^ OBPackagesOrClassesNode new! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 2/16/2008 15:27'!
definitionPanel
	^(self dynamicBrowser ifTrue: [OBEnrichedDefinitionPanel new] ifFalse: [OBEnhancementDefinitionPanel new])! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 2/16/2008 15:19'!
dynamicBrowser
	dynamicBrowser ifNil: [dynamicBrowser _ false].
	^dynamicBrowser! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 2/27/2008 15:43'!
hasHistoryButtons
    ^true! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 2/22/2008 15:15'!
hasReferencePanel
    ^self dynamicBrowser! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 2/15/2008 14:36'!
hierarchyBrowserClass
    ^OBDynamicHierarchyBrowser! !

!OBPackageBrowser class methodsFor: 'initializing' stamp: 'dr 4/11/2008 10:56'!
initialize
	"self initialize"
	self registerInOpenMenu.
	self addPreferences.
	
     "to be removed in a while"
     TheWorldMenu unregisterOpenCommand: 'SmartGroup Browser'! !

!OBPackageBrowser class methodsFor: 'testing' stamp: 'dr 4/10/2008 16:34'!
isDeveloperImage
    ^(Smalltalk classNamed: #DEVImageCreator) notNil! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 4/10/2008 16:39'!
navigationPanel
	^OBSmartGroupColumnPanel minPanes: self minPanes maxPanes: self maxPanes! !

!OBPackageBrowser class methodsFor: 'instance creation' stamp: 'dr 7/20/2007 15:06'!
onMonticelloClassCategory: aString
	^self selection: (OBMonticelloClassCategoryNode on: aString)! !

!OBPackageBrowser class methodsFor: 'instance creation' stamp: 'dr 12/10/2007 10:22'!
onPackage: aPackage
	^self selection: aPackage asNode! !

!OBPackageBrowser class methodsFor: 'opening' stamp: 'dr 7/20/2007 15:07'!
openOnMonticelloClassCategory: aString
	^ (self onMonticelloClassCategory: aString) open! !

!OBPackageBrowser class methodsFor: 'opening' stamp: 'dr 7/20/2007 15:07'!
openOnPackage: aPackage
	^ (self onPackage: aPackage) open! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 3/13/2008 10:51'!
optionalButtonPanel
	^ OBPlatform current optionalButtons ifTrue: [OBEnhancementFixedButtonPanel new]! !

!OBPackageBrowser class methodsFor: 'initializing' stamp: 'dr 2/23/2008 15:22'!
registerInOpenMenu
	TheWorldMenu registerOpenCommand: {'Image Browser'. {self. #open}}.! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 1/28/2008 11:04'!
setDynamicBrowser: aBoolean
    dynamicBrowser := aBoolean
! !

!OBPackageBrowser class methodsFor: 'configuration' stamp: 'dr 4/11/2008 11:32'!
title
    ^'OB Package Browser'! !

!OBPackageBrowser methodsFor: 'morphic' stamp: 'dr 1/9/2008 15:41'!
addModelItemsToWindowMenu: aMenu
	Smalltalk 
		at: #SystemBrowser 
		ifPresent: [:class | class 
								addRegistryMenuItemsTo: aMenu 
								inAccountOf: OBPackageBrowserAdaptor new].! !

!OBPackageBrowser methodsFor: 'history' stamp: 'dr 2/22/2008 16:23'!
browseHistory
    browseHistory ifNil: [browseHistory _ OrderedCollection new].
    ^browseHistory! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 4/10/2008 16:36'!
cmdAddSmartCategory
	^OBCmdAddSmartCategory! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 4/10/2008 16:36'!
cmdAddToSmartGroup
	^OBCmdAddToSmartGroup! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/20/2007 15:33'!
cmdAddWorkingCopy
    ^OBCmdAddWorkingCopy! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 4/10/2008 16:36'!
cmdBrowse
	^OBCmdSmartGroupBrowse! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 9/13/2007 11:13'!
cmdBrowseDynamicImplementors
	^OBCmdDynamicImplementors! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 11/16/2007 16:19'!
cmdBrowseDynamicReferences
    ^OBCmdBrowseDynamicReferences! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 10/5/2007 16:49'!
cmdBrowseDynamicSenders
	^OBCmdDynamicSenders! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 2/15/2008 17:57'!
cmdBrowseHierarchy
	^OBEnhancementCmdBrowseHierarchy! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/20/2007 15:33'!
cmdBrowseWorkingCopy
	^OBCmdBrowseWorkingCopy! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 12/18/2007 17:02'!
cmdCreateMonticelloCategory
    ^OBCmdCreateMonticelloCategory! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 10/15/2007 11:01'!
cmdDisplayReferencingPlaces
	^OBCmdDisplayReferencingPlaces! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 10/15/2007 11:01'!
cmdJumpToReference
	^OBCmdJumpToReference! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 10/16/2007 10:35'!
cmdObserveDynamically
	^OBCmdObserveDynamically! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/20/2007 15:34'!
cmdPublishPackage
	^OBCmdPublishPackage! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 4/10/2008 16:36'!
cmdRemoveFromSmartGroup
	^OBCmdRemoveFromSmartGroup! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/20/2007 15:38'!
cmdRemoveWorkingCopy
	^OBCmdRemoveWorkingCopy! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 4/10/2008 16:36'!
cmdRenameSmartCategory
	^OBCmdRenameSmartCategory! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 10/16/2007 10:57'!
cmdStopObservingDynamically
	^OBCmdStopObservingDynamically! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 12/14/2007 15:16'!
cmdUpdatePackage
	^OBCmdUpdatePackage ! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/20/2007 15:34'!
cmdViewChanges
	^OBCmdViewChanges! !

!OBPackageBrowser methodsFor: 'commands' stamp: 'dr 7/20/2007 15:34'!
cmdViewHistory
	^OBCmdViewHistory! !

!OBPackageBrowser methodsFor: 'accessing' stamp: 'dr 2/16/2008 15:39'!
extent
   ^self class defaultExtent! !

!OBPackageBrowser methodsFor: 'history' stamp: 'dr 2/22/2008 17:18'!
historyAtCursor
   ^self browseHistory at: self historyCursor ifAbsent: [nil]! !

!OBPackageBrowser methodsFor: 'history' stamp: 'dr 2/23/2008 15:30'!
historyCursor
    ^historyCursor ifNil: [0]! !

!OBPackageBrowser methodsFor: 'history' stamp: 'dr 2/22/2008 16:21'!
historyCursor: anInteger
    historyCursor := anInteger! !

!OBPackageBrowser methodsFor: 'history' stamp: 'dr 2/26/2008 16:23'!
historyIndexOnSwitch
    historyIndexOnSwitch ifNil: [historyIndexOnSwitch _ 0].
    ^historyIndexOnSwitch! !

!OBPackageBrowser methodsFor: 'initializing' stamp: 'dr 2/21/2008 11:31'!
initialize
    super initialize.! !

!OBPackageBrowser methodsFor: 'testing' stamp: 'dr 4/10/2008 16:52'!
isSearchBrowser
    ^true! !

!OBPackageBrowser methodsFor: 'history' stamp: 'dr 2/26/2008 16:23'!
markSwitch
    historyIndexOnSwitch _ self historyCursor.! !

!OBPackageBrowser methodsFor: 'opening' stamp: 'dr 2/16/2008 15:43'!
open
    ^OBEnhancementBrowseRequest signal: self! !

!OBPackageBrowser methodsFor: 'panels' stamp: 'dr 3/13/2008 13:21'!
optionalButtonPanel
	^ panels 
		detect: [:ea | ea isKindOf: OBFixedButtonPanel] 
		ifNone: [self error: 'No optional button panel configured']! !

!OBPackageBrowser methodsFor: 'history' stamp: 'dr 2/26/2008 16:24'!
resetHistoryIndexOnSwitch
    historyIndexOnSwitch _ 0! !

!OBPackageBrowser methodsFor: 'history' stamp: 'dr 2/22/2008 16:48'!
setHistory: aCollection
    browseHistory := aCollection! !

!OBPackageBrowser methodsFor: 'accessing' stamp: 'dr 2/26/2008 16:26'!
setMetaNode: aMetaNode root: aNode
    self navigationPanel setMetaNode: aMetaNode node: aNode.! !

!OBClassCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 4/11/2008 11:23'!
isClassCategory
    ^true! !

OBClassCategoryNode subclass: #OBMonticelloClassCategoryNode
	instanceVariableNames: 'mcPackage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBMonticelloClassCategoryNode commentStamp: 'dr 7/16/2007 10:37' prior: 0!
I represent a class category contained in a Monticello package.!

!OBMonticelloClassCategoryNode class methodsFor: 'instance creation' stamp: 'dr 12/18/2007 16:44'!
on: aString package: mcPackage
    ^(self on: aString) mcPackage: mcPackage! !

!OBMonticelloClassCategoryNode methodsFor: 'actions' stamp: 'dr 2/15/2008 16:51'!
browse
	OBCodeBrowser defaultBrowserClass openOnMonticelloClassCategory: name! !

!OBMonticelloClassCategoryNode methodsFor: 'displaying' stamp: 'dr 2/23/2008 17:09'!
displayFullString
    ^self name! !

!OBMonticelloClassCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 6/7/2007 16:35'!
dropOnSmartGroup: aNode
	aNode addAlias: self.
	aNode signalChildrenChanged.! !

!OBMonticelloClassCategoryNode methodsFor: 'displaying' stamp: 'dr 2/24/2008 16:16'!
icon
     (Smalltalk classNamed: #HODataBase) ifNil: [^nil].
     OBPackageBrowser dynamicBrowser ifFalse:  [^nil].
    ^((Smalltalk at: #HODataBase) default analyzedClasses anySatisfy: [:class | self realClasses includes: class]) ifTrue: [#flag] ifFalse: [#blank]! !

!OBMonticelloClassCategoryNode methodsFor: 'displaying' stamp: 'dr 7/16/2007 14:24'!
indentedName
    | indent |
    indent := '    '.
    ^indent, self name! !

!OBMonticelloClassCategoryNode methodsFor: 'testing' stamp: 'dr 7/16/2007 10:33'!
isDescendantOf: packageNode 
	^ (packageNode isKindOf: OBMonticelloPackageNode) 
		and: [packageNode classCategories includes: self name]! !

!OBMonticelloClassCategoryNode methodsFor: 'testing' stamp: 'dr 5/2/2007 15:13'!
isDescendantOfClass: other
     ^false! !

!OBMonticelloClassCategoryNode methodsFor: 'testing' stamp: 'dr 2/7/2008 12:08'!
isInstrumented
    ^self classes allSatisfy: [:ea | ea isInstrumented]! !

!OBMonticelloClassCategoryNode methodsFor: 'accessing' stamp: 'dr 12/18/2007 16:46'!
mcPackage
    ^mcPackage! !

!OBMonticelloClassCategoryNode methodsFor: 'accessing' stamp: 'dr 12/18/2007 16:46'!
mcPackage: aMCPackage
    mcPackage := aMCPackage! !

!OBMonticelloClassCategoryNode methodsFor: 'accessing' stamp: 'dr 10/17/2007 12:12'!
realClasses
    ^self classNames collect: [:ea | environment at: ea] ! !

PluggableListMorphOfMany subclass: #OBPluggableListMorphOfMany
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Morphs'!

!OBPluggableListMorphOfMany methodsFor: 'list management' stamp: 'dr 8/21/2007 15:20'!
iconAt: index
	^ model iconAt: index! !

!OBPluggableListMorphOfMany methodsFor: 'list management' stamp: 'dr 6/7/2007 15:53'!
listMorphClass
    ^OBLazyListMorph! !

!OBPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'dr 11/30/2007 10:51'!
mouseDown: evt
	| selectors row oldIndex oldVal |
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].
	row _ self rowAtLocation: evt position.
	row = 0  ifTrue: [^super mouseDown: evt].
	"self dragEnabled ifTrue: [aMorph highlightForMouseDown]."
	
	model okToChange ifFalse: [^ self].  "No change if model is locked"

	"Set meaning for subsequent dragging of selection"
	dragOnOrOff _ (self listSelectionAt: row) not.
	oldIndex _ self getCurrentSelectionIndex.
	oldIndex ~= 0 ifTrue: [oldVal _ self listSelectionAt: oldIndex].

	"Set or clear new primary selection (listIndex)"
	dragOnOrOff
		ifTrue: [self changeModelSelection: row]
		ifFalse: [self changeModelSelection: 0].

	"Need to restore the old one, due to how model works, and set new one."
	oldIndex ~= 0 ifTrue: [self listSelectionAt: oldIndex put: oldVal].
	self listSelectionAt: row put: dragOnOrOff.	
	
	selectors _ Array 
		with: nil"#click:"
		with: (doubleClickSelector ifNotNil:[#doubleClick:])
		with: nil
		with: (self dragEnabled ifTrue:[#startDrag:] ifFalse:[nil]).
	evt hand waitForClicksOrDrag: self event: evt selectors: selectors threshold: 10 ! !

!OBPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'dr 11/30/2007 10:44'!
mouseMove: evt

	| oldIndex oldVal row |
	(self dropEnabled and: [evt hand hasSubmorphs]) 
		ifFalse:[^super mouseMove: evt].
	potentialDropRow ifNotNil:[
		potentialDropRow = (self rowAtLocation: evt position)
			ifTrue:[^self].
	].
	self mouseLeaveDragging: evt.
	(self containsPoint: evt position) 
		ifTrue:[self mouseEnterDragging: evt].
		
	"Set meaning for subsequent dragging of selection"
	oldIndex := self getCurrentSelectionIndex.
	oldIndex ~= 0 ifTrue: [oldVal := self listSelectionAt: oldIndex].

     row _ self rowAtLocation: evt position.
	"Set or clear new primary selection (listIndex)"
	dragOnOrOff 
		ifTrue: [self changeModelSelection: row]
		ifFalse: [self changeModelSelection: 0].

	"Need to restore the old one, due to how model works, and set new one."
	oldIndex ~= 0 ifTrue: [self listSelectionAt: oldIndex put: oldVal].
	self listSelectionAt: row put: dragOnOrOff.
	row changed	! !

!OBPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'dr 11/30/2007 11:18'!
mouseUp: event 
	"The mouse came up within the list; take appropriate action"
	| row |
	row := self rowAtLocation: event position.
	"aMorph ifNotNil: [aMorph highlightForMouseDown: false]."
	model okToChange
		ifFalse: [^ self].
	"No change if model is locked"
	
	dragOnOrOff _ nil.  "So improperly started drags will have not effect"	
	
	"row == self selectionIndex
		ifTrue: [(autoDeselect ifNil: [true]) ifTrue:[row == 0 ifFalse: [self changeModelSelection: 0] ]]
		ifFalse: [self changeModelSelection: row]."
	Cursor normal show! !

!OBPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'dr 2/8/2008 10:00'!
specialKeyPressed: asciiValue
	"A special key with the given ascii-value was pressed; dispatch it"

	| oldSelection result |
	oldSelection _ self getCurrentSelectionIndex.
	result := super specialKeyPressed: asciiValue.	
	self listSelectionAt: oldSelection put: false.
	^result! !

!OBColumnPanel methodsFor: '*ob-enhancements' stamp: 'dr 5/29/2007 10:36'!
definitionPanel
    ^browser definitionPanel! !

OBColumnPanel subclass: #OBEnhancementColumnPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBEnhancementColumnPanel methodsFor: 'search integration' stamp: 'dr 3/11/2008 11:05'!
addSearchToSmartGroup: aSearchNode
    | alias |
    alias := self smartGroup addSearchNode: aSearchNode.
    columns first switch selection: 2.
    alias jumpIn: self.! !

!OBEnhancementColumnPanel methodsFor: 'selecting' stamp: 'dr 2/14/2008 15:34'!
autoSelect: aColumn 
	aColumn next ifNotNilDo: 
		[:next | next autoSelect].! !

!OBEnhancementColumnPanel methodsFor: 'accessing columns' stamp: 'dr 2/26/2008 15:51'!
changeRootNode: aNode 
	| metaNode |
	metaNode _ browser class defaultMetaNode.
	metaNode addFilter: (OBClassHierarchyFilter columnPanel: self).	
	self changeRootNode: aNode metaNode: metaNode.! !

!OBEnhancementColumnPanel methodsFor: 'accessing columns' stamp: 'dr 3/5/2008 16:19'!
changeRootNode: aNode metaNode: aMetaNode
	| firstColumn  |	
	root := aNode.
     root metaNode: aMetaNode.
	
	firstColumn := columns first.
	firstColumn clear.
	firstColumn basicParent: aNode.		
     self clearAfter: firstColumn.
     self jumpTo: aNode.! !

!OBEnhancementColumnPanel methodsFor: 'accessing columns' stamp: 'dr 2/14/2008 15:02'!
columnClass
    ^OBEnhancementColumn! !

!OBEnhancementColumnPanel methodsFor: 'accessing columns' stamp: 'dr 2/14/2008 15:02'!
emptyColumn
	^self columnClass inPanel: self! !

!OBEnhancementColumnPanel methodsFor: 'accessing columns' stamp: 'dr 3/20/2008 13:14'!
setMetaNode: aMetaNode node: aNode 
	root := aNode.
	root metaNode: aMetaNode.
	self pushColumn: (self columnClass inPanel: self metaNode: aMetaNode node: root).

	minPanes - self columns size 
		timesRepeat: [self pushColumn: self emptyColumn].
	
	browser class isHierarchyBrowser ifTrue: [
		aMetaNode addFilter: (OBClassHierarchyFilter columnPanel: self).
		columns first useDoubleClick]
	   ifFalse: [columns second useDoubleClick].! !

!OBEnhancementColumnPanel methodsFor: 'accessing columns' stamp: 'dr 2/29/2008 10:46'!
shrinkToMaxPanes: anInteger! !

OBEnhancementColumnPanel subclass: #OBMultipleSelectionColumnPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

!OBMultipleSelectionColumnPanel methodsFor: 'accessing columns' stamp: 'dr 2/14/2008 12:09'!
columnClass
     | columnClass methodColumnIdx |
     columnClass _ OBEnhancementColumn.

     browser class useMultipleSelection ifTrue: [
	    methodColumnIdx _ browser class methodColumnIndex.    
         self columns size = (methodColumnIdx - 1) ifTrue: [columnClass _ OBMultipleSelectionColumn].
     ].
	^columnClass! !

!OBMultipleSelectionColumnPanel methodsFor: 'accessing columns' stamp: 'dr 2/14/2008 12:09'!
emptyColumn
	^self columnClass inPanel: self! !

!OBMultipleSelectionColumnPanel methodsFor: 'initializing' stamp: 'dr 2/14/2008 12:09'!
setMetaNode: aMetaNode node: aNode 
	root _ aNode.
	root metaNode: aMetaNode.
	self pushColumn: (self columnClass inPanel: self metaNode: aMetaNode node: root).
	minPanes - self columns size 
		timesRepeat: [self pushColumn: self emptyColumn]! !

OBMultipleSelectionColumnPanel subclass: #OBSmartGroupColumnPanel
	instanceVariableNames: 'smartGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

OBSmartGroupColumnPanel class
	instanceVariableNames: 'smartGroup'!

OBSmartGroupColumnPanel class
	instanceVariableNames: 'smartGroup'!

!OBSmartGroupColumnPanel methodsFor: 'navigating' stamp: 'dr 8/22/2007 16:19'!
selectSubtree: aSubtree
	| myColumns |
	myColumns_ smartGroup ifNil: [columns] ifNotNil: [columns allButFirst].
	aSubtree selectInColumns: myColumns! !

!OBSmartGroupColumnPanel methodsFor: 'updating' stamp: 'dr 3/1/2008 16:50'!
selectionChanged: ann
     ann node ifNotNilDo: [:node | node isSmartGroupCategory ifTrue: [^self]].
     super selectionChanged: ann.! !

!OBSmartGroupColumnPanel methodsFor: 'initializing' stamp: 'dr 3/1/2008 16:51'!
setMetaNode: aMetaNode node: aNode 
	| metaNode |
	columns := OrderedCollection new.
     maxPanes := browser class maxPanes.

	metaNode := aMetaNode.
	metaNode name = 'SmartGroup' ifTrue: [
	    metaNode := (aMetaNode children detect: [:ea | ea name = 'Environment']).	
	    smartGroup := OBSmartRootNode default.
	    smartGroup panel: self.
	    self columns addLast: (OBSmartGroupColumn 
				inPanel: self
				metaNode: aMetaNode
				node: smartGroup).		
	].
	root := aNode.
	root metaNode: metaNode.
	
	self columns addLast: (self columnClass inPanel: self metaNode: metaNode node: root).
	minPanes - self columns size 
		timesRepeat: [self columns addLast: self emptyColumn].
		
	self changed: #columns.! !

!OBSmartGroupColumnPanel methodsFor: 'accessing' stamp: 'dr 3/1/2008 17:06'!
smartGroup
    ^OBSmartRootNode default! !

OBSendersBrowser subclass: #OBDynamicSendersBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBDynamicSendersBrowser class methodsFor: 'configuration' stamp: 'dr 10/5/2007 17:17'!
chasingBrowsers
    ^false! !

!OBDynamicSendersBrowser class methodsFor: 'configuration' stamp: 'dr 10/5/2007 16:41'!
defaultMetaNode
	^self sendersNav: #dynamicSenders! !

!OBDynamicSendersBrowser class methodsFor: 'configuration' stamp: 'dr 10/5/2007 16:40'!
title
	^'Dynamic Senders of'! !

!MCWorkingCopy methodsFor: '*ob-enhancements' stamp: 'dr 12/10/2007 10:14'!
asNode
    ^OBMonticelloPackageNode on: self! !

!OBPaneScroller methodsFor: '*ob-enhancements' stamp: 'dr 2/19/2008 17:28'!
addPaneSplitters
	| splitter remaining target targetX sameX minY maxY targetY sameY minX maxX |
	self removePaneSplitters.
	self removeCornerGrips. self halt.
	remaining _ transform submorphs reject: [ : each | each layoutFrame rightFraction = 1 ].
	[ remaining notEmpty ] whileTrue: 
		[ target _ remaining first.
		targetX _ target layoutFrame rightFraction.
		sameX _ transform submorphs select: [ : each | each layoutFrame rightFraction = targetX ].
		minY _ (sameX detectMin: [ : each | each layoutFrame topFraction ]) layoutFrame topFraction.
		maxY _ (sameX detectMax: [ : each | each layoutFrame bottomFraction ]) layoutFrame bottomFraction.
		splitter _ ProportionalSplitterMorph new.
		splitter layoutFrame: (LayoutFrame 
				fractions: (targetX @ minY corner: targetX @ maxY)
				offsets: ((0 @ (target layoutFrame topOffset ifNil: [ 0 ]) corner: 4 @ (target layoutFrame bottomOffset ifNil: [ 0 ])) translateBy: (target layoutFrame rightOffset ifNil: [ 0 ]) @ 0)).
		transform addMorphBack: (splitter position: self position).
		remaining _ remaining copyWithoutAll: sameX ].
	remaining _ transform submorphs copy reject: [ : each | each layoutFrame bottomFraction = 1 ].
	[ remaining notEmpty ] whileTrue: 
		[ target _ remaining first.
		targetY _ target layoutFrame bottomFraction.
		sameY _ transform submorphs select: [ : each | each layoutFrame bottomFraction = targetY ].
		minX _ (sameY detectMin: [ : each | each layoutFrame leftFraction ]) layoutFrame leftFraction.
		maxX _ (sameY detectMax: [ : each | each layoutFrame rightFraction ]) layoutFrame rightFraction.
		splitter _ ProportionalSplitterMorph new
			beSplitsTopAndBottom ;
			yourself.
		splitter layoutFrame: (LayoutFrame 
				fractions: (minX @ targetY corner: maxX @ targetY)
				offsets: (((target layoutFrame leftOffset ifNil: [ 0 ]) @ 0 corner: (target layoutFrame rightOffset ifNil: [ 0 ]) @ 4) translateBy: 0 @ (target layoutFrame bottomOffset ifNil: [ 0 ]))).
		transform addMorphBack: (splitter position: self position).
		remaining _ remaining copyWithoutAll: sameY ].
	self linkSubmorphsToSplitters. 
	self splitters do: [ : each | each comeToFront ]! !

!OBPaneScroller methodsFor: '*ob-enhancements' stamp: 'dr 2/19/2008 11:11'!
linkSubmorphsToSplitters

	self splitters do:
		[:each |
		each splitsTopAndBottom
			ifTrue:
				[transform submorphsDo:
					[:eachMorph |
					(eachMorph ~= each and: [eachMorph layoutFrame bottomFraction = each layoutFrame topFraction]) ifTrue: [each addLeftOrTop: eachMorph].
					(eachMorph ~= each and: [eachMorph layoutFrame topFraction = each layoutFrame bottomFraction]) ifTrue: [each addRightOrBottom: eachMorph]]]
			ifFalse:
				[transform submorphsDo:
					[:eachMorph |
					(eachMorph ~= each and: [eachMorph layoutFrame rightFraction = each layoutFrame leftFraction]) ifTrue: [each addLeftOrTop: eachMorph].
					(eachMorph ~= each and: [eachMorph layoutFrame leftFraction = each layoutFrame rightFraction]) ifTrue: [each addRightOrBottom: eachMorph]]]]! !

!OBPaneScroller methodsFor: '*ob-enhancements' stamp: 'dr 2/19/2008 11:23'!
removeCornerGrips

	| corners |
	corners _ transform submorphsSatisfying: [:each | each isKindOf: CornerGripMorph].
	corners do: [:each | each delete]! !

!OBPaneScroller methodsFor: '*ob-enhancements' stamp: 'dr 2/19/2008 11:24'!
splitters

	^ transform submorphsSatisfying: [:each | each isKindOf: ProportionalSplitterMorph]! !

!OBClassSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 3/4/2008 17:31'!
isDescendantOfClassCat: aClassCategoryNode
    ^true! !

!OBClassSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 2/7/2008 17:10'!
isEnrichedDefinition
    ^false! !

OBMetagraphBuilder subclass: #OBEnhancementMetagraphBuilder
	instanceVariableNames: 'updateOnAutoSelect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

OBEnhancementMetagraphBuilder subclass: #OBDynamicMetagraphBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBDynamicMetagraphBuilder methodsFor: 'private' stamp: 'dr 11/12/2007 11:01'!
populateClassNode
     super populateClassNode.
	(self classMetaNode)
		addFilter: OBClassAnnotationFilter new! !

!OBDynamicMetagraphBuilder methodsFor: 'private' stamp: 'dr 11/19/2007 16:42'!
populateMetaclassNode
     super populateMetaclassNode.
	(self metaclassMetaNode)
		addFilter: OBClassAnnotationFilter new! !

!OBDynamicMetagraphBuilder methodsFor: 'private' stamp: 'dr 11/12/2007 11:06'!
populateMethodNode
	self methodMetaNode 
		ancestrySelector: #isDescendantOfMethod:;
		addFilter: OBDynamicInheritanceFilter new! !

!OBEnhancementMetagraphBuilder methodsFor: 'accessing - metanodes' stamp: 'dr 2/14/2008 15:59'!
lastSelectionMetaNode 
    ^ (self metaNodes
		at: #LastSelection
		ifAbsentPut: [OBEnhancementMetaNode named: #LastSelection]) updateOnAutoSelect! !

!OBEnhancementMetagraphBuilder methodsFor: 'private' stamp: 'dr 2/14/2008 15:58'!
populateAllMethodCategoryNode
     super populateAllMethodCategoryNode.
	(self allMethodCategoryMetaNode) childAt: #lastSelection put: self lastSelectionMetaNode;
	                                        autoSelect: self lastSelectionMetaNode! !

!OBEnhancementMetagraphBuilder methodsFor: 'private' stamp: 'dr 3/13/2008 16:51'!
populateClassCommentNode
	(self classCommentMetaNode)
	     ancestrySelector: #isDescendantOfClass:;
		addFilter: OBClassInheritanceFilter new! !

!OBEnhancementMetagraphBuilder methodsFor: 'private' stamp: 'dr 2/20/2008 10:37'!
populateClassNode
     super populateClassNode.
	(self classMetaNode)
		addFilter: OBClassInheritanceFilter new! !

!OBEnhancementMetagraphBuilder methodsFor: 'private' stamp: 'dr 2/20/2008 10:42'!
populateMetaclassNode
     super populateMetaclassNode.
	(self metaclassMetaNode)
		addFilter: OBClassInheritanceFilter new! !

OBCmdBrowseHierarchy subclass: #OBEnhancementCmdBrowseHierarchy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBEnhancementCmdBrowseHierarchy methodsFor: 'execution' stamp: 'dr 2/15/2008 17:58'!
execute
     | browserClass |
     browserClass := OBCodeBrowser defaultHierarchyBrowserClass.
     target isMethodNode ifTrue: [browserClass openOnClass: target theClass selector: target selector] 
                             ifFalse: [browserClass openOnClass: target theClass] ! !

!OBMessageNode class methodsFor: '*ob-enhancements' stamp: 'dr 2/15/2008 15:39'!
enhancedOn: aSelector inMethodReference: ref
     | class |
     class _ ref isInstrumented ifTrue: [OBEnrichedMessageNode] ifFalse: [self].
	^ class 
		on: aSelector 
		inMethod: ref methodSymbol
		inClass: ref actualClass! !

!OBCmdBrowseHierarchyImplementors methodsFor: '*ob-enhancements' stamp: 'dr 11/16/2007 11:19'!
implementorsSelector
    ^#hierarchyImplementorsOf:! !

OBCmdBrowse subclass: #OBCmdSmartGroupBrowse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBCmdSmartGroupBrowse methodsFor: 'as yet unclassified' stamp: 'dr 3/12/2008 15:36'!
isActive
    ^super isActive and: [target isBrowseable]! !

OBBrowseRequest subclass: #OBEnhancementBrowseRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBEnhancementBrowseRequest methodsFor: 'dispatching' stamp: 'dr 2/16/2008 15:43'!
handleBrowseRequestWithExtent: anObject! !

!OBEnhancementBrowseRequest methodsFor: 'dispatching' stamp: 'dr 2/16/2008 15:43'!
handleWith: anObject
	^ anObject handleBrowseRequestWithExtent: self! !

OBListBrowser subclass: #OBDynamicReferenceBrowser
	instanceVariableNames: 'browseHistory historyCursor historyIndexOnSwitch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBDynamicReferenceBrowser class methodsFor: 'configuration' stamp: 'dr 2/21/2008 14:53'!
defaultMetaNode
	| class referencingClasses referencingMethods |
	class _ OBMetaNode named: 'Class'.
	referencingClasses _ OBMetaNode named: 'Dyamic references'.
	referencingMethods _ OBMetaNode named: 'ReferencingMethods'.
	
	class childAt: #referencingClasses put: referencingClasses.
	
	referencingClasses 
	    childAt: #referencingMethods put: referencingMethods;
	    ancestrySelector: #isDescendantOfClassRef:.
	
	referencingMethods 
		displaySelector: #usageName;
		ancestrySelector: #isDescendantOfMethod:;
		addFilter: OBDynamicInheritanceFilter new.
		
	^ class! !

!OBDynamicReferenceBrowser class methodsFor: 'configuration' stamp: 'dr 11/12/2007 10:29'!
definitionPanel
     ^OBEnrichedDefinitionPanel new! !

!OBDynamicReferenceBrowser class methodsFor: 'configuration' stamp: 'dr 2/27/2008 15:43'!
hasHistoryButtons
    ^true! !

!OBDynamicReferenceBrowser class methodsFor: 'configuration' stamp: 'dr 10/9/2007 17:03'!
title
   ^'Dynamic references in'! !

!OBDynamicReferenceBrowser methodsFor: 'history' stamp: 'dr 2/23/2008 16:30'!
browseHistory
    browseHistory ifNil: [browseHistory _ OrderedCollection new].
    ^browseHistory! !

!OBDynamicReferenceBrowser methodsFor: 'accessing' stamp: 'dr 9/10/2007 11:55'!
defaultLabel
	^ self labelPrefix, ' ', self root name asString! !

!OBDynamicReferenceBrowser methodsFor: 'history' stamp: 'dr 2/23/2008 16:32'!
historyAtCursor
   ^self browseHistory at: self historyCursor ifAbsent: [nil]! !

!OBDynamicReferenceBrowser methodsFor: 'history' stamp: 'dr 2/23/2008 16:32'!
historyCursor
    ^historyCursor ifNil: [0]! !

!OBDynamicReferenceBrowser methodsFor: 'history' stamp: 'dr 2/23/2008 16:31'!
historyCursor: anInteger
    historyCursor _ anInteger! !

!OBDynamicReferenceBrowser methodsFor: 'history' stamp: 'dr 2/26/2008 16:25'!
historyIndexOnSwitch
    historyIndexOnSwitch ifNil: [historyIndexOnSwitch _ 0].
    ^historyIndexOnSwitch! !

!OBDynamicReferenceBrowser methodsFor: 'history' stamp: 'dr 2/26/2008 16:25'!
resetHistoryIndexOnSwitch
    historyIndexOnSwitch _ 0! !

!OBDynamicReferenceBrowser methodsFor: 'history' stamp: 'dr 2/23/2008 16:31'!
setHistory: aCollection
    browseHistory _ aCollection! !

!OBListBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/11/2008 10:34'!
definitionPanel
     ^OBDefinitionPanel new! !

!OBListBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:37'!
hasReferencePanel
    ^self dynamicBrowser! !

!OBAllMethodCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 10/16/2007 15:21'!
icon
    ^#blank! !

!OBAllMethodCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 2/14/2008 11:55'!
lastSelection
    ^#()
! !

OBAllMethodCategoryNode subclass: #OBAllMethodExtensionCategoryNode
	instanceVariableNames: 'classExtensionNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBAllMethodExtensionCategoryNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 15:23'!
classExtensionNode
    ^classExtensionNode! !

!OBAllMethodExtensionCategoryNode methodsFor: 'accessing' stamp: 'dr 3/3/2008 15:06'!
classExtensionNode: aClassExtensionNode 
    classExtensionNode := aClassExtensionNode! !

!OBAllMethodExtensionCategoryNode methodsFor: 'accessing' stamp: 'dr 3/3/2008 15:11'!
extensionName
	^classExtensionNode extensionName ! !

!OBAllMethodExtensionCategoryNode methodsFor: 'ancestry' stamp: 'dr 3/3/2008 15:39'!
isDescendantOfClass: aClassNode 
   ^((super isDescendantOfClass: aClassNode) and: [aClassNode isKindOf: OBClassExtensionNode]) 
                                                    and: [self classExtensionNode = aClassNode] ! !

!OBAllMethodExtensionCategoryNode methodsFor: 'ancestry' stamp: 'dr 3/3/2008 17:23'!
isDescendantOfClassCat: aClassCategoryNode
	(aClassCategoryNode isKindOf: OBMonticelloPackageNode) ifFalse: [^false].
	aClassCategoryNode = self classExtensionNode package ifFalse: [^false]. 
	^(aClassCategoryNode extensionClasses collect: [:ea | ea theNonMetaClass]) includes: self theNonMetaClass.
! !

!OBAllMethodExtensionCategoryNode methodsFor: 'ancestry' stamp: 'dr 2/24/2008 15:27'!
isDescendantOfMethodCat: other
   ^(super isDescendantOfMethodCat: other) and: [self class = other class]! !

!OBAllMethodExtensionCategoryNode methodsFor: 'navigating' stamp: 'dr 2/24/2008 14:00'!
methodReferences
	^ self theClass selectors asSortedArray 
		collect: [:ea | MethodExtensionReference new setStandardClass: self theClass methodSymbol: ea; categoryExtensionNode: self]! !

!OBAllMethodExtensionCategoryNode methodsFor: 'navigating' stamp: 'dr 2/24/2008 15:22'!
methods
   ^self methodReferences collect: [:ea | (OBMethodExtensionNode on: ea) categoryExtensionNode: self; yourself]! !

!OBNode methodsFor: '*ob-enhancements' stamp: 'dr 2/29/2008 10:19'!
annotationString
	"Provide a line of content for an annotation pane, representing information about the method associated with the selected node."
	
	^ nil! !

!OBNode methodsFor: '*ob-enhancements' stamp: 'dr 3/12/2008 15:31'!
isBrowseable
    ^true! !

!OBMercuryQuery methodsFor: '*ob-enhancements' stamp: 'dr 3/4/2008 16:07'!
openSearchInSameBrowserOn: searchNode 
	^ self browser isSearchBrowser 
		ifFalse: [(OBSearchBrowser with: searchNode) open]
		ifTrue: 
			["self browser navigationPanel shrinkToMaxPanes: 4."
			"self browser navigationPanel changeRootNode: OBSearchBrowser defaultRootNode 
			                                    metaNode: OBSearchBrowser defaultMetaNode."
			self browser navigationPanel addSearchToSmartGroup: self searchNode.
			"self browser markSwitch.
			self browser root addChild: searchNode."
			(self announce: OBAboutToChange) isVetoed 
				ifTrue: [self browser noteChanges]
				ifFalse: ["self announce: (OBSelectingNode node: searchNode)"]]! !

OBClassDefinition subclass: #OBEnrichedClassDefinition
	instanceVariableNames: 'formatter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBEnrichedClassDefinition methodsFor: 'accessing' stamp: 'dr 11/17/2007 15:49'!
formatter
    ^formatter! !

!OBEnrichedClassDefinition methodsFor: 'accessing' stamp: 'dr 11/17/2007 15:58'!
isEnrichedDefinition
    ^true! !

!OBEnrichedClassDefinition methodsFor: 'accessing' stamp: 'dr 11/17/2007 15:49'!
setFormatter: aHOFormatter
    formatter := aHOFormatter! !

!OBEnrichedClassDefinition methodsFor: 'accessing' stamp: 'dr 11/17/2007 16:56'!
text
    ^formatter formatClassDefinition! !

!OBRadioButtonBar methodsFor: '*ob-enhancements' stamp: 'dr 1/28/2008 11:38'!
buttons
    ^buttons! !

OBDefinitionPanel subclass: #OBClosableDefinitionPanel
	instanceVariableNames: 'node morph isPinned owner contentMorph codeTabPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/8/2007 15:54'!
asDraggableMorph
	^(StringMorph contents: '*')
		color: Color white;
		yourself! !

!OBClosableDefinitionPanel methodsFor: 'building' stamp: 'dr 7/18/2007 15:25'!
buildOn: aBuilder
    morph ifNil: [morph := aBuilder closableDefinitionPanel: self with: []].
    ^morph! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 12/6/2007 11:48'!
changeToSourceCodePanel
    self exchangeContentWith: self createContentMorph.! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 7/23/2007 14:41'!
changed
    (self respondsTo: #codeTabPanel) ifTrue: [
	     self codeTabPanel selection = 1 ifFalse: [self codeTabPanel selection: 1]].! !

!OBClosableDefinitionPanel methodsFor: 'class selecting' stamp: 'dr 5/29/2007 11:25'!
classLabel
	| classLabel |
	classLabel := self className.
	self node ifNotNil: [self node isMethodHolderNode ifTrue: [classLabel := classLabel,' >>']].
	^classLabel! !

!OBClosableDefinitionPanel methodsFor: 'class selecting' stamp: 'dr 5/29/2007 11:25'!
className
     ^self methodClass ifNotNil: [self methodClass name] ifNil: ['']! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 5/29/2007 11:26'!
close
   browser definitionPanel panels size < 2 ifTrue: [^self inform: 'You cannot close the last panel.'].
   browser definitionPanel removePanel: self column: nil.! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 5/29/2007 11:26'!
closeLabel
	^ (StringMorph 
		contents: 'x'
		font: ("TextStyle defaultFont" StrikeFontSet familyName: 'Accouny14' size: 10))
			color: Color red;
			yourself! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 6/22/2007 16:49'!
color
	^browser defaultBackgroundColor ! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 6/22/2007 16:45'!
commands
	| myNode |
	myNode _ self currentNode.
	myNode ifNil: [^ #()].
     ^{OBCmdSystemComplexity on: myNode for: self. OBCmdUmlDiagram on: myNode for: self}
    ! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 7/12/2007 13:55'!
createClassLabel
	| classLabel |		
     classLabel := (StringMorph 
		contents: (Text string: self classLabel attribute: TextEmphasis bold)	
		font: (StrikeFontSet familyName: #NewYork size: 10))
			color: Color black;
			yourself.
	classLabel on: #mouseDown send: #selectClass to: self.			
	classLabel hResizing: #spaceFill; vResizing: #spaceFill; setWidth: 100; height: 20.						
			
	^classLabel		! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/5/2007 17:45'!
createCloseButton						
	^PluggableButtonMorph
		on: self
		getState: #isSelected
		action: #close
		label: #closeLabel.! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 11/19/2007 10:26'!
createContentMorph
	| textEditor shoutInstalled morphClass |
	shoutInstalled := (Smalltalk classNamed: #SHTextStylerST80) notNil.
	morphClass := shoutInstalled 
				ifTrue: [OBPluggableTextMorphWithShout]
				ifFalse: [OBPluggableTextMorph].	
	textEditor := (morphClass
		on: self
		text: #text
		accept: #accept:notifying:
		readSelection: #selection
		menu: #menu:shifted:)
		font: Preferences standardCodeFont;
		yourself.
	textEditor 
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderWidth: 0;
		color: Color white.
     ^textEditor! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/12/2007 15:20'!
createDragButton
	| dragButton paneColor |
	dragButton := OBDraggableButtonMorph 
				on: self
				getState: #isDragged
				action: #drag
				label: #dragLabel.
	dragButton enableDragNDrop.
	paneColor := browser defaultBackgroundColor.
	dragButton onColor: Color lightGray lighter offColor: paneColor.
	^ dragButton! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 7/19/2007 14:05'!
createMorph			
     morph := nil.						
	^self buildOn: OBMorphBuilder new		! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/12/2007 15:20'!
createPinButton
	| pinButton paneColor |
	pinButton := OBDraggableButtonMorph 
				on: self
				getState: #isPinned
				action: #pin
				label: #pinLabel.
	paneColor := browser defaultBackgroundColor.
	pinButton onColor: Color lightGray lighter offColor: paneColor.
	^ pinButton! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 6/11/2007 11:48'!
createTitleBar
	| titleBar |		
	titleBar := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		borderWidth: 0;
		"borderColor: Color black;"
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.
			
	titleBar addMorphBack: self createClassLabel; 
	          addMorphBack: self createDragButton; 
	          addMorphBack: self createPinButton; 
	          addMorphBack: self createCloseButton.			
	^titleBar		! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/29/2007 15:50'!
currentNode
    ^self node ifNil: [super currentNode]! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 16:00'!
currentOrRootNode
    ^self node ifNil: [super currentOrRootNode]! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 6/11/2007 11:47'!
drag
    "do nothing"! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 6/11/2007 11:49'!
dragLabel
	^ (StringMorph 
		contents: '<- ->'
		font: (StrikeFontSet familyName: 'Accouny14' size: 10))
			color: Color red;
			yourself! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/11/2007 15:43'!
dropMorph: aMorph
    | panelToBeMoved |
    panelToBeMoved := aMorph passenger.

    (self isPlacedBefore: panelToBeMoved) ifTrue: [
	   panelToBeMoved insertBefore: self. 
    ] ifFalse: [
        panelToBeMoved insertAfter: self.
    ].! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 12/6/2007 11:47'!
exchangeContentWith: aMorph
    morph removeMorph: contentMorph. 
    aMorph vResizing: #spaceFill. 
    aMorph hResizing: #spaceFill.
    contentMorph := aMorph. 
    morph addMorphBack: contentMorph.
    contentMorph changed.! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 10/19/2007 11:34'!
getDefinition
     definition ifNotNil: [^definition]. 
	^ browser currentNode ifNotNilDo: [:ea | ea definition]! !

!OBClosableDefinitionPanel methodsFor: 'testing' stamp: 'dr 7/18/2007 15:32'!
hasSeveralPanels	
	^browser definitionPanel panels size > 1! !

!OBClosableDefinitionPanel methodsFor: 'initializing' stamp: 'dr 6/7/2007 11:20'!
initialize
    isPinned := false! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/8/2007 16:33'!
insertAfter: aPanel
    ^self owner insert: self after: aPanel! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/11/2007 15:44'!
insertBefore: aPanel
    ^self owner insert: self before: aPanel! !

!OBClosableDefinitionPanel methodsFor: 'testing' stamp: 'dr 6/7/2007 11:36'!
isChangeable
    ^self isPinned not! !

!OBClosableDefinitionPanel methodsFor: 'testing' stamp: 'dr 6/11/2007 11:47'!
isDragged
    ^false! !

!OBClosableDefinitionPanel methodsFor: 'testing' stamp: 'dr 6/6/2007 15:59'!
isPinned
    ^isPinned! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/11/2007 15:35'!
isPlacedBefore: aClosableDefinitionPanel
    ^self owner is: self placedBefore: aClosableDefinitionPanel! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 5/29/2007 11:26'!
isSelected
    ^false
   ! !

!OBClosableDefinitionPanel methodsFor: 'class selecting' stamp: 'dr 5/29/2007 11:25'!
methodClass
     ^(self node respondsTo: #theClass) ifTrue: [self node theClass] ifFalse: [nil]! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 7/18/2007 15:41'!
morph
	^morph
! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/29/2007 11:45'!
node
    ^node! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/29/2007 15:15'!
node: aNode
    node := aNode. 
    "self selectSourceTab."! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/8/2007 16:16'!
owner
	^owner! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/8/2007 16:16'!
owner: aMultipleDefinitionPanel
	owner := aMultipleDefinitionPanel! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 6/7/2007 11:50'!
pin
    self isPinned ifTrue: [isPinned := false] ifFalse: [isPinned := true] ! !

!OBClosableDefinitionPanel methodsFor: 'buttons' stamp: 'dr 6/6/2007 15:20'!
pinLabel
	^ (StringMorph 
		contents: '!!'
		font: (StrikeFontSet familyName: 'Accouny14' size: 10))
			color: Color red;
			yourself! !

!OBClosableDefinitionPanel methodsFor: 'class selecting' stamp: 'dr 5/29/2007 11:25'!
selectClass
    browser jumpTo: (OBClassNode on: self methodClass)! !

!OBClosableDefinitionPanel methodsFor: 'tabs' stamp: 'dr 6/29/2007 16:31'!
selectSourceTab
    self exchangeContentWith: self createContentMorph.! !

!OBClosableDefinitionPanel methodsFor: 'updating' stamp: 'dr 2/28/2008 16:43'!
selectionChanged: ann
     self hasSeveralPanels ifTrue: [self updateClassLabel].
	self definition: self getDefinition! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 7/18/2007 15:35'!
setContentMorph: aMorph
    contentMorph := aMorph! !

!OBClosableDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/6/2007 15:59'!
setIsPinned
    isPinned := true! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 11/19/2007 10:56'!
shoutAboutToStyle: aPluggableShoutMorph
	|  myNode classOrMetaClass |

	myNode := self currentNode.
	((myNode isKindOf: OBMethodNode) or: [(myNode isKindOf: OBMethodVersionNode) or:[myNode isKindOf: OBMethodCategoryNode]])
		ifTrue:[
			classOrMetaClass := myNode theClass.
			(classOrMetaClass isBehavior or:[classOrMetaClass isTrait]) ifFalse:[classOrMetaClass := nil].
			aPluggableShoutMorph classOrMetaClass: classOrMetaClass. 
			^true].
	(((myNode isKindOf: OBClassNode) or: [(myNode isKindOf: OBClassCategoryNode)]) or: [(myNode isKindOf: OBMonticelloPackageNode)]) 
		ifTrue:[
			aPluggableShoutMorph classOrMetaClass: nil.
			^true].
	^false! !

!OBClosableDefinitionPanel methodsFor: 'updating' stamp: 'dr 2/19/2008 09:58'!
subscribe
	self announcer 
		observe: OBAboutToChange
		send: #aboutToChange:
		to: self;
		
		observe: OBAboutToChangeSilently
		send: #aboutToChangeSilently:
		to: self;
		
		observe: OBSelectionChanged
		send: #selectionChanged:
		to: self;
				
		observe: OBNodeChanged
		send: #nodeChanged:
		to: self;		
				
		observe: OBRefreshRequired
		send: #refresh:
		to: self.! !

!OBClosableDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/8/2007 16:19'!
swapWith: aPanel
    ^self owner swap: self with: aPanel! !

!OBClosableDefinitionPanel methodsFor: 'morphic' stamp: 'dr 2/29/2008 10:13'!
updateClassLabel
    | stringMorph |
    stringMorph _ morph submorphs first submorphs first.
    (stringMorph isKindOf: StringMorph) ifTrue: [stringMorph contents: self classLabel].! !

!OBDefinitionPanel methodsFor: '*ob-enhancements' stamp: 'dr 5/29/2007 15:39'!
currentNode
	^browser currentNode! !

!OBDefinitionPanel methodsFor: '*ob-enhancements' stamp: 'dr 7/19/2007 16:00'!
currentOrRootNode
	^browser currentOrRootNode! !

!OBDefinitionPanel methodsFor: '*ob-enhancements' stamp: 'dr 5/29/2007 15:39'!
node
	^nil! !

OBDefinitionPanel subclass: #OBEnhancementDefinitionPanel
	instanceVariableNames: 'codeTabPanel morph contentMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBEnhancementDefinitionPanel methodsFor: 'accessing' stamp: 'dr 2/22/2008 15:24'!
buildOn: aBuilder
	morph ifNil: [morph := aBuilder enrichedTextarea: self with: []].
	^morph! !

!OBEnhancementDefinitionPanel methodsFor: 'code tab panel' stamp: 'dr 2/22/2008 15:21'!
changeToSourceCodePanel
    self exchangeContentWith: self createContentMorph.! !

!OBEnhancementDefinitionPanel methodsFor: 'morphic' stamp: 'dr 2/22/2008 15:34'!
createContentMorph
	| textMorph |
	
	textMorph _ self textMorphClass 
				on: self
				text: #text
				accept: #accept:notifying:
				readSelection: #selection
				menu: #menu:shifted:. 
	textMorph
		font: Preferences standardCodeFont;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.	
     ^textMorph! !

!OBEnhancementDefinitionPanel methodsFor: 'accessing' stamp: 'dr 2/14/2008 10:56'!
definition: aDefinition
	aDefinition ifNotNil: [definition _ aDefinition]. 
	self changed: #text! !

!OBEnhancementDefinitionPanel methodsFor: 'code tab panel' stamp: 'dr 2/22/2008 15:23'!
exchangeContentWith: aMorph
    morph removeMorph: contentMorph. 
    aMorph vResizing: #spaceFill. 
    aMorph hResizing: #spaceFill.
    contentMorph := aMorph. 
    morph addMorphBack: contentMorph.
    contentMorph changed.! !

!OBEnhancementDefinitionPanel methodsFor: 'code tab panel' stamp: 'dr 3/6/2008 15:37'!
hasCodeTabPanel
   ^self respondsTo: #codeTabPanel! !

!OBEnhancementDefinitionPanel methodsFor: 'testing' stamp: 'dr 2/22/2008 15:24'!
hasReferencePanel
    ^browser class hasReferencePanel! !

!OBEnhancementDefinitionPanel methodsFor: 'code tab panel' stamp: 'dr 2/23/2008 17:12'!
selectSourceTab
    codeTabPanel ifNotNil: [codeTabPanel isSourceTabSelected ifFalse: [codeTabPanel selectFirst]].! !

!OBEnhancementDefinitionPanel methodsFor: 'updating' stamp: 'dr 4/10/2008 15:08'!
selectionChanged: ann
     | column |
     column _ ann column.
     "make sure that if the auto-selected node does not have a def, the def of the node selected in the previous column is taken"
     (column selectedNode notNil and: [column selectedNode getDefinition isNil]) ifTrue: [column previous ifNotNilDo: [:col | column _ col]].
	self definition: (column selectedNode ifNotNilDo: [:n | n getDefinition])! !

!OBEnhancementDefinitionPanel methodsFor: 'code tab panel' stamp: 'dr 2/22/2008 15:23'!
setContentMorph: aMorph
    contentMorph := aMorph! !

!OBEnhancementDefinitionPanel methodsFor: 'shout' stamp: 'dr 2/24/2008 15:48'!
shoutAboutToStyle: aPluggableShoutMorph
	|  node classOrMetaClass |

	node _ browser currentNode.
	((node isKindOf: OBMethodNode) or: [(node isKindOf: OBMethodVersionNode) or:[node isKindOf: OBMethodCategoryNode]])
		ifTrue:[
			classOrMetaClass _ node theClass.
			(classOrMetaClass isBehavior or:[classOrMetaClass isTrait]) ifFalse:[classOrMetaClass _ nil].
			aPluggableShoutMorph classOrMetaClass: classOrMetaClass. 
			^true].
	((node isKindOf: OBClassNode) or: [(node isKindOf: OBClassCategoryNode) or: [node isKindOf: OBMonticelloPackageNode]]) 
		ifTrue:[
			aPluggableShoutMorph classOrMetaClass: nil.
			^true].
	^false! !

!OBEnhancementDefinitionPanel methodsFor: 'configuration' stamp: 'dr 2/22/2008 15:34'!
textMorphClass
	| shoutInstalled |
	shoutInstalled _ (Smalltalk classNamed: #SHTextStylerST80) notNil.
	^shoutInstalled 
				ifTrue: [OBPluggableTextMorphWithShout]
				ifFalse: [OBPluggableTextMorph].! !

OBEnhancementDefinitionPanel subclass: #OBEnrichedDefinitionPanel
	instanceVariableNames: 'referenceList tmpText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBEnrichedDefinitionPanel commentStamp: 'dr 10/9/2007 17:10' prior: 0!
I am an enriched definition panel. The definition I contain is enriched with dynamic information about the method being displayed.!

!OBEnrichedDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 4/10/2008 15:09'!
accept: aText notifying: aController
    | attributes methodRef result formatter source |
    self currentNode isMethodNode ifTrue: [methodRef _ self currentNode reference].
 
    "remove all attributes from aText prior to save"
    attributes _ Set new.
    1 to: aText size do: [:i | attributes addAll: (aText attributesAt: i)].
    attributes do: [:attr | aText removeAttribute: attr from: 1 to: aText size].
    
    result _ super accept: aText notifying: aController.

    methodRef ifNotNil: [
    	   "this is cumbersome, but works ok"
        formatter _ RBFormatter new.
        source _ formatter format: methodRef compiledMethod methodNode.
        result _ super accept: source notifying: aController.

        "make sure an instrumented method is still instrumented after re-compile"
        (HODataBase default isInstrumentedMethod: methodRef) ifTrue: [
	       HOCollector default reinstallInMethod: methodRef compiledMethod.
        ].

        self currentNode updateMetaMethod.
        definition _ self currentNode definition. 
        self changed: #text.
    ].

    "update variable nodes with new nodes, because during re-compilation those nodes might have changed"
    "(HODataBase default modelMethodFor: methodRef) ifNotNilDo: [:method | method updateVariableNodes].
    self refresh: nil."

    ^result! !

!OBEnrichedDefinitionPanel methodsFor: 'accessing' stamp: 'dr 11/19/2007 11:26'!
formatter
    ^self getDefinition ifNotNilDo: [:def | def isEnrichedDefinition ifTrue: [def formatter]]! !

!OBEnrichedDefinitionPanel methodsFor: 'accessing' stamp: 'dr 4/4/2008 10:19'!
getDefinition
     definition ifNotNil: [^definition].
     ^super getDefinition! !

!OBEnrichedDefinitionPanel methodsFor: 'accessing' stamp: 'dr 10/2/2007 16:27'!
methodReference
    ^self currentNode reference! !

!OBEnrichedDefinitionPanel methodsFor: 'accessing' stamp: 'dr 1/28/2008 11:13'!
morph
    ^morph! !

!OBEnrichedDefinitionPanel methodsFor: 'accessing' stamp: 'dr 10/12/2007 17:02'!
referenceList
    referenceList ifNil: [referenceList := OBReferenceList panel: self].
    ^referenceList! !

!OBEnrichedDefinitionPanel methodsFor: 'highlighting' stamp: 'dr 1/18/2008 17:31'!
selectReferencingCodeNodes: aCollection
    | method formatter |
    method := self currentNode theClass compiledMethodAt: self currentNode selector.
    formatter := HOFormatter metaMethod: (HODataBase default modelMethodFor: method methodReference) referencedClass: self currentNode referencedClass.
    formatter setSelectedNodes: aCollection. 
    tmpText := (formatter formatCodeForMethod: method) makeSelectorBold.
    self changed: #text.
    tmpText := nil.! !

!OBEnrichedDefinitionPanel methodsFor: 'updating' stamp: 'dr 3/4/2008 14:57'!
selectionChanged: ann
	super selectionChanged: ann.
		
	self selectSourceTab. 
	
	self referenceList selectionChanged: ann.
	self referenceList referencedNode ifNotNilDo: [:n | 
		(self currentNode notNil and: [self currentNode respondsTo: #isMethodNode]) ifTrue: [
		(self currentNode isMethodNode and: [(Smalltalk at: #HODataBase) default isInstrumentedMethod: self currentNode reference]) ifTrue: [
		    self selectReferencingCodeNodes: ((Smalltalk at: #HODataBase) default nodesReferencingClass: n theClass inMethod: self currentNode reference)]]].! !

!OBEnrichedDefinitionPanel methodsFor: 'highlighting' stamp: 'dr 10/15/2007 15:30'!
text
    tmpText ifNotNil: [^tmpText].
    ^super text! !

!OBEnrichedDefinitionPanel methodsFor: 'configuration' stamp: 'dr 2/22/2008 15:34'!
textMorphClass
    ^OBEnrichedPluggableTextMorph! !

OBEnhancementDefinitionPanel subclass: #OBMultipleDefinitionPanel
	instanceVariableNames: 'panels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Panels'!

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/21/2007 16:44'!
aboutToChange: ann
   " self panels first aboutToChange: ann."! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 2/19/2008 17:39'!
addPanel: aPanel
    "remove empty standard panel"
    (panels size = 1 and: [panels first node isNil]) ifTrue: [panels _ OrderedCollection new].

    aPanel owner: self.
    panels add: aPanel.

    "make sure that the first panel also get buttons as soon as a second panel is added"
    panels size = 2 ifTrue: [panels first createMorph].

    self browser ifNotNil: [aPanel browser: self browser].

    self changed: #columns.
    "morph ifNotNil: [morph addPaneSplitters]."! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/8/2007 11:40'!
browser: aBrowser
    super browser: aBrowser.
    self panels do: [:ea | ea browser: aBrowser].! !

!OBMultipleDefinitionPanel methodsFor: 'building' stamp: 'dr 2/19/2008 10:36'!
buildOn: aBuilder
	morph := aBuilder multipleDefinitionPanel: self with: [].
	^morph! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/12/2007 16:12'!
columns
   ^self panels! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 3/1/2008 17:08'!
currentDefinitionPanel
   ^self panels detect: [:ea | ea node = self currentNode] ifNone: [nil]! !

!OBMultipleDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 5/8/2007 11:29'!
defaultBackgroundColor
	^ browser defaultBackgroundColor! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 3/1/2008 17:08'!
definitionChanged: ann
    self currentDefinitionPanel ifNotNilDo: [:panel | panel definitionChanged: ann].! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 2/19/2008 09:59'!
definitionPanel
   ^self currentDefinitionPanel! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 6/7/2007 11:36'!
hasChangeablePanel
    ^self panels anySatisfy: [:ea | ea isChangeable].! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 5/25/2007 17:29'!
hasMethodPanel
    ^self panels anySatisfy: [:ea | ea node isKindOf: OBMethodNode].! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 5/29/2007 10:40'!
includesNode: aNode
    ^self panels anySatisfy: [:ea | ea node = aNode].! !

!OBMultipleDefinitionPanel methodsFor: 'initializing' stamp: 'dr 2/27/2008 15:56'!
initialize
    super initialize.

    panels _ OrderedCollection new.    
    self addPanel: OBClosableDefinitionPanel new.
    ! !

!OBMultipleDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/14/2007 10:39'!
insert: firstPanel after: secondPanel
    | removeIdx |
    removeIdx := self panels indexOf: firstPanel.
    self panels add: firstPanel after: secondPanel.
    self panels removeAt: removeIdx.
    self changed: #columns.! !

!OBMultipleDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/14/2007 10:39'!
insert: firstPanel before: secondPanel
    | removeIdx |
    removeIdx := self panels indexOf: firstPanel.
    self panels add: firstPanel before: secondPanel.
    self panels removeAt: (removeIdx + 1).
    self changed: #columns.! !

!OBMultipleDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/11/2007 15:45'!
is: firstClosableDefinitionPanel placedBefore: secondClosableDefinitionPanel
    ^(self panels indexOf: firstClosableDefinitionPanel) < (self panels indexOf: secondClosableDefinitionPanel)! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 5/24/2007 12:20'!
isDefinition
   ^true! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/7/2007 11:50'!
lastChangeablePanel "self halt."
    ^self panels reversed detect: [:ea | ea isChangeable] ifNone: [nil].! !

!OBMultipleDefinitionPanel methodsFor: 'testing' stamp: 'dr 5/31/2007 17:12'!
lastIsNonMetaPanel
    ^(self lastPanel node isKindOf: OBMethodNode) not and: [self lastPanel isKindOf: OBClosableDefinitionPanel]! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/31/2007 17:06'!
lastPanel
    ^self panels last! !

!OBMultipleDefinitionPanel methodsFor: 'constructing' stamp: 'dr 5/8/2007 11:27'!
morph
	^ (OBPaneScroller withModel: self)
		name: 'def';
		yourself! !

!OBMultipleDefinitionPanel methodsFor: 'constructing' stamp: 'dr 5/8/2007 11:32'!
morphHeight
	^ 0! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/25/2007 15:28'!
nodeDeleted: ann
    | deletedNodePanel  |
    (ann node isKindOf: OBMethodNode) ifTrue: [
	   deletedNodePanel := self panels detect: [:ea | ea node = ann node] ifNone: [nil].
	   deletedNodePanel ifNotNil: [self removePanel: deletedNodePanel column: nil]
    ].! !

!OBMultipleDefinitionPanel methodsFor: 'class comment opening' stamp: 'dr 3/4/2008 10:37'!
openClassCommentFor: aClassNode
    | classCommentNode newPanel panel |
    Preferences classCommentOnClassSelect ifFalse: [^self].

    classCommentNode := OBClassCommentNode on: aClassNode theNonMetaClass.
    panel := panels detect: [:ea | ea node isKindOf: OBClassCommentNode] ifNone: [nil].
    panel ifNotNil: [self removePanel: panel].

    newPanel := OBClosableDefinitionPanel new.
    newPanel definition: classCommentNode definition.
    newPanel node: classCommentNode.
    self addPanel: newPanel.! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/24/2007 12:27'!
panels
   ^panels! !

!OBMultipleDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 5/8/2007 11:26'!
panes
    ^panels collect: [:ea | ea morph]! !

!OBMultipleDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 5/8/2007 11:44'!
reclaimPanes
    ^0! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/18/2007 11:40'!
refresh: ann
    self panels first refresh: ann.! !

!OBMultipleDefinitionPanel methodsFor: 'class comment opening' stamp: 'dr 3/4/2008 10:36'!
removeClassCommentPanels
    | panel | 
    panel := panels detect: [:ea | ea node isKindOf: OBClassCommentNode] ifNone: [nil].
    panel ifNotNil: [self removePanel: panel].! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/25/2007 18:00'!
removeNonMethodPanels
	self panels copy do: [:ea | (ea node isKindOf: OBMethodNode) ifFalse: [self removePanel: ea]]! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 5/25/2007 17:55'!
removePanel: aPanel
    ^self removePanel: aPanel column: nil! !

!OBMultipleDefinitionPanel methodsFor: 'accessing' stamp: 'dr 6/14/2007 10:39'!
removePanel: aPanel column: aColumn
    | newPanel theClass |
    panels remove: aPanel.
 
    "make sure that the last panels does not have any buttons"
    panels size = 1 ifTrue: [panels first createMorph].
    
    "make sure that there is always at least a standard panel"
    panels ifEmpty: [ 
	    newPanel := OBClosableDefinitionPanel new. 
	    aColumn ifNotNil: [newPanel definition: aColumn selectedNode definition]
	               ifNil: [aPanel node ifNotNil: [theClass := aPanel node theClass.
			            newPanel definition: (OBMethodDefinition source: theClass sourceCodeTemplate inClass: theClass)]]. 
	    self addPanel: newPanel.
    ].
    self changed: #columns! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 3/13/2008 12:22'!
selectionChanged: ann
    | newPanel newDefinition deselectedPanel panel |
    self removeClassCommentPanels.

	ann deselectedNode ifNotNil: [
       deselectedPanel := self panels detect: [:ea | ea node = ann deselectedNode] ifNone: [nil].
       deselectedPanel ifNotNil: [self removePanel: deselectedPanel column: ann column]
	] ifNil: [
        (self panels noneSatisfy: [:ea | ea node = ann node]) ifTrue: [
	       newDefinition := ann node ifNotNil: [ann node definition].
		  (newDefinition notNil and: [newDefinition text notEmpty]) ifTrue: [
	           (self hasChangeablePanel and: [ActiveEvent isNil or: [(ActiveEvent respondsTo: #shiftPressed) not 
			                                                            or: [ActiveEvent shiftPressed not]]]) ifTrue: [
		             self lastChangeablePanel definition: newDefinition.
		             self lastChangeablePanel node: ann node.
		             self lastChangeablePanel changed. 
		             self changed: #columns. 	
			
			         ann node isClassNode ifTrue: [self openClassCommentFor: ann node].
				
		       ] ifFalse: [
                      newPanel := OBClosableDefinitionPanel new.
                      newPanel definition: newDefinition.
                      newPanel node: ann node.
                      self addPanel: newPanel.
                ].
             ] 
         ] ifFalse: [
                "update panel for this node with new source code"
                ann node ifNotNil: [
                    panel := self panels detect: [:ea | ea node = ann node].
                    panel definition: ann node definition.
                ]
         ].
     ].! !

!OBMultipleDefinitionPanel methodsFor: 'callbacks' stamp: 'dr 5/29/2007 15:28'!
sizing 
    self panels ifEmpty: [^1].
    ^self panels size! !

!OBMultipleDefinitionPanel methodsFor: 'updating' stamp: 'dr 5/25/2007 14:57'!
subscribe
	self announcer 
		observe: OBAboutToChange
		send: #aboutToChange:
		to: self;
		
		observe: OBSelectionChanged
		send: #selectionChanged:
		to: self;
		
		observe: OBRefreshRequired
		send: #refresh:
		to: self;
				
		observe: OBDefinitionChanged
		send: #definitionChanged: 
		to: self;
		
		observe: OBNodeDeleted
		send: #nodeDeleted: 
		to: self.! !

!OBMultipleDefinitionPanel methodsFor: 'reorganizing' stamp: 'dr 6/14/2007 10:39'!
swap: firstPanel with: secondPanel
    self panels swap: (self panels indexOf: firstPanel) with: (self panels indexOf: secondPanel).
    self changed: #columns.
"self halt."! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 2/14/2008 11:54'!
autoSelect
    "do nothing"! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 2/14/2008 11:55'!
fan
    ^fan! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 7/19/2007 11:48'!
panel
	^panel ! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 2/28/2008 17:00'!
preselectNodes
    self next ifNotNil: [self next preselectNodes].! !

!OBColumn methodsFor: '*ob-enhancements' stamp: 'dr 11/20/2007 16:23'!
refreshAll
    | requestor |
    requestor := self.
    [requestor notNil] whileTrue: [
	   requestor refresh.
	   requestor := requestor next.
    ]    ! !

OBColumn subclass: #OBEnhancementColumn
	instanceVariableNames: 'doubleClickSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBEnhancementColumn commentStamp: 'dr 3/12/2008 15:47' prior: 0!
I am a slightly adapted version of OBColumn and I am used in all browser provided by the enhancements package.
!

!OBEnhancementColumn methodsFor: 'callbacks' stamp: 'dr 3/1/2008 17:56'!
autoSelect
    fan autoSelection ifNotNilDo: [:node | (selection = 0 or: [node = self selectedNode]) ifTrue: [self jumpTo: node]]. 
    self next ifNotNilDo: [:next | next autoSelect] 
! !

!OBEnhancementColumn methodsFor: 'accessing' stamp: 'dr 2/24/2008 15:58'!
basicParent: aNode  
    super basicParent: aNode.
    fan _ OBEnhancementFan parent: aNode.! !

!OBEnhancementColumn methodsFor: 'building' stamp: 'dr 2/25/2008 15:15'!
buildOn: aBuilder
	| pane |
	pane _ super buildOn: aBuilder.
	pane list doubleClickSelector: self doubleClickSelector.
	^pane! !

!OBEnhancementColumn methodsFor: 'updating' stamp: 'dr 3/1/2008 16:52'!
childrenChanged: ann
     super childrenChanged: ann.
	ann node isSmartGroup ifTrue:
		[self refresh].! !

!OBEnhancementColumn methodsFor: 'updating' stamp: 'dr 2/14/2008 11:07'!
clear
    super clear.
    fan := OBEnhancementFan new.! !

!OBEnhancementColumn methodsFor: 'selecting' stamp: 'dr 2/28/2008 16:06'!
deselectItem
     | previousColumn |
     self clearSelection.
     self changed: #selection.
     fan removeAutoSelection.
	previousColumn _ self previous. "this is ugly but works"
	panel columns last = self ifTrue: [previousColumn _ previousColumn previous].
	previousColumn ifNotNil: [previousColumn signalSelectionChanged] 
	                    ifNil: [self signalSelectionChanged. 
		                       self announcer announce: (OBDefinitionChanged definition: OBDefinition new)].! !

!OBEnhancementColumn methodsFor: 'selecting' stamp: 'dr 3/20/2008 13:15'!
doubleClick
    "only used in hierarchy browser in the first column to change focus to the selected class"
    "should be change to be based on metagraph"
    panel browser class isHierarchyBrowser ifTrue: [
	   panel changeRootNode: self selectedNode
    ] ifFalse: [(OBEnhancementCmdBrowseHierarchy on: self selectedNode for: self) execute].! !

!OBEnhancementColumn methodsFor: 'selecting' stamp: 'dr 2/25/2008 15:15'!
doubleClickSelector
    ^doubleClickSelector! !

!OBEnhancementColumn methodsFor: 'callbacks' stamp: 'dr 2/14/2008 15:19'!
fan: aFan selection: index
     super fan: aFan asEnhancedFan selection: index.
     self selectedNode ifNotNilDo: [:node | node isMethodNode ifTrue: [fan setLastNode: self selectedNode]].! !

!OBEnhancementColumn methodsFor: 'updating' stamp: 'dr 3/12/2008 16:08'!
listChanged 
     | oldNode oldCurrentNode |
     oldNode := self selectedNode.
     oldCurrentNode := panel currentNode.
	self refreshAndSignal: true.

	(oldNode notNil and: [oldNode isSmartAlias]) ifTrue: [
	    oldNode isSearchOrPackageAlias ifFalse: [oldNode jumpIn: panel].
	    (oldNode alias isSearch and: [oldCurrentNode notNil and: [oldCurrentNode ~= oldNode]]) ifTrue: [panel jumpTo: oldCurrentNode].
	].
	
	"make sure that if we have a pre-selected method node before the change occurred, its defintion is displayed"
	panel currentNode ifNotNilDo: [:node | 
	    self announcer announce: (OBDefinitionChanged definition: node definition)].! !

!OBEnhancementColumn methodsFor: 'accessing' stamp: 'dr 2/24/2008 16:09'!
parent: aNode 
	| cNode autoselectNode |
	
	autoselectNode _ fan lastNode.
	self basicParent: aNode.
	autoselectNode ifNotNil: [fan setLastNode: autoselectNode].

	cNode _ fan autoSelection. 
	self jumpTo: cNode. 
	(fan shouldUpdateOnAutoSelect and: [cNode notNil]) ifTrue: [self signalSelectionChanged].
! !

!OBEnhancementColumn methodsFor: 'accessing' stamp: 'dr 2/14/2008 10:06'!
previous
    ^panel columnBefore: self! !

!OBEnhancementColumn methodsFor: 'selecting' stamp: 'dr 3/3/2008 15:40'!
select: aNode
	fan children doWithIndex: [:child :i | child = aNode ifTrue: [^ super selection: i]].
	self selection: nil! !

!OBEnhancementColumn methodsFor: 'selecting' stamp: 'dr 3/12/2008 15:48'!
selection: anInteger
     "select the same item a second time => unselect"
     (selection = anInteger and: [doubleClickSelector isNil]) ifTrue: [self deselectItem. ^self].

     "selecting of smart nodes"
     selection := anInteger. 
     self selectedNode isSmartAlias ifTrue: [self selectedNode jumpIn: panel. ^self].

     super selection: anInteger.	
     panel autoSelect: self.
     (self selectedNode notNil and: [self selectedNode isMethodNode]) ifTrue: [
	    fan setLastNode: self selectedNode].! !

!OBEnhancementColumn methodsFor: 'selecting' stamp: 'dr 2/25/2008 15:16'!
setDoubleClickSelector: aSymbol
    doubleClickSelector := aSymbol! !

!OBEnhancementColumn methodsFor: 'initializing' stamp: 'dr 2/14/2008 11:06'!
setPanel: aPanel
    super setPanel: aPanel.
    fan := OBEnhancementFan new.! !

!OBEnhancementColumn methodsFor: 'updating' stamp: 'dr 2/28/2008 17:00'!
signalSelectionChanged
	super signalSelectionChanged. 
	self next ifNotNil: [self next preselectNodes].! !

!OBEnhancementColumn methodsFor: 'selecting' stamp: 'dr 2/25/2008 15:25'!
useDoubleClick
    self setDoubleClickSelector: #doubleClick.! !

OBEnhancementColumn subclass: #OBMultipleSelectionColumn
	instanceVariableNames: 'multipleSelection oldSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-MultipleSelection'!

!OBMultipleSelectionColumn methodsFor: 'building' stamp: 'dr 7/4/2007 15:51'!
buildOn: aBuilder
	^ aBuilder
		multipleSelectionColumn: self 
		with: [switch buildOn: aBuilder]! !

!OBMultipleSelectionColumn methodsFor: 'selecting' stamp: 'dr 2/28/2008 17:15'!
clearSelection
	super clearSelection.
	"multipleSelection _ Dictionary new."! !

!OBMultipleSelectionColumn methodsFor: 'testing' stamp: 'dr 2/29/2008 10:16'!
hasSeveralSelections
   ^(self multipleSelection values select: [:ea | ea]) size > 1! !

!OBMultipleSelectionColumn methodsFor: 'morphic' stamp: 'dr 7/4/2007 15:50'!
listMorph
	^ (OBPluggableListMorphOfMany
		on: self
		list: #list
		primarySelection: #selection
		changePrimarySelection: #selection:
		listSelection: #listSelectionAt:
		changeListSelection: #listSelectionAt:put:		
		menu: #menu: 
		keystroke: #keystroke:from:)
			getListElementSelector: #listAt:;
			getListSizeSelector: #listSize;
			dragEnabled: self dragEnabled;
			dropEnabled: self dropEnabled;
			borderWidth: 0;
			autoDeselect: false;
			adoptPaneColor: panel defaultBackgroundColor;
			yourself! !

!OBMultipleSelectionColumn methodsFor: 'callbacks' stamp: 'dr 2/29/2008 10:16'!
listSelectionAt: anIndex
	^self multipleSelection at: anIndex ifAbsent: [^false]! !

!OBMultipleSelectionColumn methodsFor: 'callbacks' stamp: 'dr 2/29/2008 10:16'!
listSelectionAt: anIndex put: aValue 
     | isSelected |
     isSelected _ self multipleSelection at: anIndex ifAbsent: [false].

     "if we did not de-select the primary selection"
     (aValue not and: [anIndex = selection]) ifFalse: [
	     self multipleSelection at: anIndex put: aValue.
          "if we de-select this item"
	     (isSelected = true and: [aValue not]) ifTrue: [
		    self announcer announce: ((OBSelectionChanged column: self) deselectedNode: (self children at: anIndex)).
	     ] ifFalse: [ "if we select an new item => check all old items"
	         (self multipleSelection associationsDo: [:assoc | (assoc value = true and: [self paneExistsForSelection: assoc key]) ifFalse: [
			    self multipleSelection at: assoc key put: false.
			]])
	     ]
     ].! !

!OBMultipleSelectionColumn methodsFor: 'selecting' stamp: 'dr 2/29/2008 10:15'!
multipleSelect: anInteger
    (self multipleSelection isEmpty and: [self = panel columns last]) ifTrue: [self multipleSelection at: anInteger put: true].! !

!OBMultipleSelectionColumn methodsFor: 'accessing' stamp: 'dr 2/29/2008 10:15'!
multipleSelection
    multipleSelection ifNil: [multipleSelection _ Dictionary new].
    ^multipleSelection! !

!OBMultipleSelectionColumn methodsFor: 'testing' stamp: 'dr 2/27/2008 16:19'!
paneExistsForSelection: anIndex
    ^panel definitionPanel includesNode: (self children at: anIndex ifAbsent: [nil]).! !

!OBMultipleSelectionColumn methodsFor: 'selecting' stamp: 'dr 2/29/2008 10:15'!
preselectNodes
     self children keysAndValuesDo: [:idx :node | (panel definitionPanel includesNode: node) ifTrue: [self multipleSelection at: idx put: true]]. ! !

!OBMultipleSelectionColumn methodsFor: 'selecting' stamp: 'dr 2/14/2008 12:05'!
selectSilently: aNode
	super selectSilently: aNode.
	self multipleSelect: selection.
! !

!OBMultipleSelectionColumn methodsFor: 'callbacks' stamp: 'dr 2/28/2008 16:55'!
selection: anInteger
     ((self hasSeveralSelections not and: [selection = anInteger or: [anInteger = 0]]) and: [doubleClickSelector isNil]) ifTrue: [ 
	    "select the same item a second time => unselect"
	    self deselectItem.
	    ^self
	].

     "de-selected an item"
	anInteger = 0 ifTrue: [
         selection _ oldSelection. "self halt."
         "selection keysAndValuesDo: [:index :value | value ifTrue: [primarySelection := index]]."
	] ifFalse: [ 
	    oldSelection _ selection.
	    selection _ anInteger.
	    self multipleSelect: anInteger.
         self signalSelectionChanged.
	]. 
	self changed: #selection. 
     fan setLastNode: self selectedNode.! !

OBColumn subclass: #OBSmartGroupColumn
	instanceVariableNames: 'smartGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-SmartGroup'!

!OBSmartGroupColumn methodsFor: 'updating' stamp: 'dr 6/7/2007 16:30'!
childrenChanged: announcement
	(announcement node isKindOf: OBSmartGroupNode) ifTrue:
		[self refresh].! !

!OBSmartGroupColumn methodsFor: 'nodes' stamp: 'dr 7/4/2007 15:50'!
nextMetaNode
    ^panel root metaNode! !

!OBSmartGroupColumn methodsFor: 'accessing' stamp: 'dr 4/5/2007 14:48'!
parent
	^smartGroup! !

!OBSmartGroupColumn methodsFor: 'accessing' stamp: 'dr 8/21/2007 15:44'!
selectedNode
	^fan children at: self selection ifAbsent: [panel root].! !

!OBSmartGroupColumn methodsFor: 'nodes' stamp: 'dr 2/29/2008 15:40'!
selectionChanged: ann
    ann node isSmartAlias ifTrue: [panel jumpTo: ann node alias].! !

!OBSmartGroupColumn methodsFor: 'initializing' stamp: 'dr 7/19/2007 10:32'!
setPanel: aPanel metaNode: aMetaNode node: aNode
    smartGroup := aNode.
    super setPanel: aPanel metaNode: aMetaNode node: aNode.
    ! !

OBNavigate subclass: #OBShowDynamicImplementors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBShowDynamicImplementors methodsFor: 'as yet unclassified' stamp: 'dr 10/1/2007 16:07'!
browserClass
	^ OBDynamicImplementorsBrowser! !

!OBShowDynamicImplementors methodsFor: 'as yet unclassified' stamp: 'dr 10/1/2007 16:07'!
noChildrenMessage
	^'no dynamic implementors'! !

OBNavigate subclass: #OBShowDynamicSenders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBShowDynamicSenders methodsFor: 'as yet unclassified' stamp: 'dr 10/5/2007 16:42'!
browserClass
	^ OBDynamicSendersBrowser! !

!OBShowDynamicSenders methodsFor: 'as yet unclassified' stamp: 'dr 10/5/2007 16:42'!
noChildrenMessage
	^'no dynamic senders'! !

OBButtonBar subclass: #OBEnhancementButtonBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBEnhancementButtonBar methodsFor: 'visual' stamp: 'dr 3/13/2008 11:05'!
adoptPaneColor: aColor
	(self submorphs reject: [:ea | ea isKindOf: OBBackButtonMorph]) do: [:ea | ea onColor: aColor offColor: aColor whiter]! !

!OBEnhancementButtonBar methodsFor: 'updating' stamp: 'dr 3/13/2008 11:00'!
updateCommands
	self removeAllMorphs.
	
	self addMorphBack: model createBackButton.		
	self addMorphBack: model createForwardButton.	
				
	model commands do: [:ea | self addButtonFor: ea].! !

!OBMClassRefsQuery methodsFor: '*ob-enhancements' stamp: 'dr 2/26/2008 16:56'!
openSearchBrowserOn: searchNode 
	^ self openSearchInSameBrowserOn: searchNode ! !

!OBMorphBuilder class methodsFor: '*ob-enhancements' stamp: 'dr 2/16/2008 15:39'!
openWithExtent: aBrowser
	^ (self build: aBrowser) openInWorldExtent: aBrowser extent! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 2/27/2008 11:05'!
closableDefinitionPanel: aDefinitionPanel with: aBlock
	| morph contentMorph | 
	morph _ (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;		
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.
     
     ((Preferences visualizations and: [aDefinitionPanel respondsTo: #codeTabPanel]) and: [aDefinitionPanel codeTabPanel commands notEmpty]) ifTrue: [
	    morph addMorphBack: (aDefinitionPanel codeTabPanel buildOn: self).	
	].	
	aDefinitionPanel hasSeveralPanels ifTrue: [morph addMorphBack: aDefinitionPanel createTitleBar].	
	contentMorph _ aDefinitionPanel createContentMorph.
	aDefinitionPanel setContentMorph: contentMorph.
	morph addMorphBack: contentMorph.
	
	current ifNotNil: [current addMorphBack: morph].
	^ self current: morph do: aBlock! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 6/14/2007 10:28'!
createPaneForColumn: aColumn with: listSelector
	| pane |
	pane _ OBPane new.
	pane 
		model: aColumn;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		clipSubmorphs: true;
		color: Color transparent;
		cellInset: 0;
		borderWidth: 0;
		layoutPolicy: ProportionalLayout new;
		addList: (self perform: listSelector with: aColumn).
		
	^pane	! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 17:07'!
createReferencePaneFor: aDefinitionPanel
	| columnPanel paneScroller saved referenceMorph |
	columnPanel := OBColumnPanel minPanes: 1 maxPanes: 1.
	columnPanel pushColumn: aDefinitionPanel referenceList.
	
	paneScroller := (OBPaneScroller withModel: columnPanel)
				name: 'scroller';
				vResizing: #spaceFill;
				hResizing: #spaceFill;
				yourself.	
			
	[saved _ current.
	      self current: paneScroller do: [aDefinitionPanel referenceList buildOn: self]] 
     ensure: [current _ saved].	
	
	referenceMorph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		borderWidth: 0;
		hResizing: #rigid;
		width: aDefinitionPanel referenceList defaultWidth;
		vResizing: #spaceFill;		
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.     

	referenceMorph addMorphBack: aDefinitionPanel referenceList createTitleBar.	
	referenceMorph addMorphBack: paneScroller.	
		
	^referenceMorph
! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 3/13/2008 12:05'!
enhancementFixedButtonBar: aPanel with: aBlock 
	| morph |
	morph := OBEnhancementButtonBar on: aPanel.
	morph
		height: Preferences standardCodeFont height * 2.2;
		layoutPolicy: TableLayout new;
		vResizing: #rigid;
		hResizing: #spaceFill;
		listDirection: #leftToRight;
		rubberBandCells: true;
		borderWidth: 0.		
		
	current addMorphBack: morph.
	self current: morph do: aBlock! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 3/13/2008 12:15'!
enrichedTextarea: aDefinitionPanel with: aBlock 
	| morph definitionMorph tabBarMorph textMorph |
	morph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;		
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself. 
			
	definitionMorph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;	
		minWidth: 300;	
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.     
		
	tabBarMorph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		borderWidth: 0;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;		
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.
				
     ((Preferences visualizations and: [aDefinitionPanel hasCodeTabPanel]) 
                                      and: [aDefinitionPanel codeTabPanel commands notEmpty]) ifTrue: [
	     tabBarMorph addMorphBack: (aDefinitionPanel codeTabPanel buildOn: self).	
		definitionMorph addMorphBack: tabBarMorph
	].			
		
	textMorph := aDefinitionPanel createContentMorph.		
     aDefinitionPanel setContentMorph: textMorph.		
	definitionMorph addMorphBack: textMorph.	
	morph addMorphBack: definitionMorph.
	
	aDefinitionPanel hasReferencePanel ifTrue: [morph addMorphBack: (self createReferencePaneFor: aDefinitionPanel)].	
			
	current ifNotNil: [current addMorphBack: morph].
	self current: morph do: aBlock.
     ^definitionMorph! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 3/13/2008 13:24'!
multipleDefinitionPanel: aMultipleDefinitionPanel with: aBlock
	| morph defMorph |
	morph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;		
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself. 
			
	defMorph := (OBPaneScroller withModel: aMultipleDefinitionPanel)
		name: 'def';
		yourself.	
				
	morph addMorphBack: defMorph.			
				
	current ifNotNil: [current addMorphBack: morph].
	self current: morph do: aBlock.
	
	^defMorph! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 6/14/2007 10:27'!
multipleSelectionColumn: aColumn with: aBlock
   	| pane |
     pane := self createPaneForColumn: aColumn with: #multipleSelectionListMorphForColumn:.
	current ifNotNil: [current pushPane: pane].
	^ self current: pane do: aBlock
! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 6/14/2007 10:23'!
multipleSelectionListMorphForColumn: aColumn
	^ (OBPluggableListMorphOfMany
		on: aColumn
		list: #list
		primarySelection: #selection
		changePrimarySelection: #selection:
		listSelection: #listSelectionAt:
		changeListSelection: #listSelectionAt:put:		
		menu: #menu:
		keystroke: #keystroke:from:)
			getListElementSelector: #listAt:;
			getListSizeSelector: #listSize;
			dragEnabled: aColumn dragEnabled;
			dropEnabled: aColumn dropEnabled;
			borderWidth: 0;
			autoDeselect: false;
			yourself! !

!OBMorphBuilder methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 11:29'!
referenceList: aReferenceList with: aBlock
	| pane |
			
	pane := OBPane new.
	pane
		model: aReferenceList;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		clipSubmorphs: true;
		color: Color transparent;
		cellInset: 0;
		borderWidth: 0;
		layoutPolicy: ProportionalLayout new;
		addList: (self listMorphForColumn: aReferenceList).	
	current ifNotNil: [current pushPane: pane].
	^self current: pane do: aBlock! !

OBFan subclass: #OBEnhancementFan
	instanceVariableNames: 'lastNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBEnhancementFan methodsFor: 'accessing' stamp: 'dr 2/14/2008 11:04'!
autoSelection
	| auto |
	auto := parent ifNotNilDo: [:node | node metaNode autoSelect].
	^auto ifNotNil: [
		auto name == #LastSelection ifTrue: [
			lastNode ifNotNil: [children detect: [:ea | ea selector = lastNode selector] ifNone: [nil]].
			
		]
		ifFalse: [children detect: [:ea | ea metaNode == auto] ifNone: [nil]]]! !

!OBEnhancementFan methodsFor: 'accessing' stamp: 'dr 2/14/2008 11:04'!
lastNode
	^lastNode! !

!OBEnhancementFan methodsFor: 'selecting' stamp: 'dr 2/25/2008 10:52'!
removeAutoSelection
    lastNode := nil! !

!OBEnhancementFan methodsFor: 'accessing' stamp: 'dr 2/14/2008 11:03'!
setLastNode: aNode
	(aNode notNil and: [aNode isMethodNode]) ifTrue: [lastNode := aNode]! !

!OBEnhancementFan methodsFor: 'testing' stamp: 'dr 2/14/2008 11:03'!
shouldUpdateOnAutoSelect
    parent metaNode autoSelect ifNotNilDo: [:autoSelect | ^autoSelect shouldUpdateOnAutoSelect].
    ^false! !

!OBFan methodsFor: '*ob-enhancements' stamp: 'dr 2/14/2008 11:53'!
asEnhancedFan
    ^OBEnhancementFan new setParent: parent children: children; yourself 
! !

!OBFan methodsFor: '*ob-enhancements' stamp: 'dr 2/24/2008 13:29'!
lastNode
    ^nil! !

!OBFan methodsFor: '*ob-enhancements' stamp: 'dr 2/25/2008 11:16'!
removeAutoSelection! !

!OBMClassQuery methodsFor: '*ob-enhancements' stamp: 'dr 2/26/2008 16:54'!
openSearchBrowserOn: searchNode 
	^ self openSearchInSameBrowserOn: searchNode ! !

OBHierarchyBrowser subclass: #OBDynamicHierarchyBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBDynamicHierarchyBrowser class methodsFor: 'configuration' stamp: 'dr 2/15/2008 17:44'!
defaultMetaNode
	^ ((self dynamicBrowser ifTrue: [OBDynamicMetagraphBuilder] ifFalse: [OBEnhancementMetagraphBuilder])
		on: (OBMetaNode named: 'RootClass')
		class: #classHierarchy 
		comment: #commentHierarchy 
		metaclass: #metaclassHierarchy) execute.! !

!OBDynamicHierarchyBrowser class methodsFor: 'configuration' stamp: 'dr 2/15/2008 14:32'!
definitionPanel
     ^(self dynamicBrowser ifTrue: [OBEnrichedDefinitionPanel] ifFalse: [OBEnhancementDefinitionPanel]) new! !

!OBDynamicHierarchyBrowser class methodsFor: 'configuration' stamp: 'dr 2/15/2008 14:29'!
dynamicBrowser
    ^false! !

!OBHierarchyBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/28/2008 15:21'!
buildMetagraphOn: root class: classSel comment: commentSel metaclass: metaclassSel 
     "to make sure that the enh. graph builder is also used if package browser is not default browser"
	^ (OBEnhancementMetagraphBuilder
		on: root
		class: classSel
		comment: commentSel
		metaclass: metaclassSel) execute! !

!OBHierarchyBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/15/2008 14:32'!
definitionPanel
     ^OBEnhancementDefinitionPanel new! !

!OBHierarchyBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:36'!
hasReferencePanel
    ^self dynamicBrowser! !

!OBHierarchyBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/25/2008 15:20'!
isHierarchyBrowser
    ^true! !

!OBHierarchyBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/14/2008 16:04'!
navigationPanel
	^OBEnhancementColumnPanel minPanes: self minPanes maxPanes: self maxPanes! !

!OBHierarchyBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 3/12/2008 14:45'!
onClass: aClass selector: aSelector
     | methodNode |
     methodNode := OBMethodNode on: aSelector inClass: aClass.
	^ self root: aClass asNode selection: methodNode.! !

!OBHierarchyBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/11/2008 12:05'!
openOnClass: aClass selector: aSelector
	^(self onClass: aClass selector: aSelector) open! !

!OBMorphicPlatform methodsFor: '*ob-enhancements' stamp: 'dr 2/16/2008 15:42'!
handleBrowseRequestWithExtent: request
	^ OBMorphBuilder openWithExtent: request browser! !

OBFilter subclass: #OBClassAnnotationFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBClassAnnotationFilter methodsFor: 'filtering' stamp: 'dr 2/23/2008 16:10'!
icon: aSymbol forNode: aNode
     (Smalltalk classNamed: #HODataBase) ifNil: [^nil].
	^((Smalltalk at: #HODataBase) default includesClass: aNode theClass) ifTrue: [#flag] ifFalse: [#blank]! !

OBFilter subclass: #OBClassHierarchyFilter
	instanceVariableNames: 'columnPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBClassHierarchyFilter class methodsFor: 'instance creation' stamp: 'dr 2/25/2008 16:43'!
columnPanel: aColumnPanel
    ^self new columnPanel: aColumnPanel; yourself! !

!OBClassHierarchyFilter methodsFor: 'accessing' stamp: 'dr 2/25/2008 16:43'!
columnPanel: aColumnPanel
    columnPanel := aColumnPanel! !

!OBClassHierarchyFilter methodsFor: 'filtering' stamp: 'dr 3/12/2008 14:20'!
displayString: aStringOrText forParent: pNode child: cNode
	^ columnPanel root theNonMetaClass = cNode theNonMetaClass ifTrue: [aStringOrText asText addAttribute: TextEmphasis bold; yourself] ifFalse: [aStringOrText]! !

OBFilter subclass: #OBClassInheritanceFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBClassInheritanceFilter methodsFor: 'filtering' stamp: 'dr 2/20/2008 10:38'!
icon: aSymbol forNode: aNode
	^aNode theClass subclasses notEmpty ifTrue: [#arrowDown] ifFalse: [#blank]! !

!OBCodeBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:37'!
dynamicBrowser
    ^false! !

!OBCodeBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/27/2008 15:43'!
hasHistoryButtons
    ^false! !

!OBCodeBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 7/18/2007 16:14'!
useMultipleSelection
    ^false! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:35'!
browseHistory
    ^OrderedCollection new! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/26/2008 16:48'!
clearHistoryAfter: anInteger
    "remove all following elements"
    self setHistory: (self browseHistory copyFrom: 1 to: anInteger).! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 11/16/2007 16:18'!
cmdDisplayReferencingPlaces
	^OBCmdDisplayReferencingPlaces! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:32'!
hasBackHistory
    ^self hasHistory and: [self historyPrevious notNil]! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 17:44'!
hasForwardHistory  
    ^self hasHistory and: [self historyNext notNil]! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:24'!
hasHistory
    ^self browseHistory isEmpty not and: [self browseHistory last notNil]! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:09'!
historyAtCursor
    ^nil! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/26/2008 16:20'!
historyBack
    self browseHistory isEmpty ifTrue: [^false]. 
    ^self historyGoToIndex: self historyCursor - 1. ! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:56'!
historyBackNodes
    ^(self browseHistory copyFrom: 1 to: self historyCursor - 1) reversed reject: [:ea | ea isNil].! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:10'!
historyCursor
    ^0
! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:09'!
historyCursor: anInteger
! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 15:40'!
historyForward
    self browseHistory isEmpty ifTrue: [^false].
    ^self historyGoToIndex: self historyCursor + 1. ! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 17:22'!
historyForwardNodes "self halt."
    ^(self browseHistory copyFrom: self historyCursor + 1 to: self browseHistory size) reject: [:ea | ea isNil].! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 3/3/2008 11:34'!
historyGoToIndex: anInteger
    | node | "self halt."
    self browseHistory at: anInteger ifAbsent: [^false].
    self historyCursor: anInteger. 
    node := self historyAtCursor.
    node ifNotNil: [
        self historyIndexOnSwitch >= anInteger ifTrue: [
		  self setMetaNode: self class defaultMetaNode root: self class defaultRootNode. 
		  self clearHistoryAfter: anInteger.
		  self resetHistoryIndexOnSwitch]. 
	   self jumpTo: node. 
	   ^true
    ].

    ^false! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 17:50'!
historyIncrementCursor
   self historyCursor: self historyCursor + 1! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:29'!
historyNext
    ^self browseHistory at: self historyCursor + 1 ifAbsent: [nil]! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:48'!
historyNodes
    ^self browseHistory reject: [:ea | ea isNil].! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:29'!
historyPrevious
    ^self browseHistory at: self historyCursor - 1 ifAbsent: [nil]! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 3/13/2008 13:28'!
historyPush: aNode 
    aNode ifNotNil: [
	   self historyCursor < self browseHistory size ifTrue: [
		   self clearHistoryAfter: self historyCursor.
	   ]. 
	   self historyAtCursor = aNode ifFalse: [self browseHistory addLast: aNode. self historyIncrementCursor].
    ]! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/21/2008 11:25'!
historySizeOnSwitch
    ^0! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/21/2008 11:28'!
resetHistorySize
    "do nothing"! !

!OBCodeBrowser methodsFor: '*ob-enhancements' stamp: 'dr 2/22/2008 16:47'!
setHistory: aCollection! !

!MCFileBasedRepository methodsFor: '*ob-enhancements' stamp: 'dr 12/14/2007 14:35'!
versionsAvailableForPackage: aPackage
    ^self allVersionNames select: [:versionName | versionName beginsWith: aPackage packageName]! !

OBMethodCategoryNode subclass: #OBMethodCategoryExtensionNode
	instanceVariableNames: 'classExtensionNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBMethodCategoryExtensionNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 14:13'!
classExtensionNode
    ^classExtensionNode! !

!OBMethodCategoryExtensionNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 14:13'!
classExtensionNode: aClassExtensionNode
    classExtensionNode _ aClassExtensionNode! !

!OBMethodCategoryExtensionNode methodsFor: 'displaying' stamp: 'dr 3/5/2008 16:11'!
displayString
    | text |
    text := super displayString asText.
    (self category asString asLowercase allButFirst beginsWith: self extensionName asLowercase) ifTrue: [
	   text addAttribute: TextEmphasis bold.
	   (self category includesSubString: '-overrides') ifTrue: [text addAttribute: TextColor red].	   	      
    ].
    ^text! !

!OBMethodCategoryExtensionNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 15:16'!
extensionName
   ^self classExtensionNode extensionName! !

!OBMethodCategoryExtensionNode methodsFor: 'ancestry' stamp: 'dr 2/24/2008 14:13'!
isDescendantOfClass: aClassNode
   ^((super isDescendantOfClass: aClassNode) and: [aClassNode isKindOf: OBClassExtensionNode]) 
                                                    and: [self classExtensionNode = aClassNode]! !

!OBMethodCategoryExtensionNode methodsFor: 'ancestry' stamp: 'dr 3/3/2008 17:23'!
isDescendantOfClassCat: aClassCategoryNode
	(aClassCategoryNode isKindOf: OBMonticelloPackageNode) ifFalse: [^false].
	aClassCategoryNode = self classExtensionNode package ifFalse: [^false].
	^(aClassCategoryNode extensionClasses collect: [:ea | ea theNonMetaClass]) includes: self theNonMetaClass.
! !

!OBMethodCategoryExtensionNode methodsFor: 'ancestry' stamp: 'dr 2/24/2008 11:50'!
isDescendantOfMethodCat: other
   ^(super isDescendantOfMethodCat: other) and: [self class = other class]! !

!OBMethodCategoryExtensionNode methodsFor: 'navigating' stamp: 'dr 2/24/2008 15:26'!
methods
   ^self methodReferences collect: [:ea | (OBMethodExtensionNode on: ea) categoryExtensionNode: self; yourself]! !

!OBMethodCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 6/7/2007 16:34'!
dropOnSmartGroup: aNode
	aNode addAlias: self.
	aNode signalChildrenChanged.! !

!OBMethodCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:12'!
icon
    (Smalltalk classNamed: #HODataBase) ifNil: [^nil].
    ^(self methodReferences anySatisfy: [:methodRef | (Smalltalk at: #HODataBase) default isInstrumentedMethod: methodRef]) ifTrue: [#flag] ifFalse: [#blank]! !

!OBMethodCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 11/12/2007 10:45'!
isMethodCategory
    ^true! !

!OBMethodCategoryNode methodsFor: '*ob-enhancements' stamp: 'dr 5/25/2007 17:07'!
isMethodHolderNode
    ^true! !

OBMetaNode subclass: #OBEnhancementMetaNode
	instanceVariableNames: 'updateOnAutoSelect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBEnhancementMetaNode methodsFor: 'private' stamp: 'dr 2/20/2008 10:33'!
populateClassNode
     super populateClassNode.
	(self classMetaNode)
		addFilter: OBClassInheritanceFilter new! !

!OBEnhancementMetaNode methodsFor: 'auto-selecting' stamp: 'dr 2/13/2008 16:15'!
shouldUpdateOnAutoSelect
    updateOnAutoSelect ifNotNil: [^updateOnAutoSelect].
    ^false
    ! !

!OBEnhancementMetaNode methodsFor: 'auto-selecting' stamp: 'dr 2/13/2008 15:48'!
updateOnAutoSelect
    updateOnAutoSelect := true
    ! !

!OBMetaNode methodsFor: '*ob-enhancements' stamp: 'dr 2/14/2008 11:53'!
shouldUpdateOnAutoSelect
    ^false! !

!OBClassCommentNode methodsFor: '*ob-enhancements' stamp: 'dr 3/13/2008 16:52'!
isDescendantOfClass: aClass
    ^self class = aClass class and: [super isDescendantOfClass: aClass]! !

!OBClassCommentNode methodsFor: '*ob-enhancements' stamp: 'dr 11/5/2007 16:55'!
isDescendantOfMethodCat: aString
    ^false! !

OBPluggableTextMorph subclass: #OBEnrichedPluggableTextMorph
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBEnrichedPluggableTextMorph commentStamp: 'dr 10/11/2007 10:39' prior: 0!
I am an enriched text morph. I can display icons to depict special, dynamic information about the method whose source code is represented in this text morph.
I need to access the formatter stored in the model (an enriched definition panel) to insert the icons.!

!OBEnrichedPluggableTextMorph methodsFor: 'private' stamp: 'dr 1/22/2008 09:55'!
insertIconsOffset: offset 
     model formatter ifNotNilDo: [:formatter | 
	    formatter iconPositions keysAndValuesDo: [:node :iconPos | | x y yDelta lineStartPos lineTextMorph position iconName imageMorph |
	        x := iconPos first. y := iconPos second. 
	        lineStartPos := text string findString: (text string lineNumber: y). 
	        lineTextMorph := OBTextMorph new contents: (text copyFrom: lineStartPos to: x + lineStartPos). 
	        textMorph ifNotNil: [lineTextMorph setTextStyle: textMorph textStyle].
	        yDelta := 2.
             iconName := node image.
             lineTextMorph height > 16 ifTrue: [yDelta := 5. iconName := (node image, 'Big') asSymbol].
"self halt."
	        position := (self position x + lineTextMorph width + 3) @ (self position y + (lineTextMorph height * (y - 1) - ((y -1) * 2) + yDelta)).
	        position := position x @ (position y - offset).
	        (self containsPoint: (position x @ (position y + 4))) ifTrue: [
	            imageMorph := ImageMorph new setNewImageFrom: (OBMorphicIcons iconNamed: iconName).
	            imageMorph on: #click send: #openDynamicListFor:event:from: to: self withValue: node.	         
		       self addMorphFront: imageMorph fromWorldPosition: position]
	    ]
     ]! !

!OBEnrichedPluggableTextMorph methodsFor: 'accessing' stamp: 'dr 10/2/2007 16:11'!
methodReference
    ^model methodReference! !

!OBEnrichedPluggableTextMorph methodsFor: 'events' stamp: 'dr 2/21/2008 11:15'!
openDynamicListFor: anRBNode event: evt from: aMorph
    | selection references values uiFeedback | 
    references _ anRBNode referencesInMethod: self methodReference.
    values _ anRBNode valuesForReferences: references. 

    values ifNotEmpty: [
         (selection _ anRBNode preselectionForValues: values) ifNil: [
		   selection _ OBChoiceRequest prompt: nil labels: (anRBNode labelsForReferences: references) values: values].
         selection ifNotNil: [
	          model browser jumpTo: selection asNode. 
	          "model browser announce: (SBAnnouncement browser: model browser action: anRBNode actionLabel)"]
    ] ifEmpty: [
        uiFeedback _ (UIManager default perform: anRBNode informSelector with: anRBNode noReferencesFoundMsg).
        (uiFeedback isBoolean and: [uiFeedback]) ifTrue: [
	       anRBNode executeAlternativeActionFor: self methodReference.
	   ]
    ]. ! !

!OBEnrichedPluggableTextMorph methodsFor: 'private' stamp: 'dr 4/10/2008 14:09'!
refreshIconsOffset: offset
    self removeIcons. 
    self insertIconsOffset: offset.! !

!OBEnrichedPluggableTextMorph methodsFor: 'private' stamp: 'dr 10/1/2007 14:45'!
removeIcons
     (self submorphsSatisfying: [:ea | ea basicType = #Image]) do: [:ea | ea delete].

	

! !

!OBEnrichedPluggableTextMorph methodsFor: 'model access' stamp: 'dr 4/10/2008 14:17'!
setText: aText
     text _ aText.
     super setText: aText.

	

! !

!OBEnrichedPluggableTextMorph methodsFor: 'events' stamp: 'dr 11/21/2007 10:21'!
vScrollBarValue: scrollValue
    super vScrollBarValue: scrollValue.
    self refreshIconsOffset: (self vLeftoverScrollRange * scrollValue) rounded.! !

!OBPluggableTextMorph methodsFor: '*ob-enhancements' stamp: 'dr 11/16/2007 16:15'!
removeIcons! !

!Class methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:09'!
asEnhancedNode
	((self respondsTo: #isInstrumented) and: [self isInstrumented]) ifTrue: [
		^OBEnrichedClassNode on: ((Smalltalk at: #HODataBase) default modelClassFor: self).
	].
	^ OBClassNode on: self

! !

MethodReference subclass: #MethodExtensionReference
	instanceVariableNames: 'categoryExtensionNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!MethodExtensionReference methodsFor: 'accessing' stamp: 'dr 2/24/2008 15:10'!
asNode
	^((self category asString asLowercase copyFrom: 2 to: self category size) beginsWith: self extensionName asLowercase)
			ifTrue: [(OBMethodExtensionNode on: self) categoryExtensionNode: categoryExtensionNode; yourself]
			ifFalse: [OBMethodNode on: self]! !

!MethodExtensionReference methodsFor: 'accessing' stamp: 'dr 2/24/2008 14:00'!
categoryExtensionNode: aCategoryExtensionNode
	categoryExtensionNode _ aCategoryExtensionNode! !

!MethodExtensionReference methodsFor: 'accessing' stamp: 'dr 2/24/2008 13:58'!
extensionName
	^categoryExtensionNode extensionName! !

!MethodReference methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:10'!
asEnhancedNode
	((self respondsTo: #isInstrumented) and: [self isInstrumented]) ifTrue: [
		^OBEnrichedMethodNode on: ((Smalltalk at: #HODataBase) default modelMethodFor: self).
	].
	^OBMethodNode on: self   ! !

!MethodReference methodsFor: '*ob-enhancements' stamp: 'dr 10/8/2007 15:41'!
prettyName
    ^self actualClass name, ' >> ', methodSymbol! !

Object subclass: #OBDummyPackage
	instanceVariableNames: 'categories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBDummyPackage commentStamp: 'dr 7/16/2007 10:42' prior: 0!
I am a dummy for a Monticello package. I am used for class categories existing in the image that are not contained in any Monticello package. I list all these ownerless class categories in alphabetical order. !

!OBDummyPackage class methodsFor: 'instance creation' stamp: 'dr 7/22/2007 12:00'!
categories: aCollection
    ^self new categories: aCollection! !

!OBDummyPackage methodsFor: 'accessing' stamp: 'dr 6/18/2007 17:10'!
categories
    ^categories! !

!OBDummyPackage methodsFor: 'accessing' stamp: 'dr 6/18/2007 17:09'!
categories: aCollection
    categories := aCollection! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 17:09'!
classes
    ^(self categories gather: 
		[:cat |
		(SystemOrganization listAtCategoryNamed: cat)
			collect: [:className | Smalltalk at: className]])
				sortBy: [:a :b | a className <= b className]! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 17:10'!
extensionClasses
    ^OrderedCollection new! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 16:57'!
modified
    ^false! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 17:08'!
packageInfo
    ^self! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 17:02'!
packageName
    ^'Unpackaged'! !

!OBDummyPackage methodsFor: 'dummy accessors' stamp: 'dr 6/18/2007 16:57'!
repositories
    ^OrderedCollection new! !

Object subclass: #OBReferenceList
	instanceVariableNames: 'panel children selection textMorph referencedNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBReferenceList class methodsFor: 'instance creation' stamp: 'dr 10/11/2007 17:05'!
panel: aPanel
    ^self new setPanel: aPanel! !

!OBReferenceList methodsFor: 'selecting' stamp: 'dr 10/15/2007 10:59'!
addCommandsToMenu: aMenu 
	| scan |
	scan := self announce: OBNodeCommandScan.
	self hasSelection 
		ifTrue: 
			[scan 
				populateMenu: aMenu
				withNode: self selectedNode
				forRequestor: self
				filter: [:cmd | cmd isReferenceListCmd and: [cmd isActive]]]! !

!OBReferenceList methodsFor: 'updating' stamp: 'dr 10/15/2007 10:50'!
announce: anAnnouncement 
	^panel announce: anAnnouncement! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/15/2007 10:52'!
browser
    ^panel browser! !

!OBReferenceList methodsFor: 'building' stamp: 'dr 10/12/2007 10:28'!
buildOn: aBuilder 
	^aBuilder referenceList: self with: []! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/12/2007 14:20'!
children
     children ifNil: [self refreshChildren].
     ^children! !

!OBReferenceList methodsFor: 'building' stamp: 'dr 10/12/2007 14:35'!
createTitleBar
	| titleBar |		
	titleBar := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		borderWidth: 0;
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.
			
	titleBar addMorphBack: self textMorph.			
	^titleBar! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 11/12/2007 10:45'!
currentNode
    | curNode |
    curNode := panel currentNode.
    (curNode notNil and: [curNode isMethodCategory]) ifTrue: [curNode := OBClassNode on: curNode theClass].
    ^curNode! !

!OBReferenceList methodsFor: 'building' stamp: 'dr 10/12/2007 14:34'!
defaultWidth
    ^160! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/11/2007 17:00'!
dragEnabled
	^false! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/11/2007 17:00'!
dropEnabled
	^false! !

!OBReferenceList methodsFor: 'testing' stamp: 'dr 10/12/2007 13:33'!
hasReferences
    ^self children notEmpty! !

!OBReferenceList methodsFor: 'testing' stamp: 'dr 10/15/2007 10:50'!
hasSelection
	^ self selection > 0! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/11/2007 17:17'!
iconAt: index 
	^(self children at: index) icon! !

!OBReferenceList methodsFor: 'testing' stamp: 'dr 10/15/2007 10:49'!
isEmpty
    ^self children isEmpty! !

!OBReferenceList methodsFor: 'testing' stamp: 'dr 10/15/2007 10:51'!
isSelected: aNode
	^ self selectedNode == aNode! !

!OBReferenceList methodsFor: 'selecting' stamp: 'dr 10/15/2007 10:47'!
jumpTo: aNode
    panel browser jumpTo: aNode asClassNode.! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/11/2007 16:59'!
keystroke: aChar from: aMorph! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/11/2007 17:17'!
list
	^self children collect: [:ea | ea displayString]! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/11/2007 17:16'!
listAt: index 
	^(self children at: index ifAbsent: [^'']) displayString! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/11/2007 16:58'!
listSize
    ^self children size! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/12/2007 14:23'!
listTitle
    ^self hasReferences ifTrue: ['References in ', self currentNode prefixedName] ifFalse: [' ']! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/15/2007 10:48'!
menu: aMenu 
	self isEmpty ifFalse: [self addCommandsToMenu: aMenu].
	^aMenu! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/15/2007 16:53'!
referencedNode
    ^referencedNode! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 11/5/2007 16:45'!
refreshChildren
     children := self currentNode ifNotNilDo: [:node | node referencingClasses] ifNil: [OrderedCollection new]! !

!OBReferenceList methodsFor: 'selecting' stamp: 'dr 10/15/2007 11:20'!
selectReferencingCodeNodes: aCollection
    panel selectReferencingCodeNodes: aCollection! !

!OBReferenceList methodsFor: 'selecting' stamp: 'dr 10/16/2007 10:01'!
selectReferencingMethods: aCollection
    | column |
    column := panel browser navigationPanel columns last.
    column children do: [:node | (aCollection includes: node reference) ifTrue: [node setIsHighlighted] ifFalse: [node setUnhighlighted]].
    column changed: #list.
    referencedNode := self selectedNode.! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/15/2007 10:51'!
selectedNode
	^self children at: self selection ifAbsent: [].! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 11/5/2007 16:50'!
selection 
	(selection isNil or: [selection = 0]) ifTrue: [
		 self referencedNode ifNotNil: [selection := self children indexOf: self referencedNode ifAbsent: [0]] ifNil: [^0]].
	^selection! !

!OBReferenceList methodsFor: 'callbacks' stamp: 'dr 10/15/2007 10:38'!
selection: anInteger
	selection _ anInteger.
	self changed: #selection.
	"panel browser jumpTo: (self children at: anInteger) asClassNode."! !

!OBReferenceList methodsFor: 'updating' stamp: 'dr 11/20/2007 10:09'!
selectionChanged: ann
    "do not change list if the current node's parent might have references (eg method protocol nodes)" 
    ((self currentNode notNil and: [self currentNode isNodeWithReferences not]) and: [self currentNode respondsTo: #theClass]) ifTrue: [^self].

    selection := 0.
    self refreshChildren.
    self changed: #list.
    self updateText.! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/11/2007 17:06'!
setPanel: aPanel
    panel := aPanel! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/12/2007 14:11'!
textMorph
    textMorph ifNil: [textMorph := TextMorph new. self updateText].
    ^textMorph! !

!OBReferenceList methodsFor: 'accessing' stamp: 'dr 10/12/2007 13:30'!
title
    ^'References in ', self currentNode name! !

!OBReferenceList methodsFor: 'updating' stamp: 'dr 10/12/2007 14:33'!
updateText
    | text |
    text := Text string: self listTitle attribute: TextEmphasis bold.
    self textMorph contents: text wrappedTo: 160! !

!OBMorphicIcons class methodsFor: '*ob-enhancements' stamp: 'dr 1/16/2008 12:10'!
iconImporter
    | image stream |
    image := ColorForm fromFileNamed: '/Users/davidroethlisberger/Pictures/roethlis/textBig.gif'.
    stream := WriteStream with: String new.
    image storeOn: stream.
    stream contents.! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 10/22/2007 16:06'!
arrowLeft
	^((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 185273099 185273099 185273099 185273099 185272842 185273099 185273099 185207050 185273099 185273099 168364298 168430091 185273098 151456009 151587339 185272841 134349056 592395 185272841 328710 50924043 185273098 150997257 151587339 185273099 168364298 168430091 185273099 185207050 185273099 185273099 185272842 185273099 185273099 185273099 185273099)
	offset: 0@0)
	colorsFromArray: #(#(0.572 0.804 0.369) #(0.564 0.768 0.412) #(0.576 0.804 0.372) #(0.56 0.804 0.325) #(0.587 0.831 0.345) #(0.599 0.843 0.353) #(0.564 0.804 0.328) #(0.544 0.772 0.349) #(0.486 0.682 0.353) #(0.388 0.56 0.27) #(1.0 1.0 1.0) #( )  ))
! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 1/16/2008 12:07'!
arrowLeftBig
    ^((ColorForm
	extent: 14@14
	depth: 8
	fromArray: #( 185273099 185273099 185273099 185270272 185273099 185273098 168495883 185270272 185273099 185272841 168495883 185270272 185273099 185207049 168430090 168493056 185273099 185207049 168430090 168493056 185273098 168363785 151587081 168493056 185272841 151519745 2313 168493056 185272841 150996228 100862217 168493056 185273098 168361993 151587081 168493056 185273099 185207049 168430090 168493056 185273099 185272841 168495883 185270272 185273099 185272841 168495883 185270272 185273099 185273098 168495883 185270272 185273099 185273099 185273099 185270272)
	offset: 0@0)
	colorsFromArray: #(#(0.572 0.804 0.369) #(0.564 0.768 0.412) #(0.576 0.804 0.372) #(0.56 0.804 0.325) #(0.587 0.831 0.345) #(0.599 0.843 0.353) #(0.564 0.804 0.328) #(0.544 0.772 0.349) #(0.486 0.682 0.353) #(0.388 0.56 0.27) #(1.0 1.0 1.0) #( ) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0)  ))! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 10/17/2007 14:38'!
arrowRight
	^((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 185273099 185273099 185273099 185273099 168430347 185273099 185273099 168364555 185273099 185207306 168364298 185273099 185207049 151584777 168495883 185207043 100926720 151653131 185207040 66056 151653131 185207049 151586569 168495883 185207306 168364298 185273099 185273099 168364555 185273099 185273099 168430347 185273099 185273099 185273099 185273099)
	offset: 0@0)
	colorsFromArray: #(#(0.572 0.804 0.369) #(0.564 0.768 0.412) #(0.576 0.804 0.372) #(0.56 0.804 0.325) #(0.587 0.831 0.345) #(0.599 0.843 0.353) #(0.564 0.804 0.328) #(0.544 0.772 0.349) #(0.486 0.682 0.353) #(0.388 0.56 0.27) #(1.0 1.0 1.0) #( )  ))! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 1/16/2008 12:08'!
arrowRightBig
    ^((ColorForm
	extent: 14@14
	depth: 8
	fromArray: #( 185273099 185273099 185273099 185270272 185273099 185207307 185273099 185270272 185273099 185207050 185273099 185270272 185207306 168429833 168495883 185270272 185207306 168429833 168495883 185270272 185207049 151587072 151653131 185270272 185207043 50725893 592394 185270272 185207040 258 134810122 185270272 185207049 151587079 151653131 185270272 185207306 168429833 168495883 185270272 185273099 185207050 185273099 185270272 185273099 185207050 185273099 185270272 185273099 185207307 185273099 185270272 185273099 185273099 185273099 185270272)
	offset: 0@0)
	colorsFromArray: #(#(0.572 0.804 0.369) #(0.564 0.768 0.412) #(0.576 0.804 0.372) #(0.56 0.804 0.325) #(0.587 0.831 0.345) #(0.599 0.843 0.353) #(0.564 0.804 0.328) #(0.544 0.772 0.349) #(0.486 0.682 0.353) #(0.388 0.56 0.27) #(1.0 1.0 1.0) #( ) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0)  ))! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 10/17/2007 14:43'!
text
    ^((ColorForm
	extent: 12@12
	depth: 2
	fromArray: #( 2863311360 2840943104 2835356160 2836732416 2835356160 2836732416 2835356160 2836732416 2835356160 2840943104 2863311360 2863311360)
	offset: 0@0)
	colorsFromArray: #(#(1.0 1.0 1.0) #(0.211 0.285 0.301) #( ) #(0.0 0.0 0.0)  ))! !

!OBMorphicIcons methodsFor: '*ob-enhancements' stamp: 'dr 1/16/2008 12:17'!
textBig
    ^((ColorForm
	extent: 14@14
	depth: 2
	fromArray: #( 2863311520 2840941984 2839545248 2839889312 2839889312 2839545248 2839889312 2839545248 2839889312 2839545248 2840941984 2840941984 2863311520 2863311520)
	offset: 0@0)
	colorsFromArray: #(#(1.0 1.0 1.0) #(0.211 0.285 0.301) #( ) #(0.0 0.0 0.0)  ))
! !

!OBSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 3/12/2008 15:32'!
isBrowseable
    ^false! !

!OBSearchNode methodsFor: '*ob-enhancements' stamp: 'dr 3/4/2008 16:22'!
isSearch
    ^true! !

OBFixedButtonPanel subclass: #OBEnhancementFixedButtonPanel
	instanceVariableNames: 'backPressed currentNode backButton forwardButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Various'!

!OBEnhancementFixedButtonPanel methodsFor: 'executing' stamp: 'dr 3/13/2008 12:04'!
back
    backPressed := true.
    browser historyBack ifTrue: [self changed. self definitionPanel selectSourceTab].! !

!OBEnhancementFixedButtonPanel methodsFor: 'labeling' stamp: 'dr 3/13/2008 10:43'!
backLabel
	^self buttonLabel: '<<'.! !

!OBEnhancementFixedButtonPanel methodsFor: 'building' stamp: 'dr 3/13/2008 10:40'!
buildOn: aBuilder 
	^aBuilder enhancementFixedButtonBar: self with: []! !

!OBEnhancementFixedButtonPanel methodsFor: 'labeling' stamp: 'dr 3/13/2008 10:44'!
buttonLabel: aString
	^ (StringMorph 
		contents: aString
		font: (StrikeFontSet familyName: 'Accouny14' size: 10))
			color: Color red;
			yourself! !

!OBEnhancementFixedButtonPanel methodsFor: 'building' stamp: 'dr 4/10/2008 15:59'!
createBackButton
	backButton ifNil: [backButton := self createButton: #back].
	^backButton. ! !

!OBEnhancementFixedButtonPanel methodsFor: 'private' stamp: 'dr 3/13/2008 10:41'!
createButton: aSymbol
	| button paneColor |
	button := (OBBackButtonMorph 
				on: self
				getState: ('has', aSymbol capitalized, 'Node') asSymbol
				action: aSymbol
				label: (aSymbol, 'Label') asSymbol) panel: self.
	paneColor := browser defaultBackgroundColor.
	button onColor: paneColor lighter offColor: Color lightGray.
	^ button! !

!OBEnhancementFixedButtonPanel methodsFor: 'building' stamp: 'dr 4/10/2008 15:59'!
createForwardButton
	forwardButton ifNil: [forwardButton := self createButton: #forward].
	^forwardButton! !

!OBEnhancementFixedButtonPanel methodsFor: 'accessing' stamp: 'dr 3/13/2008 10:43'!
definitionPanel
    ^browser definitionPanel! !

!OBEnhancementFixedButtonPanel methodsFor: 'executing' stamp: 'dr 3/13/2008 12:04'!
forward
    backPressed := true.
    browser historyForward ifTrue: [self changed. self definitionPanel selectSourceTab]. ! !

!OBEnhancementFixedButtonPanel methodsFor: 'labeling' stamp: 'dr 3/13/2008 10:44'!
forwardLabel
	^ self buttonLabel: '>>'.! !

!OBEnhancementFixedButtonPanel methodsFor: 'testing' stamp: 'dr 3/13/2008 11:05'!
hasBackNode
    ^browser hasBackHistory! !

!OBEnhancementFixedButtonPanel methodsFor: 'testing' stamp: 'dr 3/13/2008 10:53'!
hasForwardNode 
    ^browser hasForwardHistory! !

!OBEnhancementFixedButtonPanel methodsFor: 'initializing' stamp: 'dr 3/13/2008 12:02'!
initialize
    super initialize.
    backPressed := false.! !

!OBEnhancementFixedButtonPanel methodsFor: 'executing' stamp: 'dr 3/13/2008 12:03'!
navigateHistoryInDirection: aSymbol
    | historyNodes index indices operation |
    historyNodes := browser perform: ('history', aSymbol capitalized, 'Nodes') asSymbol. 
    historyNodes ifEmpty: [^self].
    operation := aSymbol = #back ifTrue: [#-] ifFalse: [#+].
    indices := OrderedCollection new.

    historyNodes keysAndValuesDo: [:i :ea | indices add: (browser historyCursor perform: operation with: i)].

    index := OBChoiceRequest 
				prompt: nil
				labels: (historyNodes collect: [:ea | ea displayFullString])
				values: indices
				lines: #().
	index ifNotNil: [
		backPressed := true. 
		browser historyGoToIndex: index.
		self changed].! !

!OBEnhancementFixedButtonPanel methodsFor: 'updating' stamp: 'dr 3/13/2008 15:21'!
selectionChanged: ann
     super selectionChanged: ann.
     self updateBrowseHistory. ! !

!OBEnhancementFixedButtonPanel methodsFor: 'accessing' stamp: 'dr 3/13/2008 12:17'!
setBackPressed: aBoolean
    backPressed := aBoolean! !

!OBEnhancementFixedButtonPanel methodsFor: 'executing' stamp: 'dr 3/13/2008 13:28'!
updateBrowseHistory
    | n |
    n := self currentNode.
    ((backPressed not and: [n isEnvironment not]) and: [
	     (n notNil and: [currentNode isNil]) or: [currentNode notNil and: [n ~= currentNode alias]]]) ifTrue: [
	    browser historyPush: n. self changed].
    (n notNil and: [n isMethodNode]) ifTrue: [n setCurrentParent: browser navigationPanel currentColumn parent].
    currentNode := n. 
    backPressed := false.! !

OBMethodNode subclass: #OBEnrichedMethodNode
	instanceVariableNames: 'metaMethod formatter referencedClass isHighlighted currentParent definition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBEnrichedMethodNode commentStamp: 'dr 10/9/2007 17:12' prior: 0!
I am an enriched method node. I know how the source of the method I represent has to be formatted to reflect dynamic information about this method in the definition view.!

OBEnrichedMethodNode subclass: #OBEnrichedMessageNode
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBEnrichedMessageNode class methodsFor: 'instance creation' stamp: 'dr 11/16/2007 16:03'!
on: aSelector inMethod: aSelector2 inClass: classRef
     ^(self on: (HODataBase default modelMethodFor: (MethodReference class: classRef selector: aSelector2))) 
            setMessage: aSelector selector: aSelector2 class: classRef! !

!OBEnrichedMessageNode methodsFor: 'converting' stamp: 'dr 11/16/2007 15:50'!
asMethodNode
	^ OBEnrichedMethodNode on: selector inClass: self theClass! !

!OBEnrichedMessageNode methodsFor: 'displaying' stamp: 'dr 11/16/2007 15:51'!
name
	^ message! !

!OBEnrichedMessageNode methodsFor: 'accessing' stamp: 'dr 11/16/2007 15:50'!
selection
	| methodNode assoc |
	methodNode := Parser new 
					parse: self source
					class: self theClass.
	assoc := (methodNode encoder rawSourceRanges) 
			associations detect: [:ea | ea key selectorIs: message]
						ifNone: [nil -> (1 to: 0)].
						"Some messages are generated by the compiler."
	^ assoc value! !

!OBEnrichedMessageNode methodsFor: 'initializing' stamp: 'dr 11/16/2007 15:50'!
setMessage: aSelector selector: aSelector2 class: aClass
	message := aSelector.
	selector := aSelector2.
	self theClass: aClass! !

!OBEnrichedMethodNode class methodsFor: 'instance creation' stamp: 'dr 2/23/2008 16:11'!
fromMethodNode: aNode
    ^(self on: ((Smalltalk at: #HODataBase) default modelMethodFor: aNode reference)) metaNode: aNode metaNode; yourself! !

!OBEnrichedMethodNode class methodsFor: 'instance creation' stamp: 'dr 10/5/2007 11:06'!
on: aHOMethod
    ^(super on: aHOMethod methodReference) setMetaMethod: aHOMethod; yourself! !

!OBEnrichedMethodNode class methodsFor: 'instance creation' stamp: 'dr 10/5/2007 11:20'!
on: aHOMethod referencedClass: aClass
    ^(super on: aHOMethod methodReference) setMetaMethod: aHOMethod; setReferencedClass: aClass; yourself! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 2/21/2008 12:21'!
currentParent
    ^currentParent! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 4/10/2008 15:08'!
definition
	^ (OBEnrichedMethodDefinition
		selection: self selection
		source: self source
		inClass: self theClass) setFormatter: formatter! !

!OBEnrichedMethodNode methodsFor: 'displaying' stamp: 'dr 11/5/2007 16:58'!
displayString
    | string |
    string := super displayString.  
    self isHighlighted ifTrue: [^string asText addAttribute: TextColor green].
    ^string! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 1/29/2008 17:08'!
formatter
	^formatter! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 4/10/2008 15:06'!
getDefinition
	definition ifNil: [definition := self definition].
	^definition! !

!OBEnrichedMethodNode methodsFor: 'initializing' stamp: 'dr 10/15/2007 16:23'!
initialize
    super initialize.
    isHighlighted := false! !

!OBEnrichedMethodNode methodsFor: 'ancestry' stamp: 'dr 4/10/2008 14:41'!
isDescendantOf: aNode 
    ^aNode = self! !

!OBEnrichedMethodNode methodsFor: 'ancestry' stamp: 'dr 2/21/2008 14:49'!
isDescendantOfClassRef: aNode
    self currentParent ifNotNil: [self currentParent = aNode ifFalse: [^false]].
    ^self referencingClasses includes: aNode! !

!OBEnrichedMethodNode methodsFor: 'ancestry' stamp: 'dr 4/10/2008 14:00'!
isDescendantOfMethod: aNode
    ^aNode = self or: [aNode selector = self selector]! !

!OBEnrichedMethodNode methodsFor: 'highlighting' stamp: 'dr 10/15/2007 16:22'!
isHighlighted
    ^isHighlighted! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 10/5/2007 11:06'!
metaMethod
    ^metaMethod! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 11/16/2007 16:38'!
referencedClass
    ^referencedClass! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 2/21/2008 12:22'!
setCurrentParent: aNode
    currentParent := aNode! !

!OBEnrichedMethodNode methodsFor: 'highlighting' stamp: 'dr 10/15/2007 16:22'!
setIsHighlighted
    isHighlighted := true! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 10/5/2007 11:06'!
setMetaMethod: aMetaMethod
    metaMethod := aMetaMethod! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 10/5/2007 11:20'!
setReferencedClass: aClass
	referencedClass := aClass! !

!OBEnrichedMethodNode methodsFor: 'highlighting' stamp: 'dr 10/15/2007 16:40'!
setUnhighlighted
    isHighlighted := false! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 1/28/2008 15:28'!
source
	| method |
	method := self theClass compiledMethodAt: self selector ifAbsent: [^ self defaultSource].
	formatter := HOFormatter metaMethod: self metaMethod referencedClass: referencedClass.
	^formatter formatCodeForMethod: method! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 4/10/2008 14:00'!
species
    ^OBMethodNode! !

!OBEnrichedMethodNode methodsFor: 'accessing' stamp: 'dr 4/10/2008 15:01'!
updateMetaMethod
    metaMethod := HODataBase default modelMethodFor: self reference! !

!OBEnrichedMethodNode methodsFor: 'displaying' stamp: 'dr 10/4/2007 13:30'!
usageName
    ^self fullName", ' (', self methodDependency displayString, ')'"! !

OBMethodNode subclass: #OBMethodExtensionNode
	instanceVariableNames: 'categoryExtensionNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBMethodExtensionNode methodsFor: 'accessing' stamp: 'dr 3/5/2008 15:56'!
category
    ^self reference category asString asLowercase! !

!OBMethodExtensionNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 13:55'!
categoryExtensionNode: aCategoryExtensionNode
    categoryExtensionNode := aCategoryExtensionNode! !

!OBMethodExtensionNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 14:47'!
classExtensionNode
    ^categoryExtensionNode classExtensionNode! !

!OBMethodExtensionNode methodsFor: 'displaying' stamp: 'dr 3/5/2008 16:05'!
displayString
    | text |
    text := super displayString asText.
    (self category allButFirst beginsWith: self extensionName asLowercase) ifTrue: [
	   text addAttribute: TextEmphasis bold.
	   (self category includesSubString: '-overrides') ifTrue: [text addAttribute: TextColor red].	   	      
    ].
    ^text! !

!OBMethodExtensionNode methodsFor: 'accessing' stamp: 'dr 2/24/2008 15:21'!
extensionName
   ^categoryExtensionNode extensionName! !

!OBMethodExtensionNode methodsFor: 'ancestry' stamp: 'dr 2/24/2008 14:48'!
isDescendantOfClass: aClassNode
   ^((super isDescendantOfClass: aClassNode) and: [aClassNode isKindOf: OBClassExtensionNode]) 
                                                    and: [self classExtensionNode = aClassNode]! !

!OBMethodExtensionNode methodsFor: 'ancestry' stamp: 'dr 3/3/2008 17:22'!
isDescendantOfClassCat: aClassCategoryNode
	(aClassCategoryNode isKindOf: OBMonticelloPackageNode) ifFalse: [^false].
	aClassCategoryNode = self classExtensionNode package ifFalse: [^false].
	^(aClassCategoryNode extensionClasses collect: [:ea | ea theNonMetaClass]) includes: self theNonMetaClass.! !

!OBMethodExtensionNode methodsFor: 'ancestry' stamp: 'dr 2/24/2008 15:29'!
isDescendantOfMethodCat: other 
   ^(super isDescendantOfMethodCat: other) "and: [categoryExtensionNode class = other class]"! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 2/14/2008 11:56'!
classHierarchy
    ^self classNode classHierarchy! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:03'!
displayFullString
    ^self fullName! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 6/7/2007 16:16'!
dropOnSmartGroup: aNode

	aNode addAlias: self.
	aNode signalChildrenChanged.! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:12'!
isInstrumented 
    ^(Smalltalk classNamed: #HODataBase) notNil and: [(Smalltalk at: #HODataBase) default isInstrumentedMethod: self reference]! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 5/25/2007 17:06'!
isMethodHolderNode
    ^true! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 11/2/2006 11:21'!
isMethodNode
	^true! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 14:05'!
isNodeWithReferences
    ^true! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 10/12/2007 14:23'!
prefixedName
    ^'#', self name! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 1/18/2008 17:31'!
referencedClass
    ^nil! !

!OBMethodNode methodsFor: '*ob-enhancements' stamp: 'dr 10/15/2007 16:43'!
setUnhighlighted
    ! !

IconicButton subclass: #OBIconicButton
	instanceVariableNames: 'windowClass openLabel targets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-ToolBar'!

!OBIconicButton class methodsFor: 'buttons' stamp: 'dr 12/18/2007 15:00'!
browserIcon
    ^(Form
	extent: 52@44
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 4290622893 4286874756 4286874756 4287401100 4287927444 4290624957 4290624957 4287401100 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4287401100 4286874756 4289570204 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290624957 4292796126 4291743438 4285229939 4286282619 4286874756 4291217094 4289045933 4285229939 4290624957 4289045933 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4291743438 4291743438 4288453780 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4286282628 4286282628 4290624966 4294967295 4294967295 4292271822 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293390302 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453788 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287929476 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4290624966 4294967295 4294967295 4294967295 4293916655 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293916647 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453788 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453772 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4290624966 4294967295 4290624966 4294967295 4290624966 4294967295 4294967295 4294442991 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293916647 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453788 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453772 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4290624966 4290624966 4294967295 4294967295 4294967295 4294442991 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293916647 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453788 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453772 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294442991 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293916647 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453788 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453772 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4290624966 4294967295 4286282628 4286282628 4290624966 4286282628 4290100661 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293916647 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453788 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453772 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4290624966 4290624966 4286282628 4294967295 4286282628 4290624966 4294967295 4294442991 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796118 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453788 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453772 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4290624966 4290624966 4290624966 4294967295 4294967295 4294442991 4292796126 4285229931 4289045925 4289045925 4293914607 4290624966 4294967295 4290624966 4294967295 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453788 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453772 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291217094 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388254 4291217094 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4291217094 4291743438 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4290624957 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4288453772 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287927444 4290624966 4290624966 4290624966 4286282628 4290624966 4294967295 4290624966 4290624966 4290624966 4294967295 4290624966 4290624966 4286282628 4290624966 4290624966 4290624966 4290624966 4294967295 4290624966 4294967295 4290624966 4286282628 4294967295 4294967295 4286282628 4294967295 4290624966 4294967295 4290624966 4290624966 4286282628 4294967295 4286282628 4294967295 4289572261 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289045908 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287929476 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453772 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453772 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453772 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453772 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453772 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453772 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453772 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453772 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287401083 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290096549 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4287925371 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291212692 4278190088 4278190088 4279242768 4282530097 4284701258 4293910197 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291212692 4278190088 4281938217 4290094468 4282530097 4278190088 4286872419 0 4293910197 4290620820 4293381805 0 4293381805 0 0 0 0 0 0 0 4292263333 4291212692 0 0 4290620820 4293381805 0 4292263333 4291212692 0 0 0 0 4291212692 0 0 0 0 0 0 0 0 0 4293910197 4290620820 4293381805 0 4293381805 0 0 0 0 4291212692 4278190088 4281938217 4290620820 4285754202 4278190088 4285754202 0 4291212692 4278190088 4281938217 4279242768 4278716424 4293910197 4284701258 4278190088 4278190088 4278190088 4287923315 0 4287923315 4278190088 4291212692 4293910197 4278190088 4283056697 0 4281938217 4279769104 0 4290094476 4278190088 4278190088 4278190088 4278190088 4291212692 4293910197 4284701258 4278190088 4278190088 4279242768 4290094476 0 4291212692 4278190088 4281938217 4279242768 4278716424 0 0 0 0 4291212692 4278190088 4278190088 4278190088 4278190088 4279242768 4292263333 0 4291212692 4278190088 4280885537 4291212692 4291212692 4285225554 4278190088 4285754202 4291212692 4281413929 4278190088 4292263333 4292263333 4278190088 4286872419 4290094476 4279242768 4279769104 4293910197 4278190088 4284109378 0 4286872419 4278716416 4293381805 0 4290620820 4293910197 4285225554 4278190088 4287923315 0 4281938217 4279769104 0 4291212692 4278190088 4280885537 4291212692 4291212692 0 0 0 0 4291212692 4278190088 4281938217 4290620820 4284701258 4278190088 4283056697 0 4291212692 4278190088 4286872419 0 0 4283056697 4278190088 4291212692 0 4287923315 4278190088 4290094476 0 4279242768 4283056697 4285754202 4285225554 4278716416 4287923315 4278190088 4287923315 0 4290094476 4278190088 4278190088 4281411873 4284701258 4293910197 4283056697 4278190088 4278190088 4278190088 4278190088 4278716416 4293381805 4291212692 4278190088 4286872419 0 0 0 0 0 0 4291212692 4278190088 4283056697 0 4292263333 4278190088 4281938217 0 4291212692 4278190088 4286872419 0 0 4284109378 4278190088 4290094476 0 4285225554 4278190088 4291212692 0 4284109378 4278716424 4281938217 4289041531 4283056697 4281938217 4278190088 4292263333 0 0 4293381805 4290620820 4283583042 4278190088 4290094476 4284109378 4278190088 4291212692 0 0 0 0 4291212692 4278190088 4286872419 0 0 0 0 0 0 4291212692 4278190088 4278190088 4278190088 4278190088 4278190088 4285225554 0 4291212692 4278190088 4286872419 0 0 4292263333 4279242768 4279242768 4281411873 4278190088 4280887585 0 0 4287923315 4278190088 4278716416 4293381805 4285754202 4278190088 4279769104 0 0 4286872419 4284701258 4286870371 4282530097 4278190088 4292263333 4292263333 4279242768 4280361240 4286870371 4285752146 4279769104 0 4291212692 4278190088 4286872419 0 0 0 0 0 0 4293381805 4286870371 4286870371 4286870371 4286870371 4290094468 4293910197 0 4293381805 4286870371 4291212692 0 0 0 4293910197 4286870371 4286870371 4287923315 0 0 0 4293381805 4286870371 4286872419 0 4291212692 4286870371 4289041531 0 0 4291212692 4286870371 4286870371 4286870371 4289041531 0 0 4293910197 4286870371 4286870371 4286870371 4290094476 0 4293381805 4286870371 4291212692 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!OBIconicButton class methodsFor: 'buttons' stamp: 'dr 1/7/2008 15:16'!
debuggerIcon
    ^(Form
	extent: 66@43
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 198300113 365874894 366730203 366730203 367516635 366730203 367519719 367519719 366730203 366730203 367516635 367516635 367516635 368306151 368306151 368306151 368306151 368306151 368306151 368306151 368306151 368306151 368303067 368303067 368303067 368303067 368303067 366726862 366726862 381267630 265080012 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2177814224 4106996426 4073902802 4073968595 4074559961 4073967824 4074822618 4074625498 4074164688 4074098640 4074624726 4074492883 4075346650 4075940843 4075939815 4075939558 4075939300 4075938275 4075938017 4075937760 4075937760 4075937760 4075871966 4075871454 4075871454 4076002781 4075476951 4074292934 4074096069 4123309750 2798635209 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2295056843 4275097294 4291940302 4290690492 4292005840 4290032306 4290360501 4290031792 4290492341 4290754744 4290754745 4290820023 4292727764 4294636532 4294701296 4294635759 4294700526 4294634988 4294700268 4294634219 4294699499 4294633448 4294633448 4294633190 4294633190 4294633448 4293580761 4290818481 4292199108 4292001985 2932128442 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296109787 4275558372 4292663782 4292334820 4291874528 4292005853 4291807960 4291808472 4291873757 4291939292 4291807446 4292531167 4292333789 4292530911 4292531166 4292398813 4292859359 4293319651 4293451235 4293319906 4293385186 4293319137 4293384673 4293319136 4293319136 4293318880 4293318880 4293253599 4293055703 4292528329 2932523457 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296044251 4272597448 4289243079 4289242823 4289242823 4289572047 4288848582 4289374921 4289703629 4289505995 4289572047 4290163920 4289967055 4290690519 4290690524 4290098135 4291545826 4293059309 4293125103 4293124845 4292993517 4293059055 4293059311 4293124847 4293059309 4292993773 4293124846 4293388018 4291939798 4289963429 2932062137 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296109786 4274110659 4290756546 4290164409 4290624704 4291282890 4290361790 4290295995 4290493373 4291480269 4291940566 4290822338 4291414476 4293256681 4294243577 4293980662 4293980403 4294111986 4294177779 4294440696 4294440952 4294111988 4293651438 4294046195 4294111987 4294374903 4294440951 4294375159 4293453029 4291872197 2932326336 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296110043 4274571206 4290953920 4290493368 4290624956 4291348679 4291743692 4291414727 4290690748 4291348679 4290888128 4291348678 4291085508 4291875024 4292138195 4291809229 4291217093 4291677902 4291414472 4291217093 4290953922 4292006609 4291677645 4290953923 4291611853 4290822336 4290230198 4290953665 4292926941 4293713888 2933048518 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296109786 4274637257 4292006355 4291480267 4291546060 4290888129 4290032820 4290756543 4291085508 4290624700 4290624957 4291217094 4290230200 4291085508 4290756544 4290427578 4290164662 4290953922 4290756544 4290230456 4290559164 4290427578 4290888386 4290427578 4290361785 4290098613 4289637805 4290690750 4291808717 4291345853 2932522944 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296108760 4274110400 4292006353 4291480009 4292006610 4291348680 4290755772 4291019458 4291545802 4290888129 4291808974 4290953665 4292729820 4293124321 4293256163 4293190113 4292992991 4293058784 4293453542 4293190627 4293058784 4292400854 4292466647 4292926941 4292663511 4293058527 4293058527 4293321442 4292530898 4290160552 2932259514 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296109272 4275031758 4292663769 4292729305 4292400854 4292597719 4291874767 4292071375 4292860635 4292729048 4292597462 4292466133 4293452771 4293058013 4293058013 4292992220 4293057756 4293123549 4293057499 4293715429 4293517793 4293583329 4293123292 4292991963 4292925913 4293123292 4293123292 4292991706 4293123292 4293582815 2933312202 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296109272 4274111170 4292006867 4292927712 4292335575 4291941074 4290690750 4290756543 4292796126 4292335576 4291809232 4292532954 4293585642 4291875024 4291151558 4291019716 4291151301 4291085508 4291480266 4294177779 4293585899 4292993505 4291217351 4290691007 4290822849 4291151301 4291414473 4291085765 4292401368 4294177779 2933378511 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296634845 4276150496 4293585642 4293454056 4293783021 4293059298 4292927712 4292861919 4292993505 4293256677 4292730333 4293783021 4294506744 4294506744 4294177779 4294243572 4294046193 4294111986 4294177779 4294506744 4294704123 4294572537 4294243572 4293783021 4294111986 4294243572 4294177779 4294243572 4294506744 4294374902 2933312205 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296897503 4275294930 4291414473 4291940817 4291875024 4291283143 4291546059 4291348681 4291480266 4291809231 4291743438 4292467161 4292138196 4292335575 4292664796 4292137940 4291875024 4292861919 4292138196 4291809231 4292335575 4292269782 4292138196 4292336087 4292335575 4292072403 4292796126 4292138196 4292269782 4292335061 2932523971 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2297029603 4275952860 4291611596 4291874768 4291479754 4291413705 4292137684 4291545804 4291216838 4291677133 4291809231 4292466648 4291611596 4291545803 4292269526 4291875280 4291085252 4292335063 4292203477 4291479754 4291545803 4291348168 4290756287 4291808463 4291940817 4291348680 4292072403 4291809231 4291414473 4291414473 2932326336 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296897503 4277466099 4294309109 4293258469 4291682764 4292536794 4293390055 4293192931 4293258468 4292996065 4292732893 4292864990 4292863965 4293324006 4292601819 4292667868 4292864222 4293192931 4293258724 4293192931 4293061602 4292601819 4292863966 4292536026 4293849582 4294243316 4294243572 4294309365 4293058527 4291148988 2932260031 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296765917 4277730041 4294967295 4293982448 4291684300 4291881423 4292800477 4292866014 4292932064 4292275925 4291224260 4291421896 4292144595 4292538074 4291290565 4291750093 4291027650 4292012753 4292866526 4292998113 4292472536 4291815886 4293194467 4292209877 4293785581 4294967295 4294967295 4294901502 4292860891 4289371292 2931798963 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296240854 4274577606 4290830528 4291026881 4291289284 4291421641 4292340438 4291486153 4290895808 4291026880 4291092418 4291224259 4291420871 4292208852 4292077778 4291486665 4290698941 4291815118 4292143317 4290763965 4291618507 4290895808 4290633147 4291026882 4292602842 4294638330 4294704123 4294769916 4293584871 4292004039 2932260287 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296370902 4275886806 4292335568 4292993244 4292927706 4291612099 4292794836 4293124318 4293059036 4292927706 4292599252 4292466128 4292268237 4293123291 4292794582 4292663509 4292401617 4292204750 4292729814 4292992474 4292400078 4291282875 4292204749 4292796375 4292796119 4293649636 4293715172 4293847015 4292201676 4289634208 2932062137 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296239830 4273912765 4291216326 4294046451 4293387235 4290357419 4292727507 4294835709 4294967295 4294967295 4294967295 4291806148 4290489261 4292728279 4290493115 4291085252 4291413448 4291414217 4290821567 4292335576 4291148218 4290422955 4294570227 4294967295 4294967295 4294967038 4294967038 4294901246 4292991963 4289502364 2931798964 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296107732 4273255348 4291480524 4292072660 4291545545 4290819252 4292793813 4294638073 4294967295 4294967295 4294835709 4292136140 4291213497 4292267726 4290230714 4291546059 4290295993 4290427579 4292072660 4291414987 4290688437 4291081653 4294241773 4294967295 4294967295 4294967295 4294967295 4294901502 4293453028 4290950582 2932062650 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296765146 4276676583 4294177779 4293849071 4293453028 4292857808 4293188571 4294637816 4294967295 4294967295 4294704637 4293320414 4292857294 4293386464 4293783535 4294374901 4293783020 4293585642 4294572537 4293848814 4292793300 4292529100 4294044394 4294967295 4294967295 4294967295 4294967295 4294967038 4293979372 4292989394 2932326335 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2296108758 4277861114 4294967295 4294967295 4293979372 4291082424 4292728020 4294638073 4294967295 4294967295 4294835709 4292202190 4291213497 4294175980 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291938761 4291016375 4294110188 4294967295 4294967295 4294967295 4294967295 4294901502 4293453028 4291016375 2931405747 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2294925255 4277729528 4294967295 4294967295 4293650150 4290226601 4292661969 4294769915 4294967295 4294967295 4294835709 4291806147 4290358188 4294307566 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291214524 4290160552 4294373359 4294967295 4294967295 4294967295 4294967295 4294901502 4293255135 4289765280 2930418852 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2160707529 4089758660 4057124302 4057781719 4057386189 4056464317 4057254602 4057715925 4057716183 4057716183 4057715926 4056662724 4056595389 4057648848 4057781719 4057716183 4057716183 4057716183 4057716183 4057716183 4056596929 4056464317 4057714642 4057716183 4057716183 4057716183 4057781719 4057782232 4056532422 4105021609 2780674493 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33554431 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 50331647 33554431 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 218103808 2785017856 2566914048 2566914048 2566914048 1778384896 67108864 0 0 0 0 0 0 0 0 218103808 3238002688 872415232 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 536870912 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 117440512 0 0 0 0 0 0 0 536870912 4278190080 1962934272 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 452984832 4278190080 1962934272 0 16777216 2348810240 4278190080 2566914048 0 0 754974720 1442840576 872415232 0 0 452984832 4278190080 2348810240 754974720 1442840576 167772160 0 33554432 754974720 218103808 0 67108864 872415232 67108864 0 0 754974720 1610612736 285212672 452984832 536870912 0 0 754974720 1610612736 285212672 452984832 536870912 0 0 754974720 1442840576 872415232 0 0 33554432 754974720 285212672 1291845632 637534208 0 0 0 0 0 0 0 0 0 0 0 452984832 4278190080 1962934272 0 0 33554432 4278190080 3741319168 0 2566914048 4278190080 4278190080 4278190080 3238002688 0 452984832 4278190080 4278190080 4278190080 4278190080 4278190080 285212672 536870912 4278190080 2147483648 0 536870912 4278190080 637534208 0 2566914048 4278190080 4278190080 4278190080 4278190080 4009754624 0 2566914048 4278190080 4278190080 4278190080 4278190080 4009754624 0 2566914048 4278190080 4278190080 4278190080 3238002688 0 536870912 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 452984832 4278190080 1962934272 0 0 16777216 4278190080 4278190080 285212672 4278190080 2785017856 0 1962934272 4278190080 452984832 452984832 4278190080 3003121664 0 1006632960 4278190080 2785017856 452984832 4278190080 1962934272 0 452984832 4278190080 536870912 117440512 4278190080 3741319168 16777216 536870912 4278190080 3741319168 117440512 4278190080 3741319168 16777216 536870912 4278190080 3741319168 285212672 4278190080 2785017856 0 1962934272 4278190080 452984832 452984832 4278190080 3741319168 352321536 167772160 0 0 0 0 0 0 0 0 0 0 0 452984832 4278190080 1962934272 0 0 16777216 4278190080 3741319168 452984832 4278190080 4278190080 4009754624 4278190080 4278190080 1006632960 452984832 4278190080 2566914048 0 0 4278190080 3741319168 452984832 4278190080 1962934272 0 452984832 4278190080 536870912 452984832 4278190080 1610612736 0 16777216 4278190080 3489660928 452984832 4278190080 1610612736 0 16777216 4278190080 3489660928 452984832 4278190080 4278190080 4009754624 4278190080 4278190080 1006632960 452984832 4278190080 1778384896 0 0 0 0 0 0 0 0 0 0 0 0 0 452984832 4278190080 1778384896 0 0 754974720 4278190080 3238002688 536870912 4278190080 3489660928 352321536 1006632960 1442840576 352321536 452984832 4278190080 1962934272 0 33554432 4278190080 3489660928 452984832 4278190080 1778384896 0 536870912 4278190080 536870912 218103808 4278190080 2785017856 0 33554432 4278190080 3489660928 218103808 4278190080 2785017856 0 33554432 4278190080 3489660928 536870912 4278190080 3489660928 352321536 1006632960 1442840576 352321536 452984832 4278190080 1962934272 0 0 0 0 0 0 0 0 0 0 0 0 0 452984832 4278190080 3741319168 2566914048 3238002688 4278190080 4278190080 536870912 67108864 4278190080 4009754624 637534208 3238002688 4278190080 285212672 452984832 4278190080 4278190080 1442840576 3238002688 4278190080 1442840576 352321536 4278190080 4009754624 872415232 4278190080 4278190080 536870912 0 4278190080 4278190080 2566914048 4278190080 4278190080 3489660928 0 4278190080 4278190080 2566914048 4278190080 4278190080 3489660928 67108864 4278190080 4009754624 637534208 3238002688 4278190080 285212672 452984832 4278190080 1962934272 0 0 0 0 0 0 0 0 0 0 0 0 0 452984832 4278190080 4278190080 4278190080 4278190080 3741319168 637534208 0 0 637534208 4278190080 4278190080 4278190080 1778384896 0 452984832 4278190080 3003121664 4278190080 4278190080 2785017856 0 0 2785017856 4278190080 4278190080 3489660928 4278190080 536870912 0 167772160 3489660928 4278190080 3003121664 4278190080 3489660928 0 167772160 3489660928 4278190080 3003121664 4278190080 3489660928 0 637534208 4278190080 4278190080 4278190080 1778384896 0 452984832 4278190080 1610612736 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 67108864 16777216 0 0 0 0 0 0 33554432 0 0 0 0 33554432 16777216 0 0 0 16777216 3741319168 3003121664 167772160 285212672 4278190080 3741319168 16777216 3741319168 3003121664 167772160 285212672 4278190080 3741319168 0 0 0 67108864 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3238002688 4278190080 4278190080 4278190080 4278190080 754974720 0 3238002688 4278190080 4278190080 4278190080 4278190080 754974720 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 452984832 1006632960 872415232 167772160 0 0 0 452984832 1006632960 872415232 167772160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!OBIconicButton class methodsFor: 'initialize-release' stamp: 'dr 1/7/2008 16:24'!
initialize
   super initialize.
   self installButtons.! !

!OBIconicButton class methodsFor: 'buttons' stamp: 'dr 1/7/2008 14:50'!
inspectorIcon
    ^(Form
	extent: 65@44
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 83886079 181193932 181193932 181193932 182904550 182904550 182904550 182904550 182904550 182904550 182904550 182904550 182904550 182904550 182904550 182904550 182904550 182904550 182904550 182904550 182904550 182904550 181193958 182904550 182904550 181193932 181193932 181193932 165929955 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1910694630 4107325906 4072915909 4073705424 4074560733 4074823907 4074889699 4074889700 4074758112 4074889699 4074824163 4074823905 4074758113 4074758113 4074758368 4074692319 4074692319 4074692319 4074692318 4074692318 4074692318 4074626782 4074494941 4074429146 4074363353 4073771217 4072521151 4140156358 3872707543 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2009713097 4275755995 4291875024 4293388263 4291085508 4290427578 4293980400 4292467161 4291743438 4292927455 4292927712 4292401368 4292927455 4293453799 4294375158 4294440951 4294375158 4294309365 4294309108 4294243571 4294177778 4294243571 4293980142 4291019200 4290756028 4292269525 4289966770 4291282630 4056072898 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2009055169 4274966222 4289111718 4292598747 4288914339 4287664272 4293125091 4289967027 4287861651 4290559164 4289835441 4287335564 4288519581 4290559164 4294046193 4294374644 4294177522 4294111986 4294111729 4294046193 4293980400 4294046193 4293716971 4288782496 4287861651 4291216837 4290164149 4290493114 4055546297 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2009910476 4276610790 4293454056 4293980400 4292993505 4292401368 4293782764 4292006610 4291414473 4293059298 4292664540 4290887872 4290690493 4291743438 4294045936 4293980143 4293848557 4293783021 4293782764 4293717228 4293585642 4293585642 4293519849 4292137939 4291808974 4292927455 4291677388 4292203989 4056599242 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010700763 4276808170 4293256677 4292467161 4292006867 4294046194 4294178036 4294440951 4294572537 4294243829 4293190627 4291874767 4291808974 4292927712 4293848557 4293914607 4293914350 4293848814 4293848814 4293848814 4293848557 4293783021 4293783021 4294046193 4294374901 4292993505 4291743438 4291480266 4056664778 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010897371 4275426774 4289901234 4289572270 4289901234 4294046195 4294967295 4294901502 4294967295 4294901502 4292796126 4287795858 4288716960 4292401368 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901759 4294967295 4293651435 4288190616 4288256409 4056270020 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010699995 4275953118 4291480266 4291546059 4292730333 4293454056 4293783021 4292993505 4293914607 4293322470 4291875024 4288980132 4289374890 4292269782 4294572537 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293256677 4289243304 4288979875 4056269763 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010897371 4275163600 4288585374 4290427578 4292269784 4290032820 4289111718 4289638062 4293125091 4291348680 4290624700 4290690493 4290822079 4292401625 4294572537 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293322213 4291413702 4290822336 4056401349 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010568408 4276216288 4292861919 4294111986 4294440951 4294177779 4293914607 4294046193 4294835709 4294440951 4293125091 4291414473 4291282887 4292730333 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293519849 4291874767 4291282116 4056467399 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010699992 4275953117 4292401368 4294638330 4294967295 4294967295 4294967295 4294967295 4294901502 4294967295 4292796126 4287730065 4288387995 4292269782 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293519592 4291808974 4291216323 4056401863 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010568408 4275624151 4292401368 4293454313 4293783021 4293783021 4293914607 4294375415 4293783021 4293651435 4292335575 4289374890 4289835441 4292466904 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293256420 4290361528 4289900977 4056138691 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010568406 4273847740 4288190873 4289111461 4291413702 4291480009 4291677131 4293059298 4289769648 4288980132 4291414473 4293585642 4293322213 4292927712 4294506487 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293454056 4288124823 4287861651 4056072898 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010436822 4274176705 4288651166 4289111205 4291019201 4291347652 4291282373 4292664283 4289637805 4288914082 4291677645 4294243572 4294046193 4293124834 4293914607 4294440951 4294309365 4294309365 4294309108 4294309108 4294243572 4294243572 4294243572 4294243572 4294506744 4293125091 4290164406 4289901234 4056401863 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010568408 4275097818 4291808984 4292401369 4292401368 4292401112 4292532697 4292861919 4292598747 4292532697 4292664540 4293125091 4293125091 4293190627 4293125091 4293190627 4293125091 4293125091 4293124834 4293124834 4293059298 4293059298 4293059041 4293059041 4293125091 4292335318 4291282630 4291151301 4056665035 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010568406 4274637027 4293519348 4294506999 4294440951 4294375158 4294375158 4294375158 4294506744 4294506744 4294440951 4294309365 4294309365 4294375158 4294309365 4294309108 4294243572 4294243572 4294243572 4294243572 4294243572 4294243572 4294243572 4294243572 4294506744 4293125348 4289638062 4289374890 4056270277 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010568406 4274636773 4293519610 4294835711 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293519849 4287993237 4287861651 4056270020 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010568406 4276676844 4294572542 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293190884 4290558393 4290032563 4056138434 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010568406 4276940012 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293519849 4291940560 4291413702 4056270020 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010568406 4276940012 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293519592 4291808717 4291216323 4056270020 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010568406 4276940012 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293519592 4291808717 4291216323 4056270020 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2010436822 4276940012 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293454056 4292006353 4291479752 4056270020 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2009581511 4276479204 4294835709 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293125091 4289440683 4288914339 4055217589 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2008199860 4275755481 4294769659 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293651435 4287927701 4287466893 4053901729 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2009055169 4275624151 4293783021 4293980400 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309365 4294309108 4294309108 4294309108 4294243572 4294243572 4294243572 4294243572 4294243572 4294243572 4294243572 4294572537 4292993505 4289967027 4289572012 4054822831 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1893720036 4088837815 4053770142 4054493866 4055743933 4056072898 4056007106 4056007105 4056007105 4056007105 4056007105 4055941313 4055941312 4055941312 4055940800 4055940800 4055940800 4055809728 4055809728 4055809728 4055809726 4055809726 4055809726 4055809726 4055940800 4055085747 4053440922 4121075874 3836916404 50331647 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1056964608 3053453312 251658240 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 352321536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1845493760 4278190080 587202560 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 2147483648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1845493760 4278190080 587202560 33554432 872415232 67108864 754974720 1442840576 352321536 0 0 33554432 1140850688 1442840576 1006632960 16777216 0 285212672 637534208 167772160 1291845632 1140850688 0 0 0 218103808 1442840576 1291845632 33554432 0 0 0 452984832 1442840576 1140850688 67108864 0 754974720 4278190080 2785017856 285212672 0 33554432 1140850688 1442840576 536870912 0 0 33554432 754974720 285212672 1291845632 637534208 0 0 0 0 0 0 0 0 0 0 0 0 1845493760 4278190080 587202560 536870912 4278190080 4278190080 4278190080 4278190080 4278190080 218103808 0 4278190080 4278190080 4278190080 4278190080 4278190080 0 1962934272 4278190080 4278190080 4278190080 4278190080 3741319168 0 754974720 4278190080 4278190080 4278190080 4278190080 167772160 0 1962934272 4278190080 4278190080 4278190080 4278190080 117440512 4278190080 4278190080 4278190080 4278190080 218103808 4278190080 4278190080 4278190080 4278190080 2566914048 0 536870912 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 1845493760 4278190080 587202560 452984832 4278190080 3489660928 0 1610612736 4278190080 536870912 352321536 4278190080 4009754624 167772160 1610612736 1140850688 0 1778384896 4278190080 1610612736 0 3003121664 4278190080 452984832 4278190080 4278190080 67108864 352321536 4278190080 2348810240 67108864 4278190080 3741319168 16777216 1140850688 4278190080 1140850688 218103808 4278190080 2348810240 16777216 3489660928 4278190080 872415232 33554432 3238002688 4278190080 352321536 452984832 4278190080 3741319168 352321536 167772160 0 0 0 0 0 0 0 0 0 0 0 0 1845493760 4278190080 587202560 452984832 4278190080 1778384896 0 352321536 4278190080 536870912 0 4278190080 4278190080 4278190080 4278190080 1778384896 0 1778384896 4278190080 167772160 0 536870912 4278190080 1627389952 4278190080 4278190080 4009754624 4278190080 4278190080 4278190080 452984832 4278190080 1778384896 0 0 0 0 16777216 4278190080 1778384896 0 3741319168 4278190080 0 0 637534208 4278190080 1778384896 452984832 4278190080 1778384896 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1845493760 4278190080 587202560 452984832 4278190080 1962934272 0 452984832 4278190080 536870912 0 352321536 1291845632 2147483648 4009754624 4278190080 536870912 1778384896 4278190080 452984832 0 1140850688 4278190080 889192448 4278190080 4278190080 536870912 637534208 1442840576 872415232 352321536 4278190080 2566914048 0 33554432 1962934272 352321536 16777216 4278190080 1778384896 0 3741319168 4278190080 0 0 1291845632 4278190080 1006632960 452984832 4278190080 1962934272 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1845493760 4278190080 587202560 452984832 4278190080 1962934272 0 452984832 4278190080 536870912 637534208 4278190080 3003121664 218103808 3489660928 4278190080 452984832 1778384896 4278190080 4009754624 1291845632 4278190080 4278190080 218103808 3489660928 4278190080 1442840576 1610612736 4278190080 2147483648 0 4278190080 4278190080 1778384896 3003121664 4278190080 1291845632 33554432 4278190080 3489660928 1610612736 2566914048 4278190080 3238002688 1442840576 4278190080 4278190080 67108864 452984832 4278190080 1962934272 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1845493760 4278190080 503316480 452984832 4278190080 1778384896 0 452984832 4278190080 536870912 0 2147483648 4278190080 4278190080 4278190080 2147483648 0 1778384896 4278190080 3238002688 4278190080 4278190080 1291845632 0 67108864 3489660928 4278190080 4278190080 3238002688 16777216 0 352321536 4278190080 4278190080 4278190080 2566914048 0 0 3489660928 4278190080 4009754624 0 2566914048 4278190080 4278190080 4278190080 452984832 0 452984832 4278190080 1610612736 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 67108864 16777216 0 0 1778384896 4278190080 16777216 33554432 16777216 0 0 0 0 67108864 33554432 0 0 0 0 0 33554432 16777216 0 0 0 0 33554432 0 0 0 16777216 67108864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1962934272 4278190080 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 117440512 352321536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!OBIconicButton class methodsFor: 'installing' stamp: 'cb 3/11/2008 19:18'!
installBrowserButton
| browserButton |

	browserButton := OBIconicButton newWithLabel: ''.
    browserButton actWhen: #whilePressed.
    browserButton targets: {OBPackageBrowser. OBSystemBrowser. Browser}.
    browserButton openLabel: 'browser'.
    browserButton left: 120; bottom: 32.
    browserButton labelGraphic: self browserIcon.
    browserButton recolor: Color transparent.
    browserButton borderWidth: 0.
    browserButton cornerStyle: #rounded.
    World addMorph: browserButton.

 ! !

!OBIconicButton class methodsFor: 'installing' stamp: 'cb 3/11/2008 19:04'!
installButtons
    "self installButtons"
	self removeButtons.
	self 
		installSmartButton; 
		installBrowserButton; 
		installWorkspaceButton; 
		installDebuggerButton; 
		installInspectorButton.
	
 ! !

!OBIconicButton class methodsFor: 'installing' stamp: 'cb 3/11/2008 19:13'!
installDebuggerButton


    | debuggerButton |
    debuggerButton := OBIconicButton newWithLabel: ''.
    debuggerButton actWhen: #whilePressed.
    debuggerButton windowClass: PreDebugWindow.
    debuggerButton left: 280; bottom: 32.
    debuggerButton labelGraphic: self debuggerIcon.
    debuggerButton recolor: Color transparent.
    debuggerButton borderWidth: 0.
    debuggerButton cornerStyle: #rounded.
    World addMorph: debuggerButton.


	
 ! !

!OBIconicButton class methodsFor: 'installing' stamp: 'cb 3/11/2008 19:13'!
installInspectorButton
	
    | inspectorButton |
    inspectorButton := OBIconicButton newWithLabel: ''.
    inspectorButton actWhen: #whilePressed.
    inspectorButton target: Inspector.
    inspectorButton left: 360; bottom: 32.
    inspectorButton labelGraphic: self inspectorIcon.
    inspectorButton recolor: Color transparent.
    inspectorButton borderWidth: 0.
    inspectorButton cornerStyle: #rounded.
    World addMorph: inspectorButton.! !

!OBIconicButton class methodsFor: 'installing' stamp: 'cb 3/11/2008 19:19'!
installSmartButton
| browserButton |

    browserButton := OBIconicButton newWithLabel: ''.
    browserButton actWhen: #whilePressed.
    browserButton targets: {OBSmartGroupBrowser.}.
    browserButton openLabel: 'smart browser'.
    browserButton left: 30; bottom: 32.
    browserButton labelGraphic: self browserIcon.
    browserButton recolor: Color transparent.
    browserButton borderWidth: 0.
    browserButton cornerStyle: #rounded.
    World addMorph: browserButton.
! !

!OBIconicButton class methodsFor: 'installing' stamp: 'cb 3/11/2008 19:12'!
installWorkspaceButton

	
    | workspaceButton |
    workspaceButton := OBIconicButton newWithLabel: ''.
    workspaceButton actWhen: #whilePressed.
    workspaceButton target: Workspace.
    workspaceButton openLabel: 'workspace'.
    workspaceButton left: 200; bottom: 32.
    workspaceButton labelGraphic: self workspaceIcon.
    workspaceButton recolor: Color transparent.
    workspaceButton borderWidth: 0.
    workspaceButton cornerStyle: #rounded.
    World addMorph:     workspaceButton.
! !

!OBIconicButton class methodsFor: 'installing' stamp: 'dr 12/18/2007 15:08'!
removeButtons
    "self removeButtons"
    World submorphs copy do: [:ea | (ea isKindOf: self) ifTrue: [ea delete]].! !

!OBIconicButton class methodsFor: 'buttons' stamp: 'dr 12/18/2007 11:37'!
workspaceIcon
    ^(Form
	extent: 67@44
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290622893 4286874756 4286874756 4286874756 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4287401100 4286874756 4289570204 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290624957 4292796126 4291743438 4292796126 4291217094 4287927444 4285756275 4286874756 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4291743438 4291743438 4288453780 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287927436 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288451732 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287399044 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290096549 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4289572261 4287925371 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4293381805 4286870371 4291212692 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285754202 4278190088 4292263333 0 4291212692 4278190088 4284109378 0 0 4278190088 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 4291212692 4278190088 4286872419 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290094476 4278190088 4287923315 0 4286872419 4278190088 4279769104 0 4292263333 4278190088 4281938217 0 0 0 0 0 0 0 4293910197 4290620820 4293381805 0 4293381805 4291212692 4278190088 4286872419 0 4293381805 4290620820 4292263333 0 0 0 4291212692 0 0 4293910197 4290620820 4293381805 0 0 0 0 0 0 4290620820 4293910197 0 0 0 0 0 0 4293381805 4293381805 0 0 0 0 0 0 0 0 0 0 0 0 4293910197 4278190088 4284109378 0 4281938217 4284109378 4278190088 4292263333 4287923315 4278190088 4285754202 4293910197 4284701258 4278190088 4278190088 4278190088 4287923315 0 4291212692 4278190088 4281938217 4279242768 4278716424 4291212692 4278190088 4286872419 4292263333 4279242768 4279242768 4292263333 4290094476 4278190088 4278190088 4278190088 4278190088 4291212692 4291212692 4278190088 4281938217 4279242768 4278190088 4281938217 0 4291212692 4278190088 4278190088 4278190088 4279242768 4290094476 0 4293910197 4284701258 4278190088 4278190088 4278190088 4291212692 4293910197 4284701258 4278190088 4278190088 4279242768 4290094476 0 0 0 0 0 0 4281938217 4280887585 4293910197 4278190088 4291212692 4279242768 4289041531 4285225554 4278190088 4290094476 4285225554 4278190088 4285754202 4291212692 4281413929 4278190088 4292263333 4291212692 4278190088 4280885537 4291212692 4291212692 4291212692 4278190088 4283583042 4279242768 4279242768 4292263333 0 4286872419 4278716416 4293381805 0 4290620820 4293910197 4291212692 4278190088 4281938217 4291212692 4284701258 4278190088 4287923315 4293910197 4292263333 0 4291212692 4278190088 4283056697 0 4285225554 4278190088 4284701258 4292263333 4292263333 4293381805 4285225554 4278190088 4287923315 0 4281938217 4279769104 0 0 0 0 0 0 4285225554 4278716416 4287923315 4278716424 4293910197 4284109378 4285225554 4280361240 4278716416 4293381805 4283056697 4278190088 4291212692 0 4287923315 4278190088 4290094476 4291212692 4278190088 4286872419 0 0 4291212692 4278190088 4278190088 4278190088 4291212692 0 0 4290094476 4278190088 4278190088 4281411873 4284701258 4293910197 4291212692 4278190088 4286872419 0 4292263333 4278190088 4285754202 4291212692 4279242768 4278190088 4278190088 4278190088 4279769104 0 4283056697 4278190088 4291212692 0 0 0 4283056697 4278190088 4278190088 4278190088 4278190088 4278716416 4293381805 0 0 0 0 0 4289041531 4278190088 4280361240 4281938217 0 4287923315 4280361240 4278190088 4280887585 0 4284109378 4278190088 4290094476 0 4285225554 4278190088 4291212692 4291212692 4278190088 4286872419 0 0 4291212692 4278190088 4284109378 4279242768 4281938217 4293910197 0 0 4293381805 4290620820 4283583042 4278190088 4290094476 4291212692 4278190088 4285754202 0 4289041531 4278190088 4286872419 4283056697 4278190088 4290094476 4293910197 4279242768 4278716424 0 4284109378 4278190088 4290094476 0 0 0 4284109378 4278190088 4291212692 0 0 0 0 0 0 0 0 0 4293381805 4278190088 4278190088 4285225554 0 4292263333 4278190088 4278190088 4285225554 0 4292263333 4279242768 4279242768 4281411873 4278190088 4280887585 0 4291212692 4278190088 4286872419 0 0 4291212692 4278190088 4286872419 4292263333 4279242768 4281938217 4293910197 4286872419 4284701258 4286870371 4282530097 4278190088 4292263333 4291212692 4278190088 4278190088 4281411873 4278190088 4278716416 4293381805 4284109378 4278190088 4284701258 4283583042 4279242768 4278716424 0 4292263333 4279242768 4278190088 4282530097 4281411873 4291212692 4292263333 4279242768 4280361240 4286870371 4285752146 4279769104 0 0 0 0 0 0 0 4286870371 4286870371 4291212692 0 0 4286870371 4286870371 4291212692 0 0 4293910197 4286870371 4286870371 4287923315 0 0 4293381805 4286870371 4291212692 0 0 4293381805 4286870371 4291212692 0 4292263333 4286870371 4290094476 4291212692 4286870371 4286870371 4286870371 4289041531 0 4291212692 4278190088 4285754202 4287923315 4286870371 4292263333 0 4293910197 4289041531 4286870371 4291212692 4289041531 4286872419 0 0 4293910197 4286870371 4286870371 4286870371 4293381805 0 4293910197 4286870371 4286870371 4286870371 4290094476 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4291212692 4278190088 4286872419 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4293381805 4286870371 4291212692 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!OBIconicButton methodsFor: 'action' stamp: 'dr 3/12/2008 10:27'!
doButtonAction
    | windows values labels selection lines |
    windows := windowClass ifNotNil: [
	   World submorphs select: [:ea | ea isKindOf: windowClass] 
    ] ifNil: [World submorphs select: [:ea | (ea isKindOf: SystemWindow) and: [targets anySatisfy: [:tg | ea model isKindOf: tg]]]].
    values := OrderedCollection withAll: windows.
    labels := OrderedCollection withAll: (windows collect: [:ea | ea label]). 
    lines := #(1).
    
    labels ifNotEmpty: [values addFirst: [windows do: [:win | win delete]].
                           labels addFirst: 'close all'].

    openLabel ifNotNil: [
	   values addFirst: [targets first open]. 
	   labels addFirst: 'new ', openLabel.
	   lines := #(2).
    ].

    labels ifEmpty: [self inform: 'Nothing opened']
            ifNotEmpty: [selection := OBChoiceRequest prompt: nil labels: labels values: values lines: lines].
    selection ifNotNil: [
        selection isBlock ifTrue: [selection value] ifFalse: [selection activate].
    ].
    oldColor ifNotNil: [self color: oldColor]! !

!OBIconicButton methodsFor: 'accessing' stamp: 'dr 12/18/2007 11:09'!
openLabel: aString
    openLabel := aString! !

!OBIconicButton methodsFor: 'accessing' stamp: 'dr 12/18/2007 15:13'!
target: aMorph
    ^self targets add: aMorph! !

!OBIconicButton methodsFor: 'accessing' stamp: 'dr 12/18/2007 15:13'!
targets
    targets ifNil: [targets := OrderedCollection new].
    ^targets! !

!OBIconicButton methodsFor: 'accessing' stamp: 'dr 12/18/2007 15:13'!
targets: aCollection
    targets := aCollection! !

!OBIconicButton methodsFor: 'accessing' stamp: 'dr 1/8/2008 10:44'!
windowClass
    ^windowClass! !

!OBIconicButton methodsFor: 'accessing' stamp: 'dr 12/18/2007 11:09'!
windowClass: aClass
    windowClass := aClass! !

!OBCmdBrowseList methodsFor: '*ob-enhancements' stamp: 'dr 11/16/2007 11:21'!
implementorsSelector
    ^#implementorsOf:! !

OBCmdBrowseList subclass: #OBCmdDynamicImplementors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdDynamicImplementors methodsFor: 'configuration' stamp: 'dr 10/1/2007 16:08'!
announcementClass
	^ OBShowDynamicImplementors! !

!OBCmdDynamicImplementors methodsFor: 'configuration' stamp: 'dr 9/13/2007 11:01'!
browserClass
    ^OBDynamicImplementorsBrowser! !

!OBCmdDynamicImplementors methodsFor: 'command' stamp: 'dr 10/8/2007 16:44'!
execute
    | method selectors selection messages messageNode implementors |
    method := target reference compiledMethod.
    (method isNil or: [(messages := method reflectiveMethod messages) size == 0])
		 ifTrue: [self inform: 'No messages sent in this method'. ^self].
		
    selectors := OrderedCollection new.
    selectors addAll: messages asSortedCollection.

    selection := OBChoiceRequest labels: selectors.
    selection ifNotNil: [implementors := target perform: self implementorsSelector with: selection.
		                implementors ifNotEmpty: [messageNode := OBMessageNode on: selection inMethod: target selector inClass: target theClass].
         messageNode ifNil: [self inform: 'No ', self label, ' found!!']
                         ifNotNil: [(requestor announce: (self announcementClass of: messageNode)) execute].	
    ].! !

!OBCmdDynamicImplementors methodsFor: 'command' stamp: 'dr 10/16/2007 10:15'!
group
	^ #dynamic! !

!OBCmdDynamicImplementors methodsFor: 'command' stamp: 'dr 2/28/2008 12:01'!
isActive
     requestor browser class dynamicBrowser ifFalse: [^false].
	^(target isKindOf: OBMethodNode) and: [(requestor isSelected: target) and: [(Smalltalk classNamed: #HODataBase) notNil]]! !

!OBCmdDynamicImplementors methodsFor: 'command' stamp: 'dr 9/13/2007 11:01'!
label
    ^'dynamic implementors'! !

OBCmdBrowseList subclass: #OBCmdDynamicSenders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdDynamicSenders methodsFor: 'configuration' stamp: 'dr 10/5/2007 16:43'!
announcementClass
	^ OBShowDynamicSenders! !

!OBCmdDynamicSenders methodsFor: 'configuration' stamp: 'dr 10/5/2007 16:45'!
browserClass
    ^OBDynamicSendersBrowser! !

!OBCmdDynamicSenders methodsFor: 'command' stamp: 'dr 10/16/2007 10:15'!
group
	^ #dynamic! !

!OBCmdDynamicSenders methodsFor: 'configuration' stamp: 'dr 2/28/2008 12:01'!
isActive
     requestor browser class dynamicBrowser ifFalse: [^false].
	^(target isKindOf: OBMethodNode) and: [(requestor isSelected: target) and: [(Smalltalk classNamed: #HODataBase) notNil]]! !

!OBCmdDynamicSenders methodsFor: 'configuration' stamp: 'dr 10/5/2007 16:45'!
label
    ^'dynamic senders'! !

OBImplementorsBrowser subclass: #OBDynamicImplementorsBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Dynamic'!

!OBDynamicImplementorsBrowser class methodsFor: 'configuration' stamp: 'dr 10/5/2007 17:17'!
chasingBrowsers
    ^false! !

!OBDynamicImplementorsBrowser class methodsFor: 'configuration' stamp: 'dr 9/13/2007 11:20'!
defaultMetaNode
	^self implementorsNav: #dynamicImplementors! !

!OBDynamicImplementorsBrowser class methodsFor: 'configuration' stamp: 'dr 9/13/2007 11:20'!
title
	^'Dynamic Implementors of'! !

!OBImplementorsBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 11/16/2007 11:52'!
definitionPanel
     ^OBEnrichedDefinitionPanel new! !

!OBImplementorsBrowser class methodsFor: '*ob-enhancements' stamp: 'dr 2/23/2008 16:36'!
hasReferencePanel
    ^self dynamicBrowser! !

OBCommand subclass: #OBCmdAddSmartCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdAddSmartCategory methodsFor: 'command' stamp: 'dr 4/16/2007 15:52'!
execute
	| name |
	name := OBTextRequest 
					prompt: 'Please type new category name' 
					template: ''.
	name ifNil: [^self].

    requestor panel smartGroup addNode: (OBSmartGroupNode name: name).
    requestor panel columns first refresh.! !

!OBCmdAddSmartCategory methodsFor: 'command' stamp: 'dr 4/10/2007 11:18'!
group
	^ #general! !

!OBCmdAddSmartCategory methodsFor: 'command' stamp: 'dr 3/14/2008 17:15'!
isActive
     target isEnvironment ifFalse: [^false].
	^(target isSmartGroup and: [requestor isSelected: target]) or: [requestor switch selection = 2]! !

!OBCmdAddSmartCategory methodsFor: 'command' stamp: 'dr 3/1/2008 17:06'!
label
    ^'new smart group...'! !

OBCommand subclass: #OBCmdAddToSmartGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdAddToSmartGroup methodsFor: 'command' stamp: 'dr 3/18/2008 17:09'!
execute
    | selection smartGroups |

    smartGroups := requestor panel smartGroup nodes select: [:ea | ea isSmartGroupCategory and: [ea isSearchGroup not]].

    selection := OBChoiceRequest prompt: nil labels: (smartGroups collect: [:ea | ea name]) values: smartGroups.
    selection ifNotNil: [selection addAlias: target].

    requestor panel columns first refresh.
    self select: target with: requestor announcer! !

!OBCmdAddToSmartGroup methodsFor: 'command' stamp: 'dr 4/5/2007 13:27'!
group
	^ #navigation! !

!OBCmdAddToSmartGroup methodsFor: 'command' stamp: 'dr 5/29/2007 17:22'!
isActive
	^(requestor browser isKindOf: OBSmartGroupBrowser) and: [target isSmartGroup not
		and: [requestor isSelected: target]]! !

!OBCmdAddToSmartGroup methodsFor: 'command' stamp: 'dr 4/5/2007 13:27'!
label
    ^'add to smart group'! !

OBCommand subclass: #OBCmdAddWorkingCopy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdAddWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 7/17/2007 10:17'!
execute
	| name package workingCopy |
	name := FillInTheBlankMorph request: 'Name of package:'. 
	name isEmptyOrNil ifTrue: [^self].
	PackageInfo named: name. 
	package := (MCPackage new name: name).
	workingCopy := MCWorkingCopy forPackage: package.
	self select: (OBMonticelloPackageNode on: workingCopy) with: requestor announcer! !

!OBCmdAddWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 5/3/2007 16:15'!
group
	^ #general! !

!OBCmdAddWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 12/18/2007 16:37'!
icon
	^ #newIcon! !

!OBCmdAddWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 3/12/2008 15:16'!
isActive
	^ target isEnvironment and: [requestor switch selection < 2]! !

!OBCmdAddWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 5/3/2007 16:15'!
label
    ^'add package'! !

OBCommand subclass: #OBCmdBrowseDynamicReferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdBrowseDynamicReferences methodsFor: 'execution' stamp: 'dr 10/9/2007 17:04'!
execute
	OBDynamicReferenceBrowser browseRoot: target theNonMetaClass asNode ! !

!OBCmdBrowseDynamicReferences methodsFor: 'accessing' stamp: 'dr 10/16/2007 10:16'!
group
	^ #dynamic! !

!OBCmdBrowseDynamicReferences methodsFor: 'testing' stamp: 'dr 2/23/2008 16:11'!
isActive
	^(((target isKindOf: OBClassAwareNode)
		and: [requestor isSelected: target]) and: [(Smalltalk classNamed: #HODataBase) notNil]) 
		and: [(Smalltalk at: #HODataBase) default includesClass: target theClass]! !

!OBCmdBrowseDynamicReferences methodsFor: 'testing' stamp: 'dr 10/15/2007 11:02'!
isReferenceListCmd
    ^true! !

!OBCmdBrowseDynamicReferences methodsFor: 'accessing' stamp: 'dr 11/12/2007 10:49'!
label
	^ 'browse dynamic references'! !

OBCommand subclass: #OBCmdBrowseWorkingCopy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdBrowseWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:33'!
execute
	(MCSnapshotBrowser forSnapshot: target mcPackage package snapshot)
			label: 'Snapshot Browser: ', target mcPackage packageName;
			show! !

!OBCmdBrowseWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:34'!
group
    ^#general! !

!OBCmdBrowseWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 7/16/2007 10:33'!
isActive
	^ (target isKindOf: OBMonticelloPackageNode) 
		and: [requestor isSelected: target]! !

!OBCmdBrowseWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:34'!
label
    ^'browse package'! !

OBCommand subclass: #OBCmdCreateMonticelloCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdCreateMonticelloCategory methodsFor: 'execution' stamp: 'dr 12/18/2007 17:59'!
execute
	| organization catName |
	organization _ target organization.
	catName _ OBTextRequest 
					prompt: 'Please type new category name' 
					template: self template.
	
	(catName beginsWith: self template) ifFalse: [^self inform: 'Class category should start with package name.']. 				
					
	catName ifNotNil:	[organization addCategory: catName.
						self select: (OBMonticelloClassCategoryNode on: catName package: target mcPackage) with: requestor announcer].! !

!OBCmdCreateMonticelloCategory methodsFor: 'accessing' stamp: 'dr 12/18/2007 16:37'!
icon
	^ #newIcon! !

!OBCmdCreateMonticelloCategory methodsFor: 'testing' stamp: 'dr 12/18/2007 17:12'!
isActive
    ^(requestor isSelected: target) and: [target isKindOf: OBMonticelloPackageNode]! !

!OBCmdCreateMonticelloCategory methodsFor: 'accessing' stamp: 'dr 12/18/2007 17:03'!
label
   ^'create category'! !

!OBCmdCreateMonticelloCategory methodsFor: 'accessing' stamp: 'dr 12/18/2007 17:15'!
template
    ^target mcPackage packageName, '-'! !

OBCommand subclass: #OBCmdDisplayReferencingPlaces
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdDisplayReferencingPlaces methodsFor: 'command' stamp: 'dr 2/23/2008 16:11'!
execute
    | nodesToSelect |
    requestor currentNode isMethodHolderNode ifTrue: [
        nodesToSelect _ (Smalltalk at: #HODataBase) default nodesReferencingClass: target theClass inMethod: requestor currentNode reference.
        requestor selectReferencingCodeNodes: nodesToSelect.
    ] ifFalse: [
        nodesToSelect _ (Smalltalk at: #HODataBase) default methodsReferencingClass: target theClass inClass: requestor currentNode theClass.
        requestor selectReferencingMethods: nodesToSelect.
    ].
    ! !

!OBCmdDisplayReferencingPlaces methodsFor: 'command' stamp: 'dr 10/15/2007 11:09'!
group
	^ #navigation! !

!OBCmdDisplayReferencingPlaces methodsFor: 'command' stamp: 'dr 10/16/2007 10:33'!
isActive
    ^requestor isKindOf: OBReferenceList! !

!OBCmdDisplayReferencingPlaces methodsFor: 'command' stamp: 'dr 10/15/2007 10:59'!
isReferenceListCmd
    ^true! !

!OBCmdDisplayReferencingPlaces methodsFor: 'command' stamp: 'dr 10/16/2007 10:31'!
label
     ^requestor currentNode isMethodHolderNode ifTrue: ['select referencing variables']
                                                        ifFalse: ['select referencing methods']
! !

OBCommand subclass: #OBCmdJumpToReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdJumpToReference methodsFor: 'command' stamp: 'dr 2/16/2008 16:15'!
execute
    requestor jumpTo: target! !

!OBCmdJumpToReference methodsFor: 'command' stamp: 'dr 10/15/2007 11:04'!
group
	^ #navigation! !

!OBCmdJumpToReference methodsFor: 'command' stamp: 'dr 2/16/2008 16:14'!
isActive
	^target isKindOf: OBClassReferenceNode! !

!OBCmdJumpToReference methodsFor: 'command' stamp: 'dr 10/15/2007 10:59'!
isReferenceListCmd
    ^true! !

!OBCmdJumpToReference methodsFor: 'command' stamp: 'dr 2/16/2008 16:16'!
label
    ^'browse'! !

OBCommand subclass: #OBCmdObserveDynamically
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdObserveDynamically methodsFor: 'command' stamp: 'dr 2/7/2008 14:31'!
execute
    requestor selectedNode instrument.   
    requestor refreshAll.! !

!OBCmdObserveDynamically methodsFor: 'command' stamp: 'dr 10/16/2007 10:27'!
group
    ^#dynamic! !

!OBCmdObserveDynamically methodsFor: 'command' stamp: 'dr 2/22/2008 15:09'!
isActive
     requestor browser class dynamicBrowser ifFalse: [^false].
	^(((((target isKindOf: OBClassAwareNode) and: [requestor isSelected: target])) or: [target isEnvironment])
          and: [(Smalltalk classNamed: #HODataBase) notNil]) 
		and: [requestor selectedNode isInstrumented not]! !

!OBCmdObserveDynamically methodsFor: 'command' stamp: 'dr 10/16/2007 10:28'!
label
	^ 'observe dynamically'! !

OBCommand subclass: #OBCmdPublishPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdPublishPackage methodsFor: 'as yet unclassified' stamp: 'dr 12/14/2007 11:55'!
execute
	| repository |
	target hasRepository ifFalse: [^self].
	repository := target askForRepository.
	repository ifNil: [^self].
	(target checkForNewerVersionsAndAskIn: repository) ifFalse: [^self].
	
	target mcPackage newVersion ifNotNilDo:
		[:v |
		(MCVersionInspector new version: v) show.
		Cursor wait showWhile: [repository storeVersion: v].
		v allAvailableDependenciesDo:
			[:dep |
			(repository includesVersionNamed: dep info name)
				ifFalse: [repository storeVersion: dep]]].
	requestor announce: (OBChildrenChanged node: requestor parent).	! !

!OBCmdPublishPackage methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:11'!
group
    ^#general! !

!OBCmdPublishPackage methodsFor: 'as yet unclassified' stamp: 'dr 7/16/2007 10:33'!
isActive
	^ (target isKindOf: OBMonticelloPackageNode) 
		and: [requestor isSelected: target]! !

!OBCmdPublishPackage methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:10'!
label
    ^'publish'! !

OBCommand subclass: #OBCmdRemoveFromSmartGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 3/14/2008 16:20'!
execute 
    target remove.
    requestor panel columns first refresh.
    self select: target with: requestor announcer! !

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 4/5/2007 15:43'!
group
	^ #navigation! !

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 3/14/2008 16:22'!
isActive
     (target isSmartGroupCategory and: [target name = 'default' or: [target name = OBSmartRootNode searchGroupName]]) ifTrue: [^false].
	^target isSmartGroup
		and: [requestor isSelected: target]! !

!OBCmdRemoveFromSmartGroup methodsFor: 'command' stamp: 'dr 4/5/2007 15:43'!
label
    ^'remove'! !

OBCommand subclass: #OBCmdRemoveWorkingCopy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdRemoveWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 7/16/2007 15:23'!
execute
	(PopUpMenu confirm: 'Really remove package?')
		ifTrue: [target mcPackage unregister. requestor announce: (OBNodeDeleted node: target)]! !

!OBCmdRemoveWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:48'!
group
	^ #general! !

!OBCmdRemoveWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 7/16/2007 10:33'!
isActive
	^ (target isKindOf: OBMonticelloPackageNode) 
		and: [requestor isSelected: target]! !

!OBCmdRemoveWorkingCopy methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:49'!
label
    ^'remove package'! !

OBCommand subclass: #OBCmdStopObservingDynamically
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdStopObservingDynamically methodsFor: 'command' stamp: 'dr 2/7/2008 14:31'!
execute
    requestor selectedNode uninstrument.
    requestor refreshAll.! !

!OBCmdStopObservingDynamically methodsFor: 'command' stamp: 'dr 10/16/2007 10:56'!
group
    ^#dynamic! !

!OBCmdStopObservingDynamically methodsFor: 'command' stamp: 'dr 2/7/2008 14:38'!
isActive
	^(((((target isKindOf: OBClassAwareNode) and: [requestor isSelected: target])) or: [target isEnvironment])
		and: [(Smalltalk classNamed: #HODataBase) notNil]) 
		and: [requestor selectedNode isInstrumented]! !

!OBCmdStopObservingDynamically methodsFor: 'command' stamp: 'dr 10/16/2007 10:56'!
label
	^ 'stop observing dynamically'! !

OBCommand subclass: #OBCmdUpdatePackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdUpdatePackage methodsFor: 'as yet unclassified' stamp: 'dr 12/14/2007 15:22'!
execute
	| repository versions fileName |
	target hasRepository ifFalse: [^self].
	repository := target askForRepository.
	repository ifNil: [^self]. 
	(target checkForNewerVersionsIn: repository) ifFalse: [self inform: 'There are no newer versions available in this repository.'. ^self].
	
	versions := (repository versionsAvailableForPackage: target mcPackage) select: [:version | version last isDigit].
	versions := versions asSortedCollection: [:a :b | | versionNr1 versionNr2 | 
	    	versionNr1 := (a copyAfterLast: $.) asInteger.
		versionNr2 := (b copyAfterLast: $.) asInteger.
		versionNr1 >= versionNr2
	].

     (self confirm: 'Do you want to load version ', versions first, '?') ifTrue: [
	    fileName := (repository allFileNamesForVersionNamed: versions first) first.
	    Cursor wait showWhile: [(repository versionFromFileNamed: fileName) load]
	].
	
	requestor announce: (OBChildrenChanged node: requestor parent).	! !

!OBCmdUpdatePackage methodsFor: 'as yet unclassified' stamp: 'dr 12/14/2007 12:00'!
group
    ^#general! !

!OBCmdUpdatePackage methodsFor: 'as yet unclassified' stamp: 'dr 12/14/2007 12:00'!
isActive
	^ (target isKindOf: OBMonticelloPackageNode) 
		and: [requestor isSelected: target]! !

!OBCmdUpdatePackage methodsFor: 'as yet unclassified' stamp: 'dr 12/14/2007 12:00'!
label
    ^'update'! !

OBCommand subclass: #OBCmdViewChanges
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdViewChanges methodsFor: 'as yet unclassified' stamp: 'dc 1/7/2008 14:18'!
execute
	| patch repository |
	target hasRepository ifFalse: [^self].
	repository := target askForRepository.
	repository ifNil: [^ self].
	patch := target mcPackage changesRelativeToRepository: repository.
	patch isNil ifTrue: [^ self].
	patch isEmpty
		ifTrue: [target mcPackage modified: false.
				self inform: 'No changes' ]
		ifFalse:
				[target mcPackage modified: true.
				(MCPatchBrowser forPatch: patch)
					label: 'Patch Browser: ', target mcPackage description;
					show]! !

!OBCmdViewChanges methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:36'!
group
    ^#general! !

!OBCmdViewChanges methodsFor: 'as yet unclassified' stamp: 'dr 7/16/2007 10:33'!
isActive
	^ (target isKindOf: OBMonticelloPackageNode) 
		and: [requestor isSelected: target]! !

!OBCmdViewChanges methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:36'!
label
    ^'changes'! !

OBCommand subclass: #OBCmdViewHistory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Commands'!

!OBCmdViewHistory methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:37'!
execute
	target mcPackage ifNil: [^self].
	(MCWorkingHistoryBrowser new
				ancestry: target mcPackage ancestry;
				package: target mcPackage package)
			label:  'Version History: ', target mcPackage packageName;
			show! !

!OBCmdViewHistory methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:37'!
group
    ^#general! !

!OBCmdViewHistory methodsFor: 'as yet unclassified' stamp: 'dr 7/16/2007 10:33'!
isActive
	^ (target isKindOf: OBMonticelloPackageNode) 
		and: [requestor isSelected: target]! !

!OBCmdViewHistory methodsFor: 'as yet unclassified' stamp: 'dr 4/24/2007 18:37'!
label
    ^'history'! !

!OBCommand methodsFor: '*ob-enhancements' stamp: 'dr 10/15/2007 10:58'!
isReferenceListCmd
    ^false
! !

!OBCommand methodsFor: '*ob-enhancements' stamp: 'dr 6/28/2007 16:24'!
wantsTabButton
    ^false! !

PluggableButtonMorph subclass: #OBDraggableButtonMorph
	instanceVariableNames: 'dropOn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Morphs'!

!OBDraggableButtonMorph commentStamp: 'dr 6/12/2007 15:21' prior: 0!
I represent a button morph which is draggable. Other draggable button morphs can be dropped on me.!

OBDraggableButtonMorph subclass: #OBBackButtonMorph
	instanceVariableNames: 'panel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-Morphs'!

!OBBackButtonMorph methodsFor: 'mouse events' stamp: 'dr 2/8/2008 16:46'!
handlesMouseStillDown: evt
    ^true! !

!OBBackButtonMorph methodsFor: 'mouse events' stamp: 'dr 3/4/2008 15:10'!
mouseStillDown: evt
     panel navigateHistoryInDirection: actionSelector.
     super mouseStillDown: evt.
     showSelectionFeedback := false.
     self changed.! !

!OBBackButtonMorph methodsFor: 'mouse events' stamp: 'dr 2/8/2008 16:48'!
mouseStillDownThreshold
    ^1000! !

!OBBackButtonMorph methodsFor: 'accessing' stamp: 'dr 2/8/2008 16:07'!
panel: aPanel
    panel _ aPanel! !

!OBDraggableButtonMorph methodsFor: 'events-processing' stamp: 'dr 6/11/2007 15:44'!
acceptDroppingMorph: aMorph event: evt 
     model dropMorph: aMorph.
	
	self resetDropOn.
	evt hand releaseMouseFocus: self.
	Cursor normal show. 
! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/8/2007 15:25'!
click: evt
    super mouseDown: evt! !

!OBDraggableButtonMorph methodsFor: 'drawing' stamp: 'dr 6/11/2007 11:27'!
drawOn: aCanvas
	super drawOn: aCanvas. 
	
    dropOn ifNotNil: ["self halt."self highlightOn: aCanvas].! !

!OBDraggableButtonMorph methodsFor: 'drawing' stamp: 'dr 6/11/2007 11:39'!
highlightOn: aCanvas
	| topLeft drawBounds |
	topLeft := self topLeft x @ (self topLeft y + 1).
	drawBounds := topLeft extent: self width @ (self height + 1).
	drawBounds := drawBounds intersect: self bounds.
	aCanvas frameRectangle: self innerBounds width: 1 color: Color blue! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 2/8/2008 14:27'!
mouseDown: evt
	| selectors |
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].

	selectors _ Array 
		with: #click:
		with: nil
		with: nil
		with: #startDrag:.
	evt hand waitForClicksOrDrag: self event: evt selectors: selectors threshold: 10.! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/11/2007 11:34'!
mouseEnterDragging: evt
	(self dropEnabled and: [evt hand hasSubmorphs]) ifFalse: [^super mouseEnterDragging: evt].
	
	(self wantsDroppedMorph: evt hand firstSubmorph event: evt)
		ifTrue: [
			dropOn := true.
			
			evt hand newMouseFocus: self.
			"test ifNil: [test := (evt hand firstSubmorph passenger == model). ""evt hand firstSubmorph passenger insertAfter: model."
				
			self changed.
		].! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 9/10/2007 16:55'!
mouseLeaveDragging: evt
	(self dropEnabled and: [evt hand hasSubmorphs]) ifFalse: [^super mouseLeaveDragging: evt].
	self resetDropOn.
	evt hand releaseMouseFocus: self.! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/8/2007 16:21'!
mouseMove: evt
		
	"self = (self rowAtLocation: evt position) ifTrue: [^self]." 
	(self dropEnabled and: [evt hand hasSubmorphs]) ifFalse: [^super mouseMove: evt].
		
	self mouseLeaveDragging: evt.
	(self containsPoint: evt position) ifTrue: [self mouseEnterDragging: evt].! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/11/2007 11:18'!
resetDropOn
    dropOn ifNotNil: [dropOn := nil. self changed].! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/8/2007 15:54'!
startDrag: evt 
	| ddm |
	evt hand hasSubmorphs ifTrue: [^self].

	[  (self dragEnabled and: [model okToChange]) ifFalse: [^self].
	   ddm := TransferMorph withPassenger: model from: self.
        evt hand grabMorph: ddm]
	ensure: [Cursor normal show. evt hand releaseMouseFocus: self]! !

!OBDraggableButtonMorph methodsFor: 'drag and drop' stamp: 'dr 6/11/2007 11:33'!
wantsDroppedMorph: transferMorph event: evt
	(transferMorph isKindOf: TransferMorph) ifFalse: [^false].
	(transferMorph passenger isKindOf: model class) ifFalse: [^false]. 
	transferMorph passenger == model ifTrue: [^false].
	
     ^true! !

OBSystemBrowserAdaptor subclass: #OBMultipleSelectionBrowserAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-MultipleSelection'!

!OBMultipleSelectionBrowserAdaptor class methodsFor: 'configuration' stamp: 'dr 7/19/2007 16:36'!
browserClass
    ^OBMultipleSelectionBrowser! !

!OBMultipleSelectionBrowserAdaptor class methodsFor: 'initializing' stamp: 'dr 2/23/2008 17:08'!
initialize
     "deactivate registering me as default system browser"
	"self register"! !

OBSystemBrowserAdaptor subclass: #OBPackageBrowserAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Enhancements-PackageBrower'!

!OBPackageBrowserAdaptor class methodsFor: 'configuration' stamp: 'dr 2/15/2008 14:34'!
browserClass
    ^OBPackageBrowser! !

!OBPackageBrowserAdaptor class methodsFor: 'initializing' stamp: 'dr 12/14/2007 11:39'!
initialize
	self register! !

!OBPackageBrowserAdaptor methodsFor: 'registry protocol' stamp: 'dr 12/14/2007 09:56'!
labelString
    ^'Package Browser'! !

!OBPackageBrowserAdaptor methodsFor: 'actions' stamp: 'dr 2/15/2008 14:34'!
spawnHierarchy
	^ OBDynamicHierarchyBrowser openOnClass: self targetClass ! !
OBSmartRootNode initialize!
OBMultipleSelectionBrowser initialize!
OBPackageBrowser initialize!
OBIconicButton initialize!
OBMultipleSelectionBrowserAdaptor initialize!
OBPackageBrowserAdaptor initialize!
